/**
 * AZARDI READER AND AZARDI INTERACTIVE ENGINE EXTENSIONS
 * Copyright 2007-2012 Infogrid Pacific Pte. Ltd. All rights reserved
 * Modified Date: 2012-04-25
 * 
 * @version: 1-2012-04-25
 */

/*
aie_dad.js - AIE module provides the Text and sound features
*/

var AIE = AIE || {};

AIE.DragAndDrop = {
	shuffleList:function(){
		if($('.association').length > 0)
		{
			$('.association >.option-source').shuffle();
		}
	},
	shuffleElement :function(element){
		$(element).shuffle();
	},
	setUpAssociation:function(){
		if ($('.association').length > 0) {
			var Correct = $('.association >.feedback-messages').children()[0];
			var Wrong = $('.association >.feedback-messages').children()[1];
			var reinforceMent = $('.association >.feedback-messages').find('.reinforcement')
			var Wrein = $(Wrong).attr('class').split(' ')[1];
			var correctText = $(Correct).attr('class').split(' ')[1]	
			
			AIE.DragAndDrop.shuffleElement($('.association >.option-source'));
			$('.association >.shuffle >li').draggable({
				revert:'invalid'				
			});	
			$('.association >.option-target >li').droppable({
				drop:function(event,ui){
					var sClass ='.' + $(ui.draggable).attr('class').split(' ')[0];
					var tClass = $(this).attr('class').split(' ')[0];
					$(ui.draggable).offset($(this).offset())
					if($(this).hasClass(correctText))
					{
						//do nothing
							
					}else {
						$(this).addClass('selected-aie');
						$(this).addClass(sClass);
					}
				}
			});	
		}
	},
	setUpCheck:function(){
		if ($('.association').length > 0)  {
			$('.association >.buttons >.check').live('click', function(){
				$($('.association >.option-target').children()).each(function(){
					try {
						var sClass = $(this).attr('class').replace(/\D/g,'');
						var sClassIndex = sClass[0]
						var tClassIndex =  sClass[1]
					} catch (e) {
						
					}
					if( sClassIndex === tClassIndex )
					{
						AIE.Qaa.hiliteText($(this),true);
					}else {
						AIE.Qaa.hiliteText($(this),false);
					}
				});
					AIE.Qaa.qaaSetResults($('.association >ol').children(),$('.association >.question-control') ,$('.association >.question-control'));
				
			})
		}else if ($('.sequence').length > 0)  {
			$('.sequence >.buttons >.check').live('click', function(){
				$($('.sequence >.option-target').children()).each(function(){
					try {
						var sClass = $(this).attr('class').replace(/\D/g,'');
						var sClassIndex = sClass[0]
						var tClassIndex =  sClass[1]
	//					alert(sClassIndex +"---"+tClassIndex)
					} catch (e) {
						
					}
					if( sClassIndex === tClassIndex )
					{
						AIE.Qaa.hiliteText($(this),true);
					}else {
						AIE.Qaa.hiliteText($(this),false);
					}
				})
			})
		}
	},
	setUpTry:function(){
			if ($('.association').length > 0) {
				var Correct = $('.association >.feedback-messages').children()[0];
				var Wrong = $('.association >.feedback-messages').children()[1];
				var reinforceMent = $('.association >.feedback-messages').find('.reinforcement')
				var Wrein = $(Wrong).attr('class').split(' ')[1];
				var correctText = $(Correct).attr('class').split(' ')[1]	
			$('.association >.buttons >.try-again').live('click', function(){
					AIE.Qaa.hideResults();
				$($('.association >.option-target').children()).each(function(){
				if($(this).hasClass(Wrein))
				{
					try {
						var sClass = $(this).attr('class').split(' ')[2];
						var sClassIndex = sClass.replace(/\D/g,'');
						var dummyclass ='.s'+ sClassIndex;
						$(this).removeClass(Wrein);
						$(this).removeClass(correctText);
						$(this).removeClass(dummyclass);
						var dummyclass = '.association >.option-source >'+dummyclass
						$(dummyclass).css({top:'0px',left:'0px'});
					} catch (e) {
						
					}


				}
				});
			});
		}else if ($('.sequence').length > 0) {
				var Correct = $('.sequence >.feedback-messages').children()[0];
				var Wrong = $('.sequence >.feedback-messages').children()[1];
				var reinforceMent = $('.sequence >.feedback-messages').find('.reinforcement')
				var Wrein = $(Wrong).attr('class').split(' ')[1];
				var correctText = $(Correct).attr('class').split(' ')[1]	
			$('.sequence >.buttons >.try-again').live('click', function(){
					AIE.Qaa.hideResults();
				$($('.sequence >.option-target').children()).each(function(){
				if($(this).hasClass(Wrein))
				{
					try {
						var sClass = $(this).attr('class').split(' ')[2];
						var sClassIndex = sClass.replace(/\D/g,'');
						var dummyclass ='.s'+ sClassIndex;
						$(this).removeClass(Wrein);
						$(this).removeClass(correctText);
						$(this).removeClass(dummyclass);
						var dummyclass = '.sequence >.option-source >'+dummyclass
						$(dummyclass).css({top:'0px',left:'0px'});
					} catch (e) {
						
					}


				}
				});
			});
		}
		
		
	},
	setUpReset:function(){
		if ($('.association').length > 0) {
			var Correct = $('.association >.feedback-messages').children()[0];
			var Wrong = $('.association >.feedback-messages').children()[1];
			var reinforceMent = $('.association >.feedback-messages').find('.reinforcement')
			var Wrein = $(Wrong).attr('class').split(' ')[1];
			var correctText = $(Correct).attr('class').split(' ')[1]
			
			$('.association >.buttons >.reset').live('click', function(){
				AIE.Qaa.hideResults();
				$($('.association >.option-target').children()).each(function(){
				if($(this).hasClass(Wrein) || $(this).hasClass(correctText))
				{
					try {
						var sClass = $(this).attr('class').split(' ')[2];
						var sClassIndex = sClass.replace(/\D/g,'');
						var dummyclass ='.s'+ sClassIndex;
						$(this).removeClass(Wrein);
						$(this).removeClass(correctText);
						$(this).removeClass(dummyclass);
						var dummyclass = '.association >.option-source >'+dummyclass
						$(dummyclass).css({top:'0px',left:'0px'});
					} catch (e) {
						
					}
				}
				});
			});
		}else if ($('.sequence').length > 0) {
			var Correct = $('.sequence >.feedback-messages').children()[0];
			var Wrong = $('.sequence >.feedback-messages').children()[1];
			var reinforceMent = $('.sequence >.feedback-messages').find('.reinforcement')
			var Wrein = $(Wrong).attr('class').split(' ')[1];
			var correctText = $(Correct).attr('class').split(' ')[1]
			
			$('.sequence >.buttons >.reset').live('click', function(){
				AIE.Qaa.hideResults();
				$($('.sequence >.option-target').children()).each(function(){
				if($(this).hasClass(Wrein) || $(this).hasClass(correctText))
				{
					try {
						var sClass = $(this).attr('class').split(' ')[2];
						var sClassIndex = sClass.replace(/\D/g,'');
						var dummyclass ='.s'+ sClassIndex;
						$(this).removeClass(Wrein);
						$(this).removeClass(correctText);
						$(this).removeClass(dummyclass);
						var dummyclass = '.sequence >.option-source >'+dummyclass
						$(dummyclass).css({top:'0px',left:'0px'});
					} catch (e) {
						
					}
				}
				});
			});
		}
	},
	setUpSequence:function(){
		if($('.sequence').length >0 )
		{
			//shufffle Element
			AIE.DragAndDrop.shuffleElement($('.sequence >.option-source'));
			$('.sequence >.shuffle >li').draggable({
				revert:'invalid'				
			});	
			$('.sequence >.option-target >li').droppable({
				drop:function(event,ui){
					var sClass ='.' + $(ui.draggable).attr('class').split(' ')[0];
					var tClass = $(this).attr('class').split(' ')[0];
					$(ui.draggable).offset($(this).offset())
					$(this).addClass('selected-aie');
					$(this).addClass(sClass);
				}
			});	
			
		}
	}
	
};

	
/*
$(document).ready(function() {
	//Temp test.
	AIE.utils.log("DAD JSloaded for this page <br/>");
	AIE.DragAndDrop.setUpAssociation();
	AIE.DragAndDrop.setUpSequence();
	
	//Code For Check ,Try & Reset buttons goes here
	AIE.DragAndDrop.setUpCheck();
	AIE.DragAndDrop.setUpTry();
	AIE.DragAndDrop.setUpReset();
	
	});
*/