/**
 * AZARDI READER AND AZARDI INTERACTIVE ENGINE EXTENSIONS
 * Copyright 2007-2012 Infogrid Pacific Pte. Ltd. All rights reserved
 * Modified Date: 2012-04-25
 * 
 * @version: 1-2012-04-25
 */

function isiPhone(){
	try {
		return (
			//Detect iPhone
			(navigator.platform.indexOf("iPhone") != -1) ||
			//Detect iPad
			(navigator.platform.indexOf("iPad") != -1)
		);
	} catch(err){
		return false;
	}
}

//Register the event handler for audio play and pause
function initAudio(){
	$('.audio-inline-rw img').addClass('play');
	$('.audio-block-rw img').addClass('play');
    $('.audio-inline-rw').bind("click", function(e){
        var $target = $(this).find('img');
		
        var audio_obj = $(this).find('audio').get(0);
        
		$(audio_obj).bind('timeupdate',function(event){
			var curr_time = $(this).get(0).currentTime;
			var duration = $(this).get(0).duration;
			if(curr_time >= duration){
				//audio finished playing. set the class
				$(this).parent('.audio-inline-rw').find('img').removeClass("stop").addClass("play");
				$(audio_obj).unbind('timeupdate');
			} else {
				$(this).parent('.audio-inline-rw').find('img').removeClass("play").addClass("stop");
			}
		});
		
		if (audio_obj.play) {
			if ($target.hasClass('play')) {
				if(audio_obj.currentTime) audio_obj.currentTime=0;
				audio_obj.play();
				$target.removeClass("play").addClass("stop");    
			}
			else {
				$(audio_obj).unbind('timeupdate');
				audio_obj.pause();
				$target.removeClass("stop").addClass("play");
			}
		}
    });
    
	if (isiPhone() == false) {
		$('.audio-block-rw').bind("click", function(e){
			var $target = $(this).find('img');
			var audio_obj = $(this).find('audio').get(0);
			
			$(audio_obj).bind('timeupdate',function(event){
				var curr_time = $(this).get(0).currentTime;
				var duration = $(this).get(0).duration;
				
				if(curr_time >= duration){
					//audio finished playing. set the class
					$(this).parent('.audio-block-rw').find('img').removeClass("stop").addClass("play");
					$(audio_obj).unbind('timeupdate');
				} else {
					$(this).parent('.audio-block-rw').find('img').removeClass("play").addClass("stop");
				}
				
			});
			
				
			if (audio_obj.play) {
				if ($target.hasClass('play')) {
					if(audio_obj.currentTime) audio_obj.currentTime=0;
					audio_obj.play();
					$target.removeClass("play").addClass("stop");
				}
				else {
					$(audio_obj).unbind('timeupdate');
					audio_obj.pause();
					$target.removeClass("stop").addClass("play");
					
					
				}
			}
		});
	}
	
	if (isiPhone()) {
		//Click event stops working on ipad once iscroll takes over
		//So implementing a touchend to handle this
		$('.audio-block-rw').live("touchend", function(e){
			var $target = $(this).find('img');
			var audio_obj = $(this).find('audio').get(0);
			
			$(audio_obj).bind('timeupdate',function(event){
				var curr_time = $(this).get(0).currentTime;
				var duration = $(this).get(0).duration;
				
				if(curr_time >= duration){
					//audio finished playing. set the class
					$(this).parent('.audio-block-rw').find('img').removeClass("stop").addClass("play");
					$(audio_obj).unbind('timeupdate');
				} else {
					$(this).parent('.audio-block-rw').find('img').removeClass("play").addClass("stop");
				}
				
			});
			
				
			if (audio_obj.play) {
				if ($target.hasClass('play')) {
					if(audio_obj.currentTime) audio_obj.currentTime=0;
					audio_obj.play();
					$target.removeClass("play").addClass("stop");
				}
				else {
					$(audio_obj).unbind('timeupdate');
					audio_obj.pause();
					$target.removeClass("stop").addClass("play");
					
					
				}
			}
		});
	}
}

//Plays a audio specified by audioref. 
//audio ref must be the id of a existing <audio> tag
//button represent the DOM element of object that called this function
function playAudio(button, audioref){
	var audio_obj = $('#'+audioref).get(0);
	if (audio_obj.paused) {
		 audio_obj.play();
		 $(button).removeClass("playsound").addClass("pausesound");
	}else {
		audio_obj.pause();
		audio_obj.currentTime=0;
		$(button).removeClass("pausesound").addClass("playsound");
    }
}

//Plays a audio specified by audioref. Does not handle button state
function playSFX(button, audioref){
	var audio_obj = $('#'+audioref).get(0);
	if(audio_obj.currentTime) audio_obj.currentTime = 0;
	audio_obj.play();
}
