/**
 * AZARDI READER AND AZARDI INTERACTIVE ENGINE EXTENSIONS
 * Copyright 2007-2012 Infogrid Pacific Pte. Ltd. All rights reserved
 * Modified Date: 2012-04-25
 * 
 * @version: 1-2012-04-25
 * @author Anup Dhabarde
 */

/**
 * @class Contains all the functions necessary for background-color adjustments
 */
var Color = function(){
	var config = {
		backgroundColor: ''
	};
	
	/**
	 * Set the background color of current chapter
	 * @params color Background color to be applied
	 */
	var set = function(color) {
		$('#doc-viewer-azd').contents().find('body').css('background-color', color);
		config.backgroundColor = color;
		BookPref.config.backgroundColor = color;
	};
	
	var setButton = function(color) {
		$('#but_color_normal').attr('selected', false);
		$('#but_color_warm').attr('selected', false);
		$('#but_color_low_contrast').attr('selected', false);
		
		switch(color) {
			case '#FFFFFF':
				$('#but_color_normal').attr('selected', true);
				break;
			case '#FAFAD2':
				$('#but_color_warm').attr('selected', true);
				break;
			case '#F0F0F0':
				$('#but_color_low_contrast').attr('selected', true);
				break;
		}
		
		config.backgroundColor = color;
		BookPref.config.backgroundColor = color;
	};
	
	return {
		config: config,
		set: set,
		setButton: setButton
	};
}();