/**
 * AZARDI READER AND AZARDI INTERACTIVE ENGINE EXTENSIONS
 * Copyright 2007-2012 Infogrid Pacific Pte. Ltd. All rights reserved
 * Modified Date: 2012-04-25
 * 
 * @version: 1-2012-04-25
 * @author Anup Dhabarde
 */

var CdpBookmark = function(){

	/**
	 * 	Private properties and methods.
	 */
	
	var config = {
		
	}
	
	var bookmark_save = function (data) {
		
		var fileObj = window.opener.getFileObject(window.opener.AME.getDbFilePath());
	
	    var values = new Array(	['time_created', data[0], 'TEXT'],
							    ['bookmark_name', data[1], 'TEXT'],
							    ['bookmark_description', data[2], 'TEXT'],
							    ['cdp_id', data[3], 'TEXT'],
							    ['current_position', data[4], 'TEXT'],
							    ['page_range', data[5], 'TEXT']);

		window.opener.insertRowIntoDatabase(fileObj, values, "cdp_bookmark");	
	}
	
	var readBookmarkData = function(cdpid){
		
		var fileObj = window.opener.getFileObject(window.opener.AME.getDbFilePath());
		try {
			var values = ['id', 'cdp_id', 'bookmark_name', 'bookmark_description', 'time_created', 'current_position', 'page_range'];
			var conditions = new Array(['cdp_id', cdpid, 'TEXT']);
			var statement = window.opener.getValuesFromDatabase(fileObj, values, 'cdp_bookmark', conditions);
			if(!statement) {
				return [];
			}
			var bookmarkData = new Array();
			while (statement.executeStep()) {
				var data = new Array();
				data.push(statement.row.cdp_id);
				data.push(statement.row.bookmark_name);
				data.push(statement.row.bookmark_description);
				data.push(statement.row.time_created);
				data.push(statement.row.current_position);
				data.push(statement.row.id);
				data.push(statement.row.page_range);
				bookmarkData.push(data);
			}
			statement.finalize();

		} catch(e) {
			alert(e);
			return [[]];
		}
		return bookmarkData;
	}
	
	var removeBookmark = function(bkId) {
		var fileObj = window.opener.getFileObject(window.opener.AME.getDbFilePath());
		var conditions = new Array(['id', bkId, 'INTEGER']);
		window.opener.deleteRowFromDatabase(fileObj, 'cdp_bookmark', conditions);
	}		
		
	return{
		config: config,
		bookmark_save: bookmark_save,
		readBookmarkData: readBookmarkData,
		removeBookmark: removeBookmark
	}
}();