/**
 * AZARDI READER AND AZARDI INTERACTIVE ENGINE EXTENSIONS
 * Copyright 2007-2012 Infogrid Pacific Pte. Ltd. All rights reserved
 * Modified Date: 2012-04-25
 * 
 * @version: 1-2012-04-25
 * @author Anup Dhabarde
 */

var CdpDownload = function () {
	var config = {
		isDownloading: false,
		prompts: Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService),
		obj_Persist: null,
		cdpId: ''
	}
	
	/**
	 * 	Function to initilize download of book database from server.
	 */
	
	var init = function (cdpId, catalogId, downloadLink) {
		var self = this;
		
		if(config.isDownloading){
			// config.prompts.alert(null, AME.getTitle(), 'Another book download in progress. You can download only one book at a time.');
			AME.showMessage('Another book download in progress. You can download only one book at a time.', 'warning', true, null);
			document.getElementById("doc-viewer-azd").contentWindow.enableDownloadButton(cdpId);
			return;
		}
		
		var params = {
					inn:{
						cdpId: cdpId,
						catalogId: catalogId,
						downloadLink: downloadLink,
						type: 'download_url'
					},
					out:{
						out: null,
						download_url: null,
						error_message: null,
						raf: null
					}
				};
  		window.openDialog("chrome://azardi2/content/azd_modal_dialog.xul", "", "width=250, height=60, chrome, dialog, modal, resizable=yes, titlebar=no, dependent, centerscreen", params).focus();
    	
		if (!params.out.out) {
			// alert(params.out.error_message);
			AME.showMessage(params.out.error_message, 'warning', true, null);
			// TODO: Remove this if codition, and while removing book do not remove expiry date from RAF_Master
			// 		 Force the user to renew the book if it has expired.
			if(params.out.error_message == 'Subscription has Expired.'){
				Catalog.writeBookStatus(cdpId, 'expired');
				document.getElementById('doc-viewer-azd').contentWindow.hideDownloadButton(cdpId);
				document.getElementById('doc-viewer-azd').contentWindow.hideInstallButton(cdpId);
				document.getElementById('doc-viewer-azd').contentWindow.hideRemoveButton(cdpId);
				document.getElementById('doc-viewer-azd').contentWindow.hideReadButton(cdpId);
				document.getElementById("doc-viewer-azd").contentWindow.disableCoverRead(cdpId);
				document.getElementById('doc-viewer-azd').contentWindow.showExpireButton(cdpId);
  			}
  			else{
  				document.getElementById("doc-viewer-azd").contentWindow.enableDownloadButton(cdpId);
  			}
  			return;
		}
		
		config.isDownloading = true;
		// Set current downloading book cdpId.
		config.cdpId = cdpId;
		AME.showStatusBar();
		$('#download-progressbar').attr('mode', 'undetermined');
		var fileObj = getFileObject(AME.getTempDownloadPath());
  		fileObj.append(cdpId+'.azd');
  		var readerToken = AME.getReaderToken();
  		// Encrypt the expiry date
	  	var expiryDate = GibberishAES.enc(params.out.raf, readerToken+cdpId);
	  	self.downloadFile(fileObj.path, params.out.download_url, expiryDate);
	}
	
	var downloadFile = function (tempDownloadPath, httpLocation, expiryDate) {
		var self = this;
		
		try {
			var obj_URI = Components.classes["@mozilla.org/network/io-service;1"]
									.getService(Components.interfaces.nsIIOService)
									.newURI(httpLocation, null, null);
			
			var obj_TargetFile = Components.classes["@mozilla.org/file/local;1"]
										   .createInstance(Components.interfaces.nsILocalFile);
	
			obj_TargetFile.initWithPath(tempDownloadPath);
			
			//	Create the file if it doesn't exists.
			if(!obj_TargetFile.exists()) {
				obj_TargetFile.create(0x00,0644);
			}
	
			config.obj_Persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"]
									.createInstance(Components.interfaces.nsIWebBrowserPersist);
	
			const nsIWBP = Components.interfaces.nsIWebBrowserPersist;
			const flags = nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES;
			config.obj_Persist.persistFlags = flags | nsIWBP.PERSIST_FLAGS_BYPASS_CACHE | nsIWBP.PERSIST_FLAGS_CLEANUP_ON_FAILURE;
	
			config.obj_Persist.progressListener = {
				onProgressChange: function(aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {
					if($('#download-progressbar').attr('mode') == 'undetermined'){
						$('#download-progressbar').attr('mode', 'determined');
					}
					var percentComplete = (aCurTotalProgress/aMaxTotalProgress)*100;
					$('#download-progressbar').attr('value', percentComplete);
				},
				
				onStateChange: function(aWebProgress, aRequest, aStateFlags, aStatus) {
					if(config.obj_Persist.currentState == config.obj_Persist.PERSIST_STATE_FINISHED) {
						var chan =	aRequest.QueryInterface(Components.interfaces.nsIHttpChannel);
						if (!chan.requestSucceeded) {
							config.isDownloading = false;
							// Reset current downloading book cdpId.
  							config.cdpId = '';
							AME.hideStatusBar();
							delete_Folder(tempDownloadPath);
							// config.prompts.alert(null, AME.getTitle(), "Book not available");
							AME.showMessage('The requested book is not available.', 'warning', true, null);
							document.getElementById("doc-viewer-azd").contentWindow.enableDownloadButton(httpLocation.split('/').pop().split('.')[0]);
							return;
						}
						if(aStatus == 0){		//		aStatus gives '0' if download is finished.
							config.isDownloading = false;
							// Reset current downloading book cdpId.
  							config.cdpId = '';
							
							AME.hideStatusBar();
							Catalog.writeBookStatus(httpLocation.split('/').pop().split('.')[0], 'downloaded');
							
							Catalog.writeBookExpiry(httpLocation.split('/').pop().split('.')[0], expiryDate);
							
							document.getElementById("doc-viewer-azd").contentWindow.hideDownloadButton(httpLocation.split('/').pop().split('.')[0]);
							document.getElementById("doc-viewer-azd").contentWindow.showInstallButton(httpLocation.split('/').pop().split('.')[0]);
							AME.showMessage('The book download is finished. Click the "Install" button to install the book.', 'info', true, null);
						}
						else{
							config.isDownloading = false;
							// Reset current downloading book cdpId.
  							config.cdpId = '';
							try{
								delete_Folder(tempDownloadPath);
							}
							catch(e){
							}
							finally{
								AME.hideStatusBar();
								// config.prompts.alert(null, AME.getTitle(), "Download is cancelled");
								AME.showMessage('The book download is cancelled.', 'info', true, null);
								document.getElementById("doc-viewer-azd").contentWindow.enableDownloadButton(httpLocation.split('/').pop().split('.')[0]);
							}
						}
					} 
				}
			  }
	
			config.obj_Persist.saveURI(obj_URI,null,null,null,null,obj_TargetFile, null);
		} catch (e) {
			dump('Error while downloading: ' + e);
		}
	}
	
	var cancel = function () {
		var self = this;
		
		config.obj_Persist.cancelSave();
	}
	
	var deleteBSItem = function (bid) {
		var params = {
			inn:{
				type: 'acf_bs_delb',
				params: bid,
			},
			out:{
				out:null,
				status: null,
			}
		};
		
		window.openDialog("chrome://azardi2/content/azd_modal_dialog.xul", "", "width=250, height=60, chrome, dialog, modal, resizable=yes, titlebar=no, dependent, centerscreen", params).focus();
		
		if (!params.out.out) {
			var msg = getPropertiesString("azd_cdp_deleteBookFail");
    		alert(msg);
			return { 
				"status": false,
				"reason": "Failed to connect to the server."
			}
		} else {
			var msg = getPropertiesString("azd_cdp_deleteBookSuccess");
    		alert(msg);
			return { 
				"status": true,
				"reason": "Failed to connect to the server."
			}
		}	
	}
	
	var downloadBSItem = function (bid) {
		try {
			if (typeof bid == "undefined") {
				var bookMD = Library.getClickedBookMD();
			} else {
				var bookMD = Library.getClickedBookMDByID(bid);
			}	
			var shelfId = Library.config.shelfId;
			var fileObj = getFileObject(AME.getDbFilePath());
			if (!fileObj.exists()){
				return false;
			}
			
			var table_name = "shelf_info";
			var values = ['shelf_id', 'shelf_metadata'];
			var conditions = new Array(['shelf_id', shelfId, 'TEXT']);
			var statement = getValuesFromDatabase(fileObj, values, table_name, conditions);
			var shelf_md_obj = {}
			while (statement.executeStep()){
				var shelf_id = statement.row.shelf_id;
				var shelf_md = statement.row.shelf_metadata;
				shelf_md_obj = JSON.parse(shelf_md);
				shelf_md_obj.shelfid = shelf_id;
				break
			}
			statement.finalize();
			 
			if (shelf_md_obj.hasOwnProperty("domain_name")) {
				var caturl =  shelf_md_obj["domain_name"] + '/acfs/newapi/registerreadingsession/';
				
				var pur_type = "";
				if (bookMD.hasOwnProperty("purchase_type")){
					pur_type = bookMD["purchase_type"];
				}
				
				var OfType = 1;
				if (pur_type === "sales") {
					OfType = 0;
				}
				
				var langcode = "en";
				if (AME.config.locale) {
					langcode = AME.config.locale;
				}
				
				var devicetoken = shelf_md_obj["devicetoken"];
				var pubacctuid = shelf_md_obj["pubacctuid"];
				var catParam = 'productuid=' + bookMD["uid"] + '&store_token=' + pubacctuid + '&offer_type=' + OfType +'&device_token=' + devicetoken + "&lang_code="+langcode+'&agreement_id=' + bookMD["agreement"];
				var catData = catParam;
				
				var params = {
					inn:{
						url: caturl,
						type: 'acf_bs_ds',
						params: catData,
						shelf_md: shelf_md_obj
					},
					out:{
						out:null,
						bsitems: null,
					}
				};
				
				window.openDialog("chrome://azardi2/content/azd_modal_dialog.xul", "", "width=250, height=60, chrome, dialog, modal, resizable=yes, titlebar=no, dependent, centerscreen", params).focus();
				
				if (!params.out.out) {
					return { 
						"status": false,
						"bsitems": {},
						"reason": params.out.bsitems["failure_reason"]
					}
				} else {
					var sessionresp = params.out.bsitems;
					sessionresp.bookuid = bookMD["agreement"];
					launchSession(shelf_md_obj, sessionresp);
				}
			}
		} catch(e) {
			alert(e);
		}
		return { 
			"status": true,
			"bsitems": {},
			"reason": "Failed to connect to the server."
		}
	}
	
	var launchSession = function(shelf_md_obj, sessioninfo) {
		var caturl = shelf_md_obj["domain_name"] + '/acfs/newapi/launchreader/';
		var pubacctuid = shelf_md_obj["pubacctuid"];
		var bookuid = sessioninfo.bookuid ;
		var langcode = "en";
		if (AME.config.locale) {
			langcode = AME.config.locale;
		}
				
		var catParam = "store_token=" + pubacctuid + '&sessionid=' + sessioninfo.session_id;
		var catData = catParam + "&lang_code=" + langcode + "&cbuster=" + new Date();
		
		var params = {
			inn:{
				url: caturl,
				type: 'acf_bs_bi',
				params: catData
			},
			out:{
				out:null,
				bsitems: null,
			}
		};
		
		window.openDialog("chrome://azardi2/content/azd_modal_dialog.xul", "", "width=250, height=60, chrome, dialog, modal, resizable=yes, titlebar=no, dependent, centerscreen", params).focus();
		
		if (!params.out.out) {
			return { 
				"status": false,
				"bsitems": {},
				"reason": "Failed to connect to the server."
			}
		} else {
			var sessionresp = params.out.bsitems;
			sessionresp.bookuid = bookuid;
			getMainBook(shelf_md_obj, sessionresp);
		}
	}
	
	var getMainBook = function(shelf_md_obj, sessionresp) {
		var response_dict = sessionresp.response_dict;
		
		if (!response_dict.hasOwnProperty('url_dict')) {
			return { 
				"status": false,
				"bsitems": {},
				"reason": "Failed to proper response from the server."
			}
		}
		
		var url_dict = response_dict['url_dict'];
		var workuid = response_dict.workid + ".json";;
		
		if (!url_dict.hasOwnProperty(workuid)) {
			return { 
				"status": false,
				"bsitems": {},
				"reason": "Failed to proper book location response from the server."
			}
		}
		
		if (response_dict.hasOwnProperty('fonts_url_dict')) {
			var fonturls = response_dict['fonts_url_dict'];
			for (fn in fonturls) {
				url_dict[fn] = fonturls[fn];
			}
		} 
		
		var jsonUrl = url_dict[workuid];
		var catData = "";
		var params = {
			inn:{
				url: jsonUrl,
				type: 'acf_bs_bd',
				params: catData,
				sessioninfo: sessionresp,
				shelfinfo: shelf_md_obj,
				url_info: url_dict
			},
			out:{
				out:null,
				bsitems: null,
			}
		};
		
		window.openDialog("chrome://azardi2/content/azd_modal_dialog.xul", "", "width=350, height=60, chrome, dialog, modal, resizable=yes, titlebar=no, dependent, centerscreen", params).focus();
		
		if (!params.out.out) {
			return { 
				"status": false,
				"bsitems": {},
				"reason": "Failed to connect to the server."
			}
		} else {
			var sessionresp = params.out.bsitems;
			
		}
	}
	
	return {
		config: config,
		init: init,
		downloadFile: downloadFile,
		downloadBSItem: downloadBSItem,
		deleteBSItem: deleteBSItem,
		cancel: cancel
	}
}();