/**
 * AZARDI READER AND AZARDI INTERACTIVE ENGINE EXTENSIONS
 * Copyright 2007-2012 Infogrid Pacific Pte. Ltd. All rights reserved
 * Modified Date: 2012-04-25
 * 
 * @version: 1-2012-04-25
 * @author Anup Dhabarde
 */

var CdpNav = function(){

	/**
	 * 	Private properties and methods.
	 */
	
	var config = {
		bufferLocation: '',
		lastAcoId: null,
		acoId: ''
	};
	
	var book = {
		ACOHtml: new Array(),
		ACOPresentationCss: new Array(),
		ACOPresentationJs: new Array(),
		ACOImages: new Array(),
		XHTML_NS: "http://www.w3.org/1999/xhtml",
		curr_pos: -1,
		curr_pages: new Array()
	};
	
	/**
	 * 	Public properties and methods.
	 */
	
	var loadAco = function (navigate) {
		var self = this;
		
		// document.getElementById('doc-viewer-azd').contentWindow.unbindNext();
		// document.getElementById('doc-viewer-azd').contentWindow.unbindPrevious();
		
		if(Azd.book.opener_aco) {
			var acoId = Azd.book.opener_aco;
			Azd.book.opener_aco = '';
			var foundInSpine = false;
		
			for(var i = 0; i < Azd.book.spine.length; i++) {
				if(Azd.book.spine[i][1] == acoId) {
					if(book.curr_pos == i) {
						return;
					} else {
						book.curr_pos = i;
					}
					foundInSpine = true;
					break;
				}
			}

			if(!foundInSpine) {
				document.getElementById('doc-viewer-azd').contentWindow.unbindNext();
				document.getElementById('doc-viewer-azd').contentWindow.unbindPrevious();
				self.loadOutOfSpineAco(acoId);
				return;
			}
		} else if(navigate == 'first') {
			book.curr_pos = 0;
		} else if(navigate == 'last') {
			if(book.curr_pos == Azd.book.spine.length - Azd.config.aco_display) {
				return;
			} else {
				book.curr_pos = Azd.book.spine.length - Azd.config.aco_display;
			}
		} else if(navigate == 'next') {
			if(book.curr_pos == Azd.book.spine.length - Azd.config.aco_display) {
				return;
			} else{
				book.curr_pos = book.curr_pos + Azd.config.aco_display;
			}
		} else if(navigate == 'previous') {
			if(book.curr_pos == 0) {
				return;
			} else {
				book.curr_pos = book.curr_pos - Azd.config.aco_display;
			}
		}
		
		document.getElementById('doc-viewer-azd').contentWindow.unbindNext();
		document.getElementById('doc-viewer-azd').contentWindow.unbindPrevious();
		
		self.getBufferLocation();
		self.unloadAco();
		// Azd.getApplicationConfiguration();
		// Azd.getCDPConfiguration();
		
	    var acoContent = Azd.config.aco_content.split('|');
	    
	    for (var k=0; k < acoContent.length; k++) {
			if (acoContent[k] == 'all') {
				
				for(var i = book.curr_pos, j = 0; j < Azd.config.aco_display; i=i+1, j=j+1){
					var acoId = Azd.book.spine[i][1];
					self.config.acoId = acoId;
					self.getACOAudioData(Azd.book.location, acoId);
					self.getACOVideoData(Azd.book.location, acoId);
					self.getACOCssData(Azd.book.location, acoId);
					self.getACOJsData(Azd.book.location, acoId);
					self.getACOHtmlData(Azd.book.location, acoId);
					self.setACOCss();
					self.setACOJs();
					self.getACOConfiguration();
					Azd.setConfiguration();
					self.setACOHtml();
					self.setACOAudioInHtml(acoId);
					self.setACOVideoInHtml(acoId);
					document.getElementById('doc-viewer-azd').contentWindow.bindNext();
					document.getElementById('doc-viewer-azd').contentWindow.bindPrevious();
				}
				try{
					document.getElementById('doc-viewer-azd').contentWindow.initAIE();
				} catch (e) {
					alert(e);
				}
			}
			else if (acoContent[k] == 'image') {
				for(var i = book.curr_pos, j = 0; j < Azd.config.aco_display; i=i+1, j=j+1) {
					var acoId = Azd.book.spine[i][1];
					self.config.acoId = acoId;
					var imageName = Azd.book.spine[i][2];
					self.setImageDataFromDb(Azd.book.location, acoId, imageName, 'aco-page-'+(j+1));
				}
			}
			else if (acoContent[k] == 'audio') {
				for (var i = book.curr_pos, j = 0; j < Azd.config.aco_display; i=i+1, j=j+1) {
					var acoId = Azd.book.spine[i][1];
					self.config.acoId = acoId;
					var audioName = Azd.book.spine[i][3];
					self.getACOAudioData(Azd.book.location, acoId);
					self.setACOAudio(acoId, audioName, 'audio-page-'+(j+1));
				}
			}
		}
		if(Azd.book.rpnMap.length > 0) {
			book.curr_pages = Azd.book.rpnMap[book.curr_pos][2];
			var page_no = book.curr_pages;
			if(page_no.indexOf('bl') != -1)
				page_no.splice(page_no.indexOf('bl'), 1);
			page_no = page_no[0];
			
			document.getElementById('doc-viewer-azd').contentWindow.setPageNo(page_no);
		}
	}
	
	var loadOutOfSpineAco = function(acoId) {
		var self = this;
		
		self.getBufferLocation();
		self.unloadAco();
		// Azd.getApplicationConfiguration();
		// Azd.getCDPConfiguration();
		
	    var acoContent = Azd.config.aco_content.split('|');
	    
	    for (var k=0; k < acoContent.length; k++) {
			if (acoContent[k] == 'all') {
				self.config.acoId = acoId;
				self.getACOAudioData(Azd.book.location, acoId);
				self.getACOVideoData(Azd.book.location, acoId);
				self.getACOCssData(Azd.book.location, acoId);
				self.getACOJsData(Azd.book.location, acoId);
				self.getACOHtmlData(Azd.book.location, acoId);
				self.setACOCss();
				self.setACOJs();
				self.getACOConfiguration();
				Azd.setConfiguration();
				self.setACOHtml();
				self.setACOAudioInHtml(acoId);
				self.setACOVideoInHtml(acoId);
				document.getElementById('doc-viewer-azd').contentWindow.bindNext();
				document.getElementById('doc-viewer-azd').contentWindow.bindPrevious();
				
				document.getElementById('doc-viewer-azd').contentWindow.initAIE();
			}
			else if (acoContent[k] == 'image') {
				self.config.acoId = acoId;
				var imageName = Azd.book.spine[i][2];
				self.setImageDataFromDb(Azd.book.location, acoId, imageName, 'aco-page-'+(j+1));
				
			}
			else if (acoContent[k] == 'audio') {
				self.config.acoId = acoId;
				var audioName = Azd.book.spine[i][3];
				self.getACOAudioData(Azd.book.location, acoId);
				self.setACOAudio(acoId, audioName, 'audio-page-'+(j+1));
			}
		}
	};
	
	var unloadAco = function () {
		var self = this;
		
		var acoContent = Azd.config.aco_content.split('|');
		for(var i = 0; i < acoContent.length; i++){
			if(acoContent[i] == 'all'){
				book.ACOHtml.splice(0, book.ACOHtml.length);
				book.ACOPresentationCss.splice(0, book.ACOPresentationCss.length);
				book.ACOPresentationJs.splice(0, book.ACOPresentationJs.length);
				book.ACOImages.splice(0, book.ACOImages.length);
				self.removeOldCss();
				self.removeOldJs();
			}
			else if(acoContent[i] == 'image'){
				// $('#doc-viewer-azd').contents().find('*[class^="aco-page-"] > img').remove();
				// $('#doc-viewer-azd').contents().find('*[class^="aco-page-"] > img').attr('src', '');
			}
			else if(acoContent[i] == 'audio') {
				document.getElementById('doc-viewer-azd').contentWindow.resetAudioPlayer();
				$('#doc-viewer-azd').contents().find('*[id^="audio-page-"]').attr('src', '');
				$('#doc-viewer-azd').contents().find('*[id^="audio-page-"]').remove();
				
				if(typeof config.lastAcoId != 'undefined' && config.lastAcoId != null) {
					try{
						var audioPath = getAppendFilePath(config.bufferLocation, [config.lastAcoId]);
						deleteFolder(audioPath);
						config.lastAcoId = null;
					} catch(e) {
						
					}
				}
			}
		}
		// config.bufferLocation = '';
	}
	
	var goToAco = function (goToVal) {
		var self = this;
		
		if(goToVal <= 0){
			self.loadAco('first');
		}
		else{
			var leftPageRpn;
			var found = false;
			var acoId;
			for(var i = 0; i < Azd.book.rpnMap.length; i++) {
				if(Azd.book.rpnMap[i][0] == goToVal) {
					leftPageRpn = Azd.book.rpnMap[i][2][0];
					found = true;
					break;
				}
			}
			if(found){
				for(var i = 0; i < Azd.book.rpnMap.length; i++) {
					if(Azd.book.rpnMap[i][0] == leftPageRpn) {
						acoId = Azd.book.rpnMap[i][1];
						break;
					}
				}
				for(var i = 0; i < Azd.book.spine.length; i++) {
					if(Azd.book.spine[i][1] == acoId) {
						// if(book.curr_pos == i){
							// return;
						// }
						// else{
							book.curr_pos = i;
						// }
						break;
					}
				}
				self.loadAco();
			}
			else{
				self.loadAco('last');
			}
		}
	}
	
	var goToWithAcoId = function(acoId) {
		var self = this;
		
		var foundInSpine = false;
		
		for(var i = 0; i < Azd.book.spine.length; i++) {
			if(Azd.book.spine[i][1] == acoId) {
				if(book.curr_pos == i) {
					return;
				} else {
					book.curr_pos = i;
				}
				foundInSpine = true;
				break;
			}
		}
		
		if(foundInSpine) {
			self.loadAco();
		} else {
			self.loadOutOfSpineAco(acoId);
		}
	}
	
	var goToAcoFromBookmark = function(current_position) {
		var self = this;
		
		if(book.curr_pos != current_position){
			book.curr_pos = current_position;
			self.loadAco();
		}
	}
	
	 var setACOAudio = function (acoId, fileName, lookup) {
		var self = this;
		
		if(fileName == ''){
			// Deinitilizing the audio player if audio is not available.
			document.getElementById('doc-viewer-azd').contentWindow.deInitAudioPlayer();
			return;
		}
		config.lastAcoId = acoId;
		var audioPath = getAppendFilePath(config.bufferLocation, [acoId, 'audio', fileName]);
		var audioObj = getFileObjectFromPath(audioPath);
		var audioUrl = getURL(audioObj);
		// $('#doc-viewer-azd').contents().find('#'+lookup).attr('src', audioUrl);
		
		// var div_audio_target = document.getElementById('audio_placeholder');
		// if(path_ogg!==undefined && path_ogg!== '') {
			// var audio_id = 'audio_'+page_rpn;
			// var audio = $('<audio />', {
				// "id": audio_id
			// });
			// var oggpath = path_ogg
			// $('<source />').attr('src',oggpath).appendTo(audio);
			// $('#audio_placeholder').append(audio);
		// }
		
		var audioTag = document.createElementNS(book.XHTML_NS, 'audio');
		audioTag.setAttribute("preload", 'none');
		audioTag.setAttribute('id', lookup);
		audioTag.setAttribute("src", audioUrl);
		document.getElementById('doc-viewer-azd').contentWindow.document.getElementById('aco-audio-main').appendChild(audioTag);
		document.getElementById('doc-viewer-azd').contentWindow.initAudioPlayer();
	}
	
	var setImageDataFromDb = function (bookLocation, acoId, imageName, lookup) {
		var self = this;
		
		try{
			var fileObj = getFileObjectFromPath(bookLocation);
			if (!fileObj.exists()) {
				return;
			}
			
			var storageService = Components
				.classes["@mozilla.org/storage/service;1"]
				.getService(Components.interfaces.mozIStorageService);
			
			conObject = storageService.openDatabase(fileObj);
			var rows = new Array();
			var data = new Array();
			
			if(conObject != ""){
				var statement = conObject.createStatement('SELECT file_content FROM ACO_Images WHERE aco_id=?1 AND filename=?2');
				statement.bindStringParameter(0, acoId);
				statement.bindStringParameter(1, imageName);
				
				var mystatus = statement.executeAsync({
					handleResult: function(aResultSet){
			 			var i = 0;
		     			for (row = aResultSet.getNextRow();   row; row = aResultSet.getNextRow()){
		        			rows[i] = row;
		        			data['file_content'] = rows[i].getResultByName('file_content');
		        			++i;
		     			}
		  			},
		                
		  			handleError: function(anError){
		  				conObject.close();
						statement.finalize();
						var msg = getPropertiesString("azd_cdp_nav_imgNotFound");
						alert(msg);
		  			},
		
		  			handleCompletion: function(aReason){
		     			if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED){
		          			var msg = getPropertiesString("azd_cdp_nav_imgNotFound");
							alert(msg);
		     			}
		     			else{
		     				var imageDataUri = self.byteToDataUri(data['file_content'], imageName);
		     				// var imgTag = document.createElementNS(book.XHTML_NS, 'img');
							// imgTag.setAttribute("src", imageDataUri);
							// document.getElementById('doc-viewer-azd').contentWindow.document.getElementById(lookup).appendChild(imgTag);
							$('#doc-viewer-azd').contents().find('#'+lookup+' > img').attr('src', imageDataUri);
							
							// if(imageNo == Azd.config.aco_display - 1) {
								// document.getElementById('doc-viewer-azd').contentWindow.bindNext();
								// document.getElementById('doc-viewer-azd').contentWindow.bindPrevious();
							// }
		     			}
		          		conObject.close();
						statement.finalize();
		  			}
				});
			}
		}catch(e){alert(e)}
	}
	
	var byteToDataUri = function (data, imageName) {
		var stringfromByteArray = "";
		for (var i=0; i<data.length ; i++){ 
			stringfromByteArray += String.fromCharCode(data[i]);
		}
		var ext = imageName.split('.').pop();
		var dataUri = '';
		switch(ext) {
			case 'png':
				dataUri = 'data:image/png;base64,';
			  	break;
			case 'jpe':
		 	case 'jpeg':
			case 'jpg':
				dataUri = 'data:image/jpeg;base64,'
			  	break;
			default:
		}
	
		dataUri = dataUri + btoa(stringfromByteArray);
		return dataUri;
	}
	
	var getACOConfiguration = function () {
		if(typeof document.getElementById('doc-viewer-azd').contentWindow.acoPref != 'undefined'){
			$.extend(Azd.config, document.getElementById('doc-viewer-azd').contentWindow.acoPref);
		}
	}
	
	var getBufferLocation = function() {
		var file = Components.classes["@mozilla.org/file/directory_service;1"]
							 .getService(Components.interfaces.nsIProperties)
							 .get("ProfD", Components.interfaces.nsIFile);
		file.append("quizfx");
		file.append("buffer");

		config.bufferLocation = file.path;
	}
	
	var removeOldCss = function () {
		var self = this;
		
		$('#doc-viewer-azd').contents().find('style[class^="acoCss_"]').remove();
	}
	
	var removeOldJs = function () {
		var self = this;
		$('#doc-viewer-azd').contents().find('script[id^="acoJs_"]').remove();
	}
	
	var getACOHtmlData = function (bookLocation, acoId) {
		var self = this;
		
		var fileObj = getFileObjectFromPath(bookLocation);
		if (!fileObj.exists()) {
			return;
		}
		var values = ['id', 'aco_id', 'title', 'aco_content', 'aco_info'];
		var tableName = 'ACO_Master';
		var conditions = new Array(['aco_id', acoId, 'TEXT']);
		var statement = getValuesFromDatabase(fileObj, values, tableName, conditions);
		
		while(statement.executeStep()){
			book.ACOHtml['id'] = statement.row.id;
			book.ACOHtml['aco_id'] = statement.row.aco_id;	
			book.ACOHtml['title'] = statement.row.title;
			book.ACOHtml['aco_content'] = statement.row.aco_content;
			book.ACOHtml['aco_info'] = statement.row.aco_info;
		}
		statement.finalize();
	}
	
	var getACOCssData = function (bookLocation, acoId) {
		var self = this;
		
		var fileObj = getFileObjectFromPath(bookLocation);
		if (!fileObj.exists()) {
			return;
		}
		var values = ['id', 'aco_id', 'filename', 'file_content'];
		var tableName = 'ACO_Presentation_css';
		var conditions = new Array(['aco_id', acoId, 'TEXT']);
		var statement = getValuesFromDatabase(fileObj, values, tableName, conditions);
		
		while(statement.executeStep()){
			var data = new Array();
			data['id'] = statement.row.id;
			data['aco_id'] = statement.row.aco_id;	
			data['filename'] = statement.row.filename;
			data['file_content'] = statement.row.file_content;
			book.ACOPresentationCss.push(data);
		}
		statement.finalize();
	}
	
	var getACOJsData = function (bookLocation, acoId) {
		var self = this;
		
		var fileObj = getFileObjectFromPath(bookLocation);
		if (!fileObj.exists()) {
			return;
		}
		var values = ['id', 'aco_id', 'filename', 'file_content'];
		var tableName = 'ACO_Presentation_js';
		var conditions = new Array(['aco_id', acoId, 'TEXT']);
		var statement = getValuesFromDatabase(fileObj, values, tableName, conditions);
		
		while(statement.executeStep()){
			var data = new Array();
			data['id'] = statement.row.id;
			data['aco_id'] = statement.row.aco_id;	
			data['filename'] = statement.row.filename;
			data['file_content'] = statement.row.file_content;
			book.ACOPresentationJs.push(data);
		}
		statement.finalize();
	}
	
	// var getACOPresentationData = function (bookLocation, acoId) {
		// var self = this;
// 		
		// var fileObj = getFileObjectFromPath(bookLocation);
		// if (!fileObj.exists()) {
			// return;
		// }
		// var values = ['id', 'type', 'content_type', 'filename', 'file_path', 'file'];
		// var tableName = 'presentation';
		// var conditions = new Array(['type', 'ACO', 'TEXT'],
								   // ['aco_id', acoId, 'TEXT']);
		// var statement = getValuesFromDatabase(fileObj, values, tableName, conditions);
// 		
		// while(statement.executeStep()){
			// var data = new Array();
			// data['id'] = statement.row.id;
			// data['type'] = statement.row.type;	
			// data['content_type'] = statement.row.content_type;
			// data['filename'] = statement.row.filename;
			// data['file_path'] = statement.row.file_path;
			// data['file'] = statement.row.file;
			// book.ACOPresentation.push(data);
		// }
		// statement.finalize();
	// }
	
	var getACOAudioData = function (bookLocation, acoId) {
		var self = this;
		
		try{
			var fileObj = getFileObjectFromPath(bookLocation);
			if (!fileObj.exists()) {
				return;
			}
			
			var storageService = Components
				.classes["@mozilla.org/storage/service;1"]
				.getService(Components.interfaces.mozIStorageService);
			
			conObject = storageService.openDatabase(fileObj);
			var rows = new Array();
			
			if(conObject != ""){
				var statement = conObject.createStatement('SELECT file_content, filename FROM ACO_Audio WHERE aco_id=?1');
				statement.bindStringParameter(0, acoId);
				
				
				var mystatus = statement.executeAsync({
					handleResult: function(aResultSet){
			 			var i = 0;
		     			for (row = aResultSet.getNextRow();   row; row = aResultSet.getNextRow()){
		     				var data = new Array();
		        			rows[i] = row;
		        			data['filename'] = rows[i].getResultByName('filename');
		        			data['file_content'] = rows[i].getResultByName('file_content');
		        			self.saveFiles(data['filename'], data['file_content'], acoId, 'audio');
		        			++i;
		     			}
		  			},
		                
		  			handleError: function(anError){
		  				conObject.close();
						statement.finalize();
						var msg = getPropertiesString("azd_cdp_nav_audNotFound");
						alert(msg);
		  			},
		
		  			handleCompletion: function(aReason){
		     			if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED){
		          			var msg = getPropertiesString("azd_cdp_nav_audNotFound");
							alert(msg);
		     			}
		     			else{
		     			}
		          		conObject.close();
						statement.finalize();
		  			}
				});
			}
		}catch(e){alert(e)}
	}
	
	var saveFiles = function (filename, file, acoId, type){
		if(filename !== ''){	
			try {
				
				var fileObj = Components.classes["@mozilla.org/file/directory_service;1"]
										 .getService(Components.interfaces.nsIProperties)
										 .get("ProfD", Components.interfaces.nsIFile);
				fileObj.append("quizfx");
				fileObj.append('buffer');
				fileObj.append(acoId);
				fileObj.append(type);
				fileObj.append(filename);
				
			    if (!fileObj.exists()) {
			    	fileObj.create(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0666);
			    }
			
				var fileOutStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
			       fileOutStream.init(fileObj, 0x02 | 0x08 | 0x20, 0666, 0);
			    var binaryOutStream = Components.classes['@mozilla.org/binaryoutputstream;1'].createInstance(Components.interfaces.nsIBinaryOutputStream);
			    binaryOutStream.setOutputStream(fileOutStream);
			    binaryOutStream.writeByteArray(file, file.length);
			   
			    binaryOutStream.close();
			}
			catch(e){
				var msg = getPropertiesString("azd_cdp_nav_errReadAudVid");
				alert(msg);
			}
		}
	}
	
	var getACOVideoData = function (bookLocation, acoId) {
		var self = this;
		
		try{
			var fileObj = getFileObjectFromPath(bookLocation);
			if (!fileObj.exists()) {
				return;
			}
			
			var storageService = Components
				.classes["@mozilla.org/storage/service;1"]
				.getService(Components.interfaces.mozIStorageService);
			
			conObject = storageService.openDatabase(fileObj);
			var rows = new Array();
			
			if(conObject != ""){
				var statement = conObject.createStatement('SELECT file_content, filename FROM ACO_Video WHERE aco_id=?1');
				statement.bindStringParameter(0, acoId);
				
				var mystatus = statement.executeAsync({
					handleResult: function(aResultSet){
			 			var i = 0;
		     			for (row = aResultSet.getNextRow(); row; row = aResultSet.getNextRow()){
		     				var data = new Array();
		        			rows[i] = row;
		        			data['filename'] = rows[i].getResultByName('filename');
		        			data['file_content'] = rows[i].getResultByName('file_content');
		        			self.saveFiles(data['filename'], data['file_content'], acoId, 'video');
		        			++i;
		     			}
		  			},
		                
		  			handleError: function(anError){
		  				conObject.close();
						statement.finalize();
						var msg = getPropertiesString("azd_cdp_nav_vidNotFound");
						alert(msg);
		  			},
		
		  			handleCompletion: function(aReason){
		     			if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED){
		          			var msg = getPropertiesString("azd_cdp_nav_vidNotFound");
							alert(msg);
		     			}
		     			else{
		     			}
		          		conObject.close();
						statement.finalize();
		  			}
				});
			}
		}catch(e){alert(e)}
	}
	
	var setACOHtml = function () {
		if($('#doc-viewer-azd').contents().find('.aco-target').length !== 0) {
			$('#doc-viewer-azd').contents().find('.aco-target').html(book.ACOHtml['aco_content']);
		} else {
			$('#doc-viewer-azd').contents().find('.aco-presentation').html(book.ACOHtml['aco_content']);
		}
	}
	
	var setACOCss = function () {
		for (var i=0; i < book.ACOPresentationCss.length; i++) {
			// if(book.ACOPresentation[i]['content_type'] == 'css'){
				var styleTag = '<style type="text/css" class="acoCss_'+ i +'">' + book.ACOPresentationCss[i]['file_content'] + '</style>';
				$('#doc-viewer-azd').contents().find('head').append(styleTag);
			// }
		};
	}
	
	var setACOJs = function () {
		for (var i=0; i < book.ACOPresentationJs.length; i++) {
			// if(book.ACOPresentation[i]['content_type'] == 'js'){
				var scriptTag = document.createElementNS(book.XHTML_NS, 'script');
				scriptTag.setAttribute("id", "acoJs_"+i);
				var scriptContent = document.createTextNode(book.ACOPresentationJs[i]['file_content']);
				scriptTag.appendChild(scriptContent);
				document.getElementById('doc-viewer-azd').contentWindow.document.getElementsByTagName('head')[0].appendChild(scriptTag);
			// };
		};
	}
	
	var setACOAudioInHtml = function (acoId) {
		var self = this;
		
		var $audio = $('#doc-viewer-azd').contents().find('.aco-presentation audio');
		var $source = $('#doc-viewer-azd').contents().find('.aco-presentation audio source');
		
		$audio.each(function () {
			var audioSrc = $(this).attr('src');
			if (typeof audioSrc != 'undefined') {
				var fileName = audioSrc.split('/').pop();
				var audioPath = getAppendFilePath(config.bufferLocation, [acoId, 'audio', fileName]);
				var audioObj = getFileObjectFromPath(audioPath);
				var audioUrl = getURL(audioObj);
				$(this).attr('src', audioUrl);
			}
		});
		
		$source.each(function () {
			var audioSrc = $(this).attr('src');
			if (typeof audioSrc != 'undefined') {
				var fileName = audioSrc.split('/').pop();
				var audioPath = getAppendFilePath(config.bufferLocation, [acoId, 'audio', fileName]);
				var audioObj = getFileObjectFromPath(audioPath);
				var audioUrl = getURL(audioObj);
				$(this).attr('src', audioUrl);
			}
		});
	}
	
	var setACOVideoInHtml = function (acoId) {
		var self = this;
		
		var $video = $('#doc-viewer-azd').contents().find('.aco-presentation video');
		var $source = $('#doc-viewer-azd').contents().find('.aco-presentation video source');
		
		$video.each(function () {
			var videoSrc = $(this).attr('src');
			if (typeof videoSrc != 'undefined') {
				var fileName = videoSrc.split('/').pop();
				var videoPath = getAppendFilePath(config.bufferLocation, [acoId, 'video', fileName]);
				var videoObj = getFileObjectFromPath(videoPath);
				var videoUrl = getURL(videoObj);
				$(this).attr('src', videoUrl);
			}
		});
		
		$source.each(function () {
			var videoSrc = $(this).attr('src');
			if (typeof videoSrc != 'undefined') {
				var fileName = videoSrc.split('/').pop();
				var videoPath = getAppendFilePath(config.bufferLocation, [acoId, 'video', fileName]);
				var videoObj = getFileObjectFromPath(videoPath);
				var videoUrl = getURL(videoObj);
				$(this).attr('src', videoUrl);
			}
		});
	};
	
	var getACOID = function() {
		var self = this;
		
		return self.config.acoId;
	};
	
	return{
		config: config,
		book: book,
		loadAco: loadAco,
		loadOutOfSpineAco: loadOutOfSpineAco,
		unloadAco: unloadAco,
		getBufferLocation: getBufferLocation,
		removeOldCss: removeOldCss,
		removeOldJs: removeOldJs,
		getACOHtmlData: getACOHtmlData,
		// getACOPresentationData: getACOPresentationData,
		getACOCssData: getACOCssData,
		getACOJsData: getACOJsData,
		getACOAudioData: getACOAudioData,
		getACOVideoData: getACOVideoData,
		saveFiles: saveFiles,
		setACOHtml: setACOHtml,
		setACOCss: setACOCss,
		setACOJs: setACOJs,
		setACOAudioInHtml: setACOAudioInHtml,
		setACOVideoInHtml: setACOVideoInHtml,
		getACOConfiguration: getACOConfiguration,
		setImageDataFromDb: setImageDataFromDb,
		byteToDataUri: byteToDataUri,
		setACOAudio: setACOAudio,
		goToAco: goToAco,
		goToAcoFromBookmark: goToAcoFromBookmark,
		getACOID: getACOID,
		goToWithAcoId: goToWithAcoId
	};
}();