/**
 * AZARDI READER AND AZARDI INTERACTIVE ENGINE EXTENSIONS
 * Copyright 2007-2012 Infogrid Pacific Pte. Ltd. All rights reserved
 * Modified Date: 2012-04-25
 * 
 * @version: 1-2012-04-25
 * @author Anup Dhabarde
 */

/**
 * @class Contains all the functions necessay to remove cdp from database.
 */
var CdpRemove = function(){

	/**
	 * 	Private properties and methods.
	 */
	
	var config = {
		
	}
	
	var init = function (cdpDbPath, searchDbPath, cdpId){
		var self = this;
		
		document.title = window.opener.AME.getTitle();
		$('#modal-message').attr('value', 'Removing the book. Please Wait...');
		setTimeout(function(){
			self.init2(cdpDbPath, searchDbPath, cdpId);
		}, 500);
	}
	
	var init2 = function (cdpDbPath, searchDbPath, cdpId) {
		var self = this;
		
		var aco = self.getAcoReferences(cdpId, searchDbPath);
		self.removeCdpData (cdpId, cdpDbPath);
		self.removeAcoData (cdpId, cdpDbPath, aco);
		self.removeSearchData(cdpId, searchDbPath);
		var fileObj = window.opener.getFileObjectFromPath(cdpDbPath);
		// window.opener.vacuumDatabase(fileObj);
		fileObj = window.opener.getFileObjectFromPath(searchDbPath);
		// window.opener.vacuumDatabase(fileObj);
		
		window.arguments[0].out = true;
		window.close();	
	}
	
	function getAcoReferences (cdpId, searchDbPath) {
		var self = this;
	
		var fileObj = window.opener.getFileObjectFromPath(searchDbPath);
		var table_name= "ContentSearch"
	    conditions = new Array(['cdp_id', cdpId, 'TEXT']);
		var values = ['aco_id'];
		var statement = window.opener.getValuesFromDatabase(fileObj, values, table_name, conditions);
		if(!statement) {
			return [];
		}
		var aco = new Array();
		while (statement.executeStep()) {
			aco.push(statement.row.aco_id);
		}
		statement.finalize();
		return aco;
	}
	
	var removeCdpData = function (cdpId, cdpDbPath) {
		var self = this;

		var fileObj = window.opener.getFileObjectFromPath(cdpDbPath);
	    conditions = new Array(['cdp_id', cdpId, 'TEXT']);
		var table_name= "CDP_Audio";
		window.opener.deleteRowFromDatabase(fileObj,table_name, conditions);
		table_name = "CDP_Images";
		window.opener.deleteRowFromDatabase(fileObj,table_name, conditions);
		table_name = "CDP_Master";
		window.opener.deleteRowFromDatabase(fileObj,table_name, conditions);
		table_name = "CDP_Metadata";
		window.opener.deleteRowFromDatabase(fileObj,table_name, conditions);
		table_name = "CDP_Presentation_css";
		window.opener.deleteRowFromDatabase(fileObj,table_name, conditions);
		table_name = "CDP_Presentation_js";
		window.opener.deleteRowFromDatabase(fileObj,table_name, conditions);
		table_name = "CDP_Proprietary";
		window.opener.deleteRowFromDatabase(fileObj,table_name, conditions);
		table_name = "CDP_Video";
		window.opener.deleteRowFromDatabase(fileObj,table_name, conditions);
		conditions = new Array(['field_id', cdpId, 'TEXT'],
							   ['raf_key', 'status', 'TEXT']);
		table_name = "RAF_Master";
		window.opener.deleteRowFromDatabase(fileObj,table_name, conditions);
	}
	
	var removeAcoData = function (cdpId, cdpDbPath, aco) {
		var self = this;
		
		var fileObj = window.opener.getFileObjectFromPath(cdpDbPath);
	    var table_name1= "ACO_Audio";
		var table_name2= "ACO_Images";
		var table_name3= "ACO_Master";
		var table_name4= "ACO_Presentation_css";
		var table_name5= "ACO_Presentation_js";
		var table_name6= "ACO_Proprietary";
		var table_name7= "ACO_Video";
		
		for (var i=0; i < aco.length; i++) {
		    var conditions = new Array(['aco_id', aco[i], 'TEXT']);
			window.opener.deleteRowFromDatabase(fileObj,table_name1, conditions);
			window.opener.deleteRowFromDatabase(fileObj,table_name2, conditions);
			window.opener.deleteRowFromDatabase(fileObj,table_name3, conditions);
			window.opener.deleteRowFromDatabase(fileObj,table_name4, conditions);
			window.opener.deleteRowFromDatabase(fileObj,table_name5, conditions);
			window.opener.deleteRowFromDatabase(fileObj,table_name6, conditions);
			window.opener.deleteRowFromDatabase(fileObj,table_name7, conditions);
	    };
	}
	
	var removeSearchData = function (cdpId, searchDbPath) {
	
		var self = this;

		var fileObj = window.opener.getFileObjectFromPath(searchDbPath);
		var table_name1= "CDP_Master";
		var table_name2= "CDP_Info";
		var table_name3= "ContentSearch";
		var table_name4= "ACOCDP_Relation";
	    conditions1 = new Array(['cdp_id', cdpId, 'TEXT']);
	    conditions2 = new Array(['cdpid', cdpId, 'TEXT']);
		window.opener.deleteRowFromDatabase(fileObj,table_name1, conditions1);
		window.opener.deleteRowFromDatabase(fileObj,table_name2, conditions2);
		window.opener.deleteRowFromDatabase(fileObj,table_name3, conditions1);
		window.opener.deleteRowFromDatabase(fileObj,table_name4, conditions1);
	}
	/**
	 * Initilizes the removal of all the books from database.
	 * @params cdpDbPath Path of the cdp database
	 * @params searchDbPath Path of the search database
	 * @params cdpRef
	 */
	var removeAll = function (cdpDbPath, searchDbPath, cdpRef) {
		var self = this;
		
		document.title = window.opener.AME.getTitle();
		$('#modal-message').attr('value', 'Please Wait...');
		//The following timeout is necessary to show the modal dialog.
		setTimeout(function(){
			self.removeAll2(cdpDbPath, searchDbPath, cdpRef);
		}, 500);
	};
	
	/**
	 * Removes all the cdp from the database
	 * @params cdpDbPath Path of the cdp database
	 * @params searchDbPath Path of the search database
	 * @params cdpRef
	 */
	var removeAll2 = function (cdpDbPath, searchDbPath, cdpRef) {
		var self = this;
		
		var fileObj = window.opener.getFileObjectFromPath(cdpDbPath);
		var table_name = "CDP_Audio";
		window.opener.deleteAllRowsFromTable(fileObj,table_name);
		table_name = "CDP_Images";
		window.opener.deleteAllRowsFromTable(fileObj,table_name);
		table_name = "CDP_Master";
		window.opener.deleteAllRowsFromTable(fileObj,table_name);
		table_name = "CDP_Metadata";
		window.opener.deleteAllRowsFromTable(fileObj,table_name);
		table_name = "CDP_Presentation_css";
		window.opener.deleteAllRowsFromTable(fileObj,table_name);
		table_name = "CDP_Presentation_js";
		window.opener.deleteAllRowsFromTable(fileObj,table_name);
		table_name = "CDP_Proprietary";
		window.opener.deleteAllRowsFromTable(fileObj,table_name);
		table_name = "CDP_Video";
		window.opener.deleteAllRowsFromTable(fileObj,table_name);
		
		table_name = "ACO_Audio";
		window.opener.deleteAllRowsFromTable(fileObj,table_name);
		table_name = "ACO_Images";
		window.opener.deleteAllRowsFromTable(fileObj,table_name);
		table_name = "ACO_Master";
		window.opener.deleteAllRowsFromTable(fileObj,table_name);
		table_name = "ACO_Presentation_css";
		window.opener.deleteAllRowsFromTable(fileObj,table_name);
		table_name = "ACO_Presentation_js";
		window.opener.deleteAllRowsFromTable(fileObj,table_name);
		table_name = "ACO_Proprietary";
		window.opener.deleteAllRowsFromTable(fileObj,table_name);
		table_name = "ACO_Video";
		window.opener.deleteAllRowsFromTable(fileObj,table_name);
		
		for(var i=0; i<cdpRef.length; i++) {
			conditions = new Array(['field_id', cdpRef[i], 'TEXT']);
			table_name = "RAF_Master";
			window.opener.deleteRowFromDatabase(fileObj, table_name, conditions);
		}
		
		fileObj = window.opener.getFileObjectFromPath(searchDbPath);
		table_name = "CDP_Master";
		window.opener.deleteAllRowsFromTable(fileObj,table_name);
		table_name = "CDP_Info";
		window.opener.deleteAllRowsFromTable(fileObj,table_name);
		table_name = "ContentSearch";
		window.opener.deleteAllRowsFromTable(fileObj,table_name);
		table_name = "ACOCDP_Relation";
		window.opener.deleteAllRowsFromTable(fileObj,table_name);
		
		// fileObj = window.opener.getFileObjectFromPath(cdpDbPath);
		// window.opener.vacuumDatabase(fileObj);
		// fileObj = window.opener.getFileObjectFromPath(searchDbPath);
		// window.opener.vacuumDatabase(fileObj);
			
		window.arguments[0].out = true;
		window.close();
	};
	
	return{
		init: init,
		init2: init2,
		removeAll: removeAll,
		removeAll2: removeAll2,
		getAcoReferences: getAcoReferences,
		removeCdpData: removeCdpData,
		removeAcoData: removeAcoData,
		removeSearchData: removeSearchData
	};
}();