/**
 * AZARDI READER AND AZARDI INTERACTIVE ENGINE EXTENSIONS
 * Copyright 2007-2012 Infogrid Pacific Pte. Ltd. All rights reserved
 * Modified Date: 2012-04-25
 * 
 * @version: 1-2012-04-25
 * @author Anup Dhabarde
 */


var CdpSearch = function(){

	/**
	 * 	Private properties and methods.
	 */
	var config = {
		lastSearchedTerm: ''
	}
	
	/**
	 * 	Public properties and methods.
	 */
	
	var documentSearch = function () {
		var items_per_page = 2000;
		//Hide the instruction panel
		$('#doc-viewer-azd').contents().find('.search_instruction').hide();
		$('#doc-viewer-azd').contents().find('#search_ins').hide();
		//Hide the page results display panel
		$('#doc-viewer-azd').contents().find('.search_result_text').hide();
		//Hide the page aco display panel
		$('#doc-viewer-azd').contents().find('.search_result_image').hide();
		$('#doc-viewer-azd').contents().find('.search-result-back-btn').click(function(){
			removeHighlightTerms();
			$('#doc-viewer-azd').contents().find('.search_result_image').hide();
			$('#doc-viewer-azd').contents().find('.search_result_text').show();
		});
		removeHighlightTerms();
		var level = $('#doc-viewer-azd').contents().find('#readingLevel :selected').val();
		//$('#doc-viewer-azd').contents().find('.search-text-azd').html("");
		var searchterm = $('#doc-viewer-azd').contents().find('#search_terms').val();
		
		config.lastSearchedTerm = searchterm;
		
		var results1 = new Array();
		if(searchterm.replace(/ /g, '') != 'AND' && searchterm.replace(/ /g, '') != 'OR' && searchterm.replace(/ /g, '') != 'NOT') {
			results1 = searchFullDoc(searchterm,"",level);
		}
		
		var resultsFound = false;
		for(var i=0; i<results1.length; i++){
			var row = results1[i];
			var cdpid = row['cdp_id'];
			var pagecount = getResultsCountForCDP(searchterm, cdpid);
			if(pagecount > 0){
				resultsFound = true;
				break;
			}
		}
		if(!resultsFound) {
		// if(results1.length==0) {
			$('#doc-viewer-azd').contents().find('.search_document .LOBT').html("");
			$('#doc-viewer-azd').contents().find('.search_document .header h2').html("No results found");
			$('#doc-viewer-azd').contents().find('.search_document').show();
			$('#doc-viewer-azd').contents().find('.search_document h3').hide();
			$('#doc-viewer-azd').contents().find('.search_document .LOBT-heading').hide();
			return;
		}
		
		var resultCount = 0;
		var booksCount = 0;
		var final_res = "";
		results1 = sortBookResults(results1, searchterm);
		for (var i=0; i< results1.length; i++) {
			row = results1[i];
			var booktpl = '<li class="book-title" id="$cdp$" title="$bt$">$bt$<span class="book-author">$ba$</span><span class="result-info">$brc$</span><span class="reading-level">$brl$</span></li>'
			var booktitle = row['title'];
			var cdpid = row['cdp_id'];
			var author = row['author'];
			var rl = getReadingLevel(cdpid);
			var snippet = booktpl;
			var pagecount = row['pagecount'];
			
			if(pagecount <= 0){
				continue;
			}
			resultCount = resultCount + pagecount;
			booksCount ++;
			var snippet = booktpl;
			snippet = snippet.replace("$cdp$", cdpid);
			snippet = snippet.replace("$bt$", booktitle);
			snippet = snippet.replace("$bt$", booktitle);
			snippet = snippet.replace("$ba$", author);
			snippet = snippet.replace("$brc$", pagecount);
			snippet = snippet.replace("$brl$", rl);
			final_res = final_res + snippet;
		}
		var resultText = 'result';
		var bookText = 'book';
		if(resultCount > 1)	resultText = 'results';
		if(booksCount > 1)	bookText = 'books';
		$('#doc-viewer-azd').contents().find('.search_document .header h2').html(resultCount + " " + resultText + " in " + booksCount + " " + bookText);
		
		if (final_res) final_res = "<ul>" + final_res + "</ul>";
		//Set the book search result to the Search div
		$('#doc-viewer-azd').contents().find('.search_document .LOBT').html(final_res);
		$('#doc-viewer-azd').contents().find('.search_document').show();
		$('#doc-viewer-azd').contents().find('.search_document h3').show();
		$('#doc-viewer-azd').contents().find('.search_document .LOBT-heading').show();
		
		//Event handler for Book click event
		$('#doc-viewer-azd').contents().find('.LOBT li').click(function(){
			var cdp_id = $(this).attr('id');
			var cdp_title = $(this).attr('title');
			var cdp_auth = $(this).find('.book-author').html();
			var cdp_reading_level = $(this).find('.reading-level').html();
			search_obj.setCDPTitle(cdp_title);
			search_obj.setCDPAuthor(cdp_auth);
			search_obj.setCDPReadingLevel(cdp_reading_level);
			//Show results for first page
			var search_results = searchFullText(searchterm, cdp_id, 1, items_per_page);
			displayPageResults(search_results, items_per_page);
		});
	}
	
	/**
	 * Function to sort the book reults according to highest pages found with matches.
	 */
	sortBookResults = function (result, searchterm) {
		var bookResult = new Array();
		for (var i=0; i<result.length; i++) {
			var temp = new Array();
			var row = result[i];
			temp['title'] = row['title'];
			var cdpid = row['cdp_id'];
			temp['cdp_id'] = cdpid;
			temp['author'] = row['author'];
			temp['pagecount'] = getResultsCountForCDP(searchterm, cdpid);
			bookResult.push(temp);
		}
		
		var columnName = 'pagecount';
		
		var resultSort = function(a, b){
			if(prepareForComparison(a[columnName]) > prepareForComparison(b[columnName])) 
	            return -1;
	        if(prepareForComparison(a[columnName]) < prepareForComparison(b[columnName])) 
	            return 1;
	        //tie breaker: name ascending is the second level sort
	        if(columnName != "title"){
	            if (prepareForComparison(a["title"]) > prepareForComparison(b["title"])) 
	                return 1;
	            if (prepareForComparison(a["title"]) < prepareForComparison(b["title"])) 
	                return -1;
	        }
	        return 0;
	    }
	
		bookResult.sort(resultSort);
		
		return bookResult;
	}
	
	prepareForComparison = function(o){
		if(typeof o == "string"){
			return o.toLowerCase();
		}
		return o;
	}
	
	/*
		function to actually display the search results.
		Sets the header block- Booktitle and total results count
		Call the createPageNavBlock to create navigation block
		Creates the search results display tags
		Initializes the event handler for showing the ACO
	*/
	displayPageResults = function(search_results, items_per_page) {
		try{
		
		$('#doc-viewer-azd').contents().find('.search_document').hide();
		
		var totalResults = search_results[1];
		var results = search_results[0];
		var cdp_title = search_obj.getCDPTitle();
		var cdp_author = search_obj.getCDPAuthor();
		
		createPageNavBlock(totalResults, items_per_page);
		if(results.length==0) {
			$('#doc-viewer-azd').contents().find('.result-book-title').html(cdp_title);
			$('#doc-viewer-azd').contents().find('.result-book-author').html(cdp_author);
			$('#doc-viewer-azd').contents().find('.result-count').html('0');
			$('#doc-viewer-azd').contents().find('.search_result_text').show();
			return;
		}else {
			$('#doc-viewer-azd').contents().find('.result-book-title').html(cdp_title);
			$('#doc-viewer-azd').contents().find('.result-book-author').html(cdp_author);
			$('#doc-viewer-azd').contents().find('.result-count').html(totalResults);
			$('#doc-viewer-azd').contents().find('.search_result_text').show();
		}
		
		//Empty the Results div first
		var div = $('#doc-viewer-azd').contents().find('.results-item').html("");
			
		for (var i=0; i< results.length ; i++) {
			var resultitem_tpl = '<p style="margin-bottom: 0px;" id="$acoid$"><span class="page-info">Page: <span class="page-result-no">$rpn$</span></span>$snippet$</p>';
			row = results[i];
			var acoid = row['aco_id'];
			var rpn = row['rpn'];
			var snippet = row['snippet(ContentSearch)'];
			var ri = resultitem_tpl.replace("$snippet$", snippet);
			ri = ri.replace("$rpn$", rpn);
			ri = ri.replace("$acoid$", acoid);
			
			var div = $('#doc-viewer-azd').contents().find('.results-item').html();
			ri = div + ri;
			$('#doc-viewer-azd').contents().find('.results-item').html(ri);
			
			$('#doc-viewer-azd').contents().find('.results-item p').click( function() {
				var acoId = $(this).attr('id');
				var rpn = $(this).find(".page-result-no").text();
				search_obj.setACOId(acoId);
				search_obj.setRPN(rpn);
				displayAco(acoId);
			});
		}
		} catch (e) {
			alert(e);
		}
	}
	
	//A object to store the state of search to be shared accross page navigation
	search_obj  = function(){
		var curr_search_term = "";
		var cdpuid = "";
		var cdptitle = "";
		var cdpauthor = "";
		var cdpReadingLevel = "";
		var acoId = "";
		var rpn = "";
		return {
			setSearchTerm: function(st){
				curr_search_term  = st;
			},
			
			getSearchTerm: function(st){
				return (curr_search_term);
			},
			
			setCDPuid: function(st){
				cdpuid  = st;
			},
			
			getCDPuid: function(st){
				return (cdpuid);
			},
			
			setCDPTitle: function(t) {
				cdptitle = t;
			},
			
			setCDPAuthor: function(t) {
				cdpauthor = t;
			},
			
			getCDPTitle: function() {
				return cdptitle;
			},
			
			getCDPAuthor: function() {
				return cdpauthor;
			},
			
			setCDPReadingLevel: function(t) {
				cdpReadingLevel = t;
			},
			
			getCDPReadingLevel: function() {
				return cdpReadingLevel;
			},
			
			setACOId: function (t){
				acoId = t;
			},
			
			getACOId: function (){
				return acoId;
			},
			
			setRPN: function (t){
				rpn = t;
			},
			
			getRPN: function (){
				return rpn;
			}
		}
	}();
	
	/*
		Function to display the page navigation block [1 2 3]
		<span class="search-nav-page">1</span>
	*/
	createPageNavBlock = function (total_results, items_per_page) {
		return;
		try {
			var totalpages = Math.abs(total_results/items_per_page);
			var nav_string = "";
			//Create the Page Nav html and insert it into the main app
			//<div class="search-text-nav"><span class="search-nav-page">1</span></div>
			for (var i =0; i<totalpages;i++) {
				var page = "<span class=\"search-nav-page\">" + (i+1) + "</span>";
				nav_string = nav_string + page;
			}
			var div = $('#doc-viewer-azd').contents().find('.search-text-nav').html(nav_string);
			
			//EVENT Handler For Click on Pages
			$('#doc-viewer-azd').contents().find('.search-text-nav .search-nav-page').click(function(){
				var pagenum = $(this).text();
				//First reset the selected class on the previous page 
				$('#doc-viewer-azd').contents().find('.search-text-nav .selected').removeClass("selected");
				//Set this page as selected
				$(this).addClass("selected");
				//Get the values stored in the search object
				var searchterm = search_obj.getSearchTerm();
				var cdp_id = search_obj.getCDPuid();
				var cdp_title = search_obj.getCDPTitle();
				//Run the search for the current selected page
				var search_results = searchFullText(searchterm, cdp_id, parseInt(pagenum), items_per_page);
				displayPageResults(search_results, items_per_page);
			});
		} catch (e) {
			alert(e);
		}
	}
	
	//Function to run the search on the CDP MAster table to return the matching books
	//Runs the Content match query on CDP_Master table and also joins the cdp_info table
	//to filter the results based on category
	searchFullDoc = function(searchterm, cdpuid,level) {
		try {
			search_obj.setSearchTerm(searchterm);
			search_obj.setCDPuid(cdpuid);
			//Load the database file as a object
			var fileObj = getFileObject(AME.getSearchDbFilePath());
			
			//Now open the sqlite database as 
			var storageService = Components.classes["@mozilla.org/storage/service;1"].getService(Components.interfaces.mozIStorageService);  
			var mDBConn = storageService.openDatabase(fileObj);
			
			var sql =  'SELECT  title, author, cdp_id FROM CDP_Master JOIN CDP_Info ON CDP_Info.cdpid = CDP_Master.cdp_id  ';
			
			searchterm = searchterm.replace(/'/g,"'\'");
			if (level== "All") {
			   sql = sql +  "  WHERE cdp_content MATCH \'" + searchterm + '\'';
			   sql = sql +  "  AND key LIKE 'level_one' " ;
			} else {
			   sql = sql +  "  WHERE cdp_content MATCH \'" + searchterm + '\'';
			   sql = sql +  "  AND key LIKE 'level_one' AND value LIKE \'" + level + '\'';
			}
			
			var statement = mDBConn.createStatement(sql);
			
			try {
				statement.execute();
				
				var results1 = [];
				while (statement.executeStep()) {
					var row = [];
					
					//	Only include a book in search results if it is not expired.
					if($.inArray(statement.row.cdp_id, Catalog.config.expiredBooks) == -1){
						for (var i=0, k = statement.columnCount;i<k;i++){
							row[statement.getColumnName(i)] = statement.getUTF8String(i); 
						}
						results1.push(row);
					} 
				}
				
			}
			catch(e) {
				alert(e);
			}
			
			statement.finalize();
			mDBConn.close();
			
			return results1; 
		} catch (e) {
			alert(e);
		}
	}
	
	//Function to query the content search table to get the pages in a book
	//Queries the contentsearch table AND for a specific CDP
	//Take page as input and returns items_per_page for that page
	searchFullText = function(searchterm, cdpuid, page, items_per_page){
		try {
			search_obj.setSearchTerm(searchterm);
			search_obj.setCDPuid(cdpuid);
			//Load the database file as a object
			var fileObj = getFileObject(AME.getSearchDbFilePath());
			
			//Now open the sqlite database as 
			var storageService = Components.classes["@mozilla.org/storage/service;1"].getService(Components.interfaces.mozIStorageService);  
			var mDBConn = storageService.openDatabase(fileObj);
			
			var sql =  'SELECT  aco_id,rpn,snippet(ContentSearch) FROM ContentSearch  ';

			searchterm = searchterm.replace(/'/g,"'\'");
			
			if (cdpuid) {
				 sql = sql + ' WHERE search_content MATCH \'' + searchterm + '\'';
				 sql = sql + ' AND cdp_id LIKE \'' + cdpuid + '\'';
			} else {
				sql = sql +  " WHERE search_content MATCH \'" + searchterm + '\'';
			}

			var statement = mDBConn.createStatement(sql);
			
			try {
				statement.execute();
				
				var results = [];
				while (statement.executeStep()) {
					var row = [];
					
					for (var i=0, k = statement.columnCount;i<k;i++){
						row[statement.getColumnName(i)] = statement.getUTF8String(i); 
					}
					results.push(row); 
				}
			}
			catch(e) {
				alert(e);
			}
			statement.finalize();
			mDBConn.close();
			
			//Calculate the start row for the current page
			var startindex = (page - 1) * items_per_page;
			var endindex = (startindex + items_per_page);
			
			//Adjust the endindex if we are looking at the last page
			if (endindex > results.length) {
				endindex = results.length;
			}
			var pageResults = [];
			for (var i=startindex; i<endindex; i++) {
				pageResults.push(results[i]);
			}
			//Return the pageresults and total results count
			return [pageResults, results.length]; 
		} catch (e) {
			alert(e);
			return [[], 0]; 
		}
	}
	
	//Function to query the content search table to get the pages in a book
	//Queries the contentsearch table AND for a specific CDP
	//Take page as input and returns items_per_page for that page
	getResultsCountForCDP = function(searchterm, cdpuid){
		try {
			search_obj.setSearchTerm(searchterm);
			search_obj.setCDPuid(cdpuid);
			//Load the database file as a object
			var fileObj = getFileObject(AME.getSearchDbFilePath());
			
			//Now open the sqlite database as 
			var storageService = Components.classes["@mozilla.org/storage/service;1"].getService(Components.interfaces.mozIStorageService);  
			var mDBConn = storageService.openDatabase(fileObj);
			
			var sql =  'SELECT  aco_id,rpn,snippet(ContentSearch) FROM ContentSearch  ';

			searchterm = searchterm.replace(/'/g,"'\'");
			
			if (cdpuid) {
				 sql = sql + ' WHERE search_content MATCH \'' + searchterm + '\'';
				 sql = sql + ' AND cdp_id LIKE \'' + cdpuid + '\'';
			} else {
				sql = sql +  " WHERE search_content MATCH \'" + searchterm + '\'';
			}
			
			var statement = mDBConn.createStatement(sql);
			
			try {
				statement.execute();
				
				var results = [];
				while (statement.executeStep()) {
					var row = [];
					
					for (var i=1230, k = statement.columnCount;i<k;i++){
						row[statement.getColumnName(i)] = statement.getUTF8String(i); 
					}
					results.push(row); 
				}
			}
			catch(e) {
				alert(e);
			}
			statement.finalize();
			mDBConn.close();
			
			//Return the pageresults and total results count
			return  results.length; 
		} catch (e) {
			alert(e);
			return 0; 
		}
	}
	
	getReadingLevel = function(cdpuid){
		try {
			//Load the database file as a object
			var fileObj = getFileObject(AME.getSearchDbFilePath());
			
			//Now open the sqlite database as 
			var storageService = Components.classes["@mozilla.org/storage/service;1"].getService(Components.interfaces.mozIStorageService);  
			var mDBConn = storageService.openDatabase(fileObj);
			
			var sql =  'SELECT  key, value FROM CDP_Info WHERE cdpid= \''+ cdpuid +'\'; ';

			
			var statement = mDBConn.createStatement(sql);
			var l1 = ""
			var oup = ""
			try {
				var results = [];
				while (statement.executeStep()) {
					var value = statement.row.value;
					var key = statement.row.key;
					if (key == "level_one") l1 = value;
					if (key == "oup") oup = "(" + value + ")";
					
				}
			}
			catch(e) {
				alert(e);
			}
			statement.finalize();
			mDBConn.close();
			
			//Return the pageresults and total results count
			return  l1 + oup; 
		} catch (e) {
			alert(e);
			return ""; 
		}
	}
	
	displayAco = function (acoId) {
		try{
			$('#doc-viewer-azd').contents().find('.search_result_text').hide();
			acoId = acoId;
			//Load the database file as a object
			var fileObj = getFileObject(AME.getCdpDbFilePath());
			if (!fileObj.exists()) {
				$('#doc-viewer-azd').contents().find('.search_result_text').show();
				return;
			}
			
			var storageService = Components
				.classes["@mozilla.org/storage/service;1"]
				.getService(Components.interfaces.mozIStorageService);
			
			conObject = storageService.openDatabase(fileObj);
			var rows = new Array();
			var data = new Array();
			
			if(conObject != ""){
				var statement = conObject.createStatement('SELECT file_content, filename FROM ACO_Images WHERE aco_id=?1');
				statement.bindStringParameter(0, acoId);
				
				var mystatus = statement.executeAsync({
					handleResult: function(aResultSet){
			 			var i = 0;
		     			for (row = aResultSet.getNextRow();   row; row = aResultSet.getNextRow()){
		        			rows[i] = row;
		        			data['file_content'] = rows[i].getResultByName('file_content');
		        			data['filename'] = rows[i].getResultByName('filename');
		        			++i;
		     			}
		  			},
		                
		  			handleError: function(anError){
		  				conObject.close();
						statement.finalize();
						var msg = getPropertiesString("azd_cdp_search_pageNotFound");
						alert(msg);
		     			$('#doc-viewer-azd').contents().find('.search_result_text').show();
						return;
		  			},
		
		  			handleCompletion: function(aReason){
		     			if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED){
		          			var msg = getPropertiesString("azd_cdp_search_pageNotFound");
							alert(msg);
		          			$('#doc-viewer-azd').contents().find('.search_result_text').show();
							return;
		     			}
		     			else{
		     				var imageDataUri = byteToDataUri(data['file_content'], data['filename']);
		     				$('#doc-viewer-azd').contents().find('.page-image-aco img').attr('src', imageDataUri);
		     				$('#doc-viewer-azd').contents().find('.page-image-aco img').bind('load', function () {
		     					highlightResults(acoId);
		     					$('#doc-viewer-azd').contents().find('.page-image-aco img').unbind('load');
		     				});
		     				var cdpTitle = search_obj.getCDPTitle();
		     				var cdpAuthor = search_obj.getCDPAuthor();
		     				var cdpReadingLevel = search_obj.getCDPReadingLevel();
		     				$('#doc-viewer-azd').contents().find('.title-block h1').html(cdpTitle);
		     				$('#doc-viewer-azd').contents().find('.title-block .author').html(cdpAuthor);
		     				$('#doc-viewer-azd').contents().find('.title-block .reading_level').html(cdpReadingLevel);
		     				$('#doc-viewer-azd').contents().find('.search_result_image').show();
		     				// highlightResults(acoId);
		     				return;
		     			}
		          		conObject.close();
						statement.finalize();
		  			}
				});
			}
			statement.finalize();
		}
		catch(e){
			// alert(e);
			$('#doc-viewer-azd').contents().find('.search_result_text').show();
			return;
		}
	}
	
	byteToDataUri = function (data, imageName) {
		var stringfromByteArray = "";
		for (var i=0; i<data.length ; i++){ 
			stringfromByteArray += String.fromCharCode(data[i]);
		}
		var ext = imageName.split('.').pop();
		var dataUri = '';
		switch(ext) {
			case 'png':
				dataUri = 'data:image/png;base64,';
			  	break;
			case 'jpe':
		 	case 'jpeg':
			case 'jpg':
				dataUri = 'data:image/jpeg;base64,'
			  	break;
			default:
		}
	
		dataUri = "data:image/png;base64," + btoa(stringfromByteArray);
		return dataUri;
	}
	
	getACOCordinates = function(acoId) {
		
	}
	
	//Main function to highlight the search term
	highlightResults = function(acoId){
		acoId = search_obj.getACOId();
		var user_st = search_obj.getSearchTerm();
		var termlist = preProcessSearchTerm(user_st);
		
		var fileObj = getFileObject(AME.getCdpDbFilePath());
		var values = ['search_coordinate'];
		var tableName = 'ACO_Master';
		var conditions = new Array(['aco_id', acoId, 'TEXT']);
		var statement = getValuesFromDatabase(fileObj, values, tableName, conditions);
		var data = new Array();
		while(statement.executeStep()){
			data['search_coordinate'] = statement.row.search_coordinate;
		}
		statement.finalize();
		
		t = data['search_coordinate'];
		t = t.replace(/\\/g, "");
		
		var coords =JSON.parse(t);
		
		//Get the image width and height
		var image_w = coords['dimensions'][0];
		var image_h = coords['dimensions'][1];
		
		allterms = coords['words'];
		
		for (var j = 0; j < termlist.length;j++) {
			var st = termlist[j];
			if (st) {
				//If the words exists in the coordinates object
				if (allterms.hasOwnProperty(st) ) {
					//first highlight the term
					highlightResultsOnImage(image_w, image_h, allterms, st);
					//Then highlight all the stem words of the search term
					handleStemResultsHighlight(image_w, image_h, allterms, st);
				} else {
					//the search term itself might not be there on the page
					//so we look for stems and highlight them
					handleStemResultsHighlight(image_w, image_h, allterms, st);
				}
			}
		}
	}
	
	//Remove the Search Control words and turn phrase into normal words
	preProcessSearchTerm = function(searchTerm) {
		var s = searchTerm;
		s = s.replace(/AND/g, "");
		s = s.replace(/OR/g, "");
		s = s.replace(/NOT/g, "");
		s = s.replace(/\"/g, "");
		s = s.toLowerCase();
		sl = s.split(" ");
		return sl;
	}
	
	//Higlight on image
	//image_w - width of image
	//image_h - height of image
	//allterms - object of terms and their boxs
	//st - search term
	highlightResultsOnImage = function(image_w, image_h, allterms, st){
		var boxs = allterms[st];
		for (var i=0;i<boxs.length;i++){
			var box = boxs[i][0];
			var textpos = boxs[i][1];
			highlightTermOnImage(image_w, image_h, st, box, textpos);
		}
	}
	
	String.prototype.startsWith = function(str){
	    return (this.indexOf(str) === 0);
	}
	
	String.prototype.endsWith = function(pattern) {
	    var d = this.length - pattern.length;
	    return d >= 0 && this.lastIndexOf(pattern) === d;
	};

	//Function first gets the stem of the search word using the stemmer object defined in porter.js
	//It then finds the stem words in the words object and highlights them
	//Eg This is to highlight look, looked when search term is looking
	handleStemResultsHighlight = function (image_w, image_h, allterms, st) {
		var stem = stemmer(st);
		// dump('\nstem==='+stem+'\n')
		for (term in allterms){
			// dump(term+'\n')
			var fi = term.startsWith(stem);
			var ew = term.endsWith(st);
			if (fi || ew) {
				highlightResultsOnImage(image_w, image_h, allterms, term);
			}
		}
	}
	
	//Actual function to display a highlight div
	highlightTermOnImage = function (image_w, image_h, term, box, testpos) {
		//Get the viewport positon and dimensions
		var viewport = $('#doc-viewer-azd').contents().find(".page-image-aco").position();
		var viewport_h = $('#doc-viewer-azd').contents().find(".page-image-aco").height();
		var viewport_w = $('#doc-viewer-azd').contents().find(".page-image-aco").width();
		
		var w_p = (viewport_w * 1.0)/image_w;
		var h_p = (viewport_h * 1.0)/image_h;
		
		//Calculate the position of the box within the viewport
		var left = (box[0]*w_p) - 4;
		var top = (box[1]*h_p) - 8;
		var width = (box[2]*w_p) + 8;
		var height = (box[3]*h_p) + 10;
		
		//Create a empty div with the position styles set to 
		//display highlight over the search term
		var d = $("<div></div>").css(
			{
			  "position":"absolute",
			  "left":left + 'px',
			  "top":top + 'px',
			  "width":width + 'px',
			  "height":height + 'px',
			  "background-color": "rgba(0, 255, 255, 0.3)"
			}).addClass('highlight-term');
		//Append the div to the body
		$('#doc-viewer-azd').contents().find('.page-image-aco').append(d);
	}
	
	removeHighlightTerms = function () {
		$('#doc-viewer-azd').contents().find('.highlight-term').remove();
	}
	
	goToReadingMode = function (type) {
		var cdp_id = search_obj.getCDPuid();
		if(type == 'page'){
			var rpn = search_obj.getRPN();
		}
		var bookLocation = getFileObject(AME.getCdpDbFilePath());
		$('#doc-viewer-azd').bind('DOMContentLoaded', function(e){
			if(type == 'page'){
				Azd.load(bookLocation.path, cdp_id, rpn);
			}
			else{
				Azd.load(bookLocation.path, cdp_id);
			}
			
			$('#doc-viewer-azd').unbind('DOMContentLoaded');
		});
		
		$('#doc-viewer-azd').attr('src', 'html/azardi2_default_cdp_doc.html');
		config.context = 'AZD';
	}
	
	trapEnterEvent = function (event) {
		if(event.keyCode == 13){
			$('#doc-viewer-azd').contents().find('#action_search').click();
		}
	}
	
	var goToMainPage = function () {
		$('#doc-viewer-azd').contents().find('.search_result_image').hide();
		$('#doc-viewer-azd').contents().find('.search_result_text').hide();
		$('#doc-viewer-azd').contents().find('.search_document').hide();
		$('#doc-viewer-azd').contents().find('.search_instruction').show();
		$('#doc-viewer-azd').contents().find('#search_ins').show();
	}


	return{
		config: config,
		documentSearch: documentSearch,
		search_obj: search_obj,
		searchFullDoc: searchFullDoc,
		searchFullText: searchFullText,
		displayAco: displayAco,
		byteToDataUri: byteToDataUri,
		highlightResults: highlightResults,
		preProcessSearchTerm: preProcessSearchTerm,
		highlightResultsOnImage: highlightResultsOnImage,
		handleStemResultsHighlight: handleStemResultsHighlight,
		highlightTermOnImage: highlightTermOnImage,
		removeHighlightTerms: removeHighlightTerms,
		goToReadingMode: goToReadingMode,
		trapEnterEvent: trapEnterEvent,
		prepareForComparison: prepareForComparison,
		goToMainPage: goToMainPage
	}
}();
//**********************************************************







