/**
 * AZARDI READER AND AZARDI INTERACTIVE ENGINE EXTENSIONS
 * Copyright 2007-2012 Infogrid Pacific Pte. Ltd. All rights reserved
 * Modified Date: 2012-04-25
 * 
 * @version: 1-2012-04-25
 * @author Anup Dhabarde
 */

var CdpSync = function () {
	var config = {
		allAcoContent: ''
	}
	
	/**
	 * 	Function to initilize Database copy from the download book database into main azardi database.
	 */
	
	var init = function (tempDownloadPath, cdpId, fullTextSearch){
		var self = this;
		
		$('#modal_spacer').attr('height', '130');
		$('#modal_box').css('background-image', 'url("icons/azd-book-install.png")');
		document.title = window.opener.AME.getTitle();
		config.allAcoContent = '';
		setTimeout(function(){
			self.init2(tempDownloadPath, cdpId, fullTextSearch);
		}, 500);
	}
	
	var init2 = function (tempDownloadPath, cdpId, fullTextSearch) {
		var self = this;
		
		var fileObj = window.opener.getFileObjectFromPath(tempDownloadPath);
		if(!fileObj.exists()){
			window.arguments[0].out = false;
			window.close();
		}
		var destinationDb = window.opener.getFileObject(window.opener.AME.getCdpDbFilePath());
		var searchDb = window.opener.getFileObject(window.opener.AME.getSearchDbFilePath());
		
		try{
			self.copyPresentation('ACO_Presentation_css', 'ACO', tempDownloadPath, destinationDb.path);
			self.copyPresentation('ACO_Presentation_js', 'ACO', tempDownloadPath, destinationDb.path);
			self.copyPresentation('CDP_Presentation_css', 'CDP', tempDownloadPath, destinationDb.path);
			self.copyPresentation('CDP_Presentation_js', 'CDP', tempDownloadPath, destinationDb.path);
			
			self.copyAudio('ACO_Audio', 'ACO', tempDownloadPath, destinationDb.path);
			self.copyAudio('CDP_Audio', 'CDP', tempDownloadPath, destinationDb.path);
			
			self.copyVideo('ACO_Video', 'ACO', tempDownloadPath, destinationDb.path);
			self.copyVideo('CDP_Video', 'CDP', tempDownloadPath, destinationDb.path);
	
			self.copyImages('ACO_Images', 'ACO', tempDownloadPath, destinationDb.path);
			self.copyImages('CDP_Images', 'CDP', tempDownloadPath, destinationDb.path);
			
			self.copyMaster('ACO_Master', 'ACO', tempDownloadPath, destinationDb.path);
			self.copyMaster('CDP_Master', 'CDP', tempDownloadPath, destinationDb.path);
			
			self.copyProprietary('ACO_Proprietary', 'ACO', tempDownloadPath, destinationDb.path);
			self.copyProprietary('CDP_Proprietary', 'CDP', tempDownloadPath, destinationDb.path);
	 
			self.copyMetadata('CDP_Metadata', tempDownloadPath, destinationDb.path);
	 
			self.copySubscriptionmaster('Subscription_Master', tempDownloadPath, destinationDb.path);
	 
			// self.copyRafmaster('RAF_Master', tempDownloadPath, destinationDb.path);
			if(fullTextSearch) {
				self.copyMasterSyc('ACO_Master', tempDownloadPath, searchDb.path, cdpId);
			
				self.copyTitle('CDP_Master', tempDownloadPath, searchDb.path);
				
				self.copyFilter('CDP_Metadata', tempDownloadPath, searchDb.path);
			}
		}
		catch(e){
			window.arguments[0].out = false;
			window.close();
			return;
		}
		
		window.opener.Catalog.writeBookStatus(cdpId, 'installed');
		try{
			window.opener.delete_Folder(tempDownloadPath);
		}
		catch(e){
			
		}
		
		window.arguments[0].out = true;
		window.close();
	}
	
	var copyPresentation = function (table_name, type, tempDownloadPath, destinationDbPath) {
		var self = this;
		
		var fileObj = window.opener.getFileObjectFromPath(tempDownloadPath);

		if (type == 'ACO') {
			var values = ['aco_id', 'filename', 'file_content'];
		}
		else if (type == 'CAT') {
			var values = ['id', 'cat_id', 'filename', 'file_content'];
		}
		else {
			var values = ['id', 'cdp_id', 'filename', 'file_content'];
		}

		var statement = window.opener.getValuesFromDatabase(fileObj, values, table_name);
		
		if(!statement) {
			throw new Error("Database corrupted.");
		}
		var presentationData = new Array();
		while (statement.executeStep()) {
			var data = new Array();
			if (type == 'ACO') {
				data.push(statement.row.aco_id);
			}
			else if (type == 'CAT') {
				data.push(statement.row.cat_id);
			}
			else {
				data.push(statement.row.cdp_id);
			}

			data.push(statement.row.filename);
			data.push(statement.row.file_content);

			presentationData.push(data);
			self.movePresentation(data, type, table_name, destinationDbPath);
		}
		statement.finalize();
	}

	var movePresentation = function (data, type, table_name, destinationDbPath) {

		var fileObj = window.opener.getFileObjectFromPath(destinationDbPath);

		if (type == 'ACO') {
			var values = new Array(['aco_id', data[0], 'TEXT'],
								   ['filename', data[1], 'TEXT'],
								   ['file_content', data[2], 'TEXT']);

			window.opener.insertRowIntoDatabase(fileObj, values, table_name);
		}
		else if (type == 'CAT') {
			var values = new Array(['cat_id', data[0], 'TEXT'],
								   ['filename', data[1], 'TEXT'],
								   ['file_content', data[2], 'TEXT']);

			window.opener.insertRowIntoDatabase(fileObj, values, table_name);
		}
		else {
			var values = new Array(['cdp_id', data[0], 'TEXT'],
								   ['filename', data[1], 'TEXT'],
								   ['file_content', data[2], 'TEXT']);

			window.opener.insertRowIntoDatabase(fileObj, values, table_name);
		}
	}
	
	var copyAudio = function (table_name, type, tempDownloadPath, destinationDbPath) {
		var self = this;
		
		var fileObj = window.opener.getFileObjectFromPath(tempDownloadPath);
		if (!fileObj.exists()) {
			throw new Error("Database corrupted.")
		}

		var storageService = Components
							.classes["@mozilla.org/storage/service;1"]
							.getService(Components.interfaces.mozIStorageService);

		conObject = storageService.openDatabase(fileObj);
		var rows = new Array();

		if(conObject != "") {
			if(type == 'ACO') {
				var statement = conObject.createStatement('SELECT aco_id, MIME_type, filename, file_content FROM ACO_Audio ');
				var mystatus = statement.executeAsync({
					handleResult: function(aResultSet) {
						var i = 0;
						for (row = aResultSet.getNextRow(); row; row = aResultSet.getNextRow()) {
							var data = new Array();
							rows[i] = row;

							data['aco_id'] = rows[i].getResultByName('aco_id');
							data['MIME_type'] = rows[i].getResultByName('MIME_type');
							data['filename'] = rows[i].getResultByName('filename');
							data['file_content'] = rows[i].getResultByName('file_content');
							++i;
							self.moveAudio(data, table_name, type, destinationDbPath);
						}
					},
					handleError: function(anError) {
						conObject.close();
						statement.finalize();
						throw new Error("Database corrupted.")
					},
					handleCompletion: function(aReason) {
						if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED) {
							throw new Error("Database corrupted.")
						}
						else {
						}
						conObject.close();
						statement.finalize();
					}
				});
			}
			else if(type == 'CAT') {

				var statement = conObject.createStatement('SELECT cat_id, MIME_type, filename, file_content FROM CAT_Audio ');
				var mystatus = statement.executeAsync({
					handleResult: function(aResultSet) {
						var i = 0;
						for (row = aResultSet.getNextRow(); row; row = aResultSet.getNextRow()) {
							var data = new Array();
							rows[i] = row;

							data['cat_id'] = rows[i].getResultByName('cat_id');
							data['MIME_type'] = rows[i].getResultByName('MIME_type');
							data['filename'] = rows[i].getResultByName('filename');
							data['file_content'] = rows[i].getResultByName('file_content');
							++i;
							self.moveAudio(data, table_name, type, destinationDbPath);
						}
					},
					handleError: function(anError) {
						conObject.close();
						statement.finalize();
						throw new Error("Database corrupted.")
					},
					handleCompletion: function(aReason) {
						if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED) {
							throw new Error("Database corrupted.")
						} else {
						}
						conObject.close();
						statement.finalize();
					}
				});
			}
			else {

				var statement = conObject.createStatement('SELECT cdp_id, MIME_type, filename, file_content FROM CDP_Audio ');
				var mystatus = statement.executeAsync({
					handleResult: function(aResultSet) {
						var i = 0;
						for (row = aResultSet.getNextRow();   row; row = aResultSet.getNextRow()) {
							var data = new Array();
							rows[i] = row;

							data['cdp_id'] = rows[i].getResultByName('cdp_id');
							data['MIME_type'] = rows[i].getResultByName('MIME_type');
							data['filename'] = rows[i].getResultByName('filename');
							data['file_content'] = rows[i].getResultByName('file_content');
							++i;
							self.moveAudio(data, table_name, type, destinationDbPath);
						}
					},
					handleError: function(anError) {
						conObject.close();
						statement.finalize();
						throw new Error("Database corrupted.")
					},
					handleCompletion: function(aReason) {
						if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED) {
							throw new Error("Database corrupted.")
						} else {
						}
						conObject.close();
						statement.finalize();
					}
				});
			}
		}
	}

	var moveAudio = function(data, table_name, type, destinationDbPath) {
		var self = this;
	
		var fileObj = window.opener.getFileObjectFromPath(destinationDbPath);

		if (!fileObj.exists()) {
			throw new Error("Database corrupted.")
		}
		
		var values;

		if( type == 'ACO') {

			values = new Array(['aco_id', data["aco_id"], 'TEXT'],
									['MIME_type', data["MIME_type"], 'TEXT'],
									['filename', data["filename"], 'TEXT'],
									['file_content', data["file_content"], 'BLOB']);

		} else if( type == 'CAT') {

			values = new Array(['cat_id', data["cat_id"], 'TEXT'],
									['MIME_type', data["MIME_type"], 'TEXT'],
									['filename', data["filename"], 'TEXT'],
									['file_content', data["file_content"], 'BLOB']);

		} else {

			values = new Array(['cdp_id', data["cdp_id"], 'TEXT'],
									['MIME_type', data["MIME_type"], 'TEXT'],
									['filename', data["filename"], 'TEXT'],
									['file_content', data["file_content"], 'BLOB']);

		}
		window.opener.insertRowIntoDatabase(fileObj, values, table_name);
	}
	
	var copyVideo = function(table_name, type, tempDownloadPath, destinationDbPath) {
		var self = this;

		var fileObj = window.opener.getFileObjectFromPath(tempDownloadPath);
		if (!fileObj.exists()) {
			throw new Error("Database corrupted.")
		}

		var storageService = Components
							.classes["@mozilla.org/storage/service;1"]
							.getService(Components.interfaces.mozIStorageService);

		conObject = storageService.openDatabase(fileObj);
		var rows = new Array();

		if(conObject != "") {
			if(type == 'ACO') {
				var statement = conObject.createStatement('SELECT  aco_id, MIME_type, filename, file_content FROM ACO_Video ');
				var mystatus = statement.executeAsync({
					handleResult: function(aResultSet) {
						var i = 0;
						for (row = aResultSet.getNextRow(); row; row = aResultSet.getNextRow()) {
							var data = new Array();
							rows[i] = row;

							data['aco_id'] = rows[i].getResultByName('aco_id');
							data['MIME_type'] = rows[i].getResultByName('MIME_type');
							data['filename'] = rows[i].getResultByName('filename');
							data['file_content'] = rows[i].getResultByName('file_content');
							++i;
							self.moveVideo(data, table_name, type, destinationDbPath);
						}
					},
					handleError: function(anError) {
						conObject.close();
						statement.finalize();
						throw new Error("Database corrupted.")
					},
					handleCompletion: function(aReason) {
						if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED) {
							throw new Error("Database corrupted.")
						} else {
						}
						conObject.close();
						statement.finalize();
					}
				});
			}
			else if(type == 'CAT') {

				var statement = conObject.createStatement('SELECT cat_id, MIME_type, filename, file_content FROM CAT_Video ');
				var mystatus = statement.executeAsync({
					handleResult: function(aResultSet) {
						var i = 0;
						for (row = aResultSet.getNextRow();   row; row = aResultSet.getNextRow()) {
							var data = new Array();
							rows[i] = row;

							data['cat_id'] = rows[i].getResultByName('cat_id');
							data['MIME_type'] = rows[i].getResultByName('MIME_type');
							data['filename'] = rows[i].getResultByName('filename');
							data['file_content'] = rows[i].getResultByName('file_content');
							++i;
							self.moveVideo(data, table_name, type, destinationDbPath);
						}
					},
					handleError: function(anError) {
						conObject.close();
						statement.finalize();
						throw new Error("Database corrupted.")
					},
					handleCompletion: function(aReason) {
						if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED) {
							throw new Error("Database corrupted.")
						} else {
						}
						conObject.close();
						statement.finalize();
					}
				});
			}
			else {

				var statement = conObject.createStatement('SELECT cdp_id, MIME_type, filename, file_content FROM CDP_Video ');
				var mystatus = statement.executeAsync({
					handleResult: function(aResultSet) {
						var i = 0;
						for (row = aResultSet.getNextRow();   row; row = aResultSet.getNextRow()) {
							var data = new Array();
							rows[i] = row;

							data['cdp_id'] = rows[i].getResultByName('cdp_id');
							data['MIME_type'] = rows[i].getResultByName('MIME_type');
							data['filename'] = rows[i].getResultByName('filename');
							data['file_content'] = rows[i].getResultByName('file_content');
							++i;
							self.moveVideo(data, table_name, type, destinationDbPath);
						}
					},
					handleError: function(anError) {
						conObject.close();
						statement.finalize();
						throw new Error("Database corrupted.")
					},
					handleCompletion: function(aReason) {
						if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED) {
							throw new Error("Database corrupted.")
						} else {
						}
						conObject.close();
						statement.finalize();
					}
				});
			}

		}
	}

	var moveVideo = function (data, table_name, type, destinationDbPath) {
		var self = this;
		
		var fileObj = window.opener.getFileObjectFromPath(destinationDbPath);
		if (!fileObj.exists()) {
			throw new Error("Database corrupted.")
		}
		if( type == 'ACO') {
			var values = new Array(['aco_id', data["aco_id"], 'TEXT'],
									['MIME_type', data["MIME_type"], 'TEXT'],
									['filename', data["filename"], 'TEXT'],
									['file_content', data["file_content"], 'BLOB']);
			window.opener.insertRowIntoDatabase(fileObj, values, table_name);
		} else if( type == 'CAT') {
			var values = new Array( ['cat_id', data["cat_id"], 'TEXT'],
									['MIME_type', data["MIME_type"], 'TEXT'],
									['filename', data["filename"], 'TEXT'],
									['file_content', data["file_content"], 'BLOB']);
			window.opener.insertRowIntoDatabase(fileObj, values, table_name);
		} else {
			var values = new Array(['cdp_id', data["cdp_id"], 'TEXT'],
									['MIME_type', data["MIME_type"], 'TEXT'],
									['filename', data["filename"], 'TEXT'],
									['file_content', data["file_content"], 'BLOB']);
			window.opener.insertRowIntoDatabase(fileObj, values, table_name);
		}
	}
	
	var copyImages = function(table_name, type, tempDownloadPath, destinationDbPath) {
		var self = this;
		
		var fileObj = window.opener.getFileObjectFromPath(tempDownloadPath);
		if (!fileObj.exists()) {
			throw new Error("Database corrupted.")
		}

		var storageService = Components
							.classes["@mozilla.org/storage/service;1"]
							.getService(Components.interfaces.mozIStorageService);

		conObject = storageService.openDatabase(fileObj);
		var rows = new Array();

		if(conObject != "") {
			if(type == 'ACO') {
				var statement = conObject.createStatement('SELECT  aco_id, MIME_type, filename, file_content FROM ACO_Images ');
				var mystatus = statement.executeAsync({
					handleResult: function(aResultSet) {
						var i = 0;
						for (row = aResultSet.getNextRow();   row; row = aResultSet.getNextRow()) {
							var data = new Array();
							rows[i] = row;

							data['aco_id'] = rows[i].getResultByName('aco_id');
							data['MIME_type'] = rows[i].getResultByName('MIME_type');
							data['filename'] = rows[i].getResultByName('filename');
							data['file_content'] = rows[i].getResultByName('file_content');
							++i;
							self.moveImages(data, table_name, type, destinationDbPath);
						}
					},
					handleError: function(anError) {
						conObject.close();
						statement.finalize();
						throw new Error("Database corrupted.")
					},
					handleCompletion: function(aReason) {
						if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED) {
							throw new Error("Database corrupted.")
						} else {
						}
						conObject.close();
						statement.finalize();
					}
				});
			} else if(type == 'CAT') {
				var statement = conObject.createStatement('SELECT cat_id, MIME_type, filename, file_content FROM CAT_Images ');
				var mystatus = statement.executeAsync({
					handleResult: function(aResultSet) {
						var i = 0;
						for (row = aResultSet.getNextRow();   row; row = aResultSet.getNextRow()) {
							var data = new Array();
							rows[i] = row;

							data['cat_id'] = rows[i].getResultByName('cat_id');
							data['MIME_type'] = rows[i].getResultByName('MIME_type');
							data['filename'] = rows[i].getResultByName('filename');
							data['file_content'] = rows[i].getResultByName('file_content');
							++i;
							self.moveImages(data, table_name, type, destinationDbPath);
						}
					},
					handleError: function(anError) {
						conObject.close();
						statement.finalize();
						throw new Error("Database corrupted.")
					},
					handleCompletion: function(aReason) {
						if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED) {
							throw new Error("Database corrupted.")
						} else {
						}
						conObject.close();
						statement.finalize();
					}
				});
			} else {

				var statement = conObject.createStatement('SELECT cdp_id, MIME_type, filename, file_content FROM CDP_Images ');
				var mystatus = statement.executeAsync({
					handleResult: function(aResultSet) {
						var i = 0;
						for (row = aResultSet.getNextRow();   row; row = aResultSet.getNextRow()) {
							var data = new Array();
							rows[i] = row;

							data['cdp_id'] = rows[i].getResultByName('cdp_id');
							data['MIME_type'] = rows[i].getResultByName('MIME_type');
							data['filename'] = rows[i].getResultByName('filename');
							data['file_content'] = rows[i].getResultByName('file_content');
							++i;
							self.moveImages(data, table_name, type, destinationDbPath);
						}
					},
					handleError: function(anError) {
						conObject.close();
						statement.finalize();
						throw new Error("Database corrupted.")
					},
					handleCompletion: function(aReason) {
						if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED) {
							throw new Error("Database corrupted.")
						} else {
						}
						conObject.close();
						statement.finalize();
					}
				});
			}
		}
	}

	var moveImages = function (data, table_name, type, destinationDbPath) {
		var self = this;
		
		var fileObj = window.opener.getFileObjectFromPath(destinationDbPath);

		if (!fileObj.exists()) {
			throw new Error("Database corrupted.")
		}

		if( type == 'ACO') {

			var values = new Array(['aco_id', data["aco_id"], 'TEXT'],
									['MIME_type', data["MIME_type"], 'TEXT'],
									['filename', data["filename"], 'TEXT'],
									['file_content', data["file_content"], 'BLOB']);
			window.opener.insertRowIntoDatabase(fileObj, values, table_name);

		} else if( type == 'CAT') {

			var values = new Array(['cat_id', data["cat_id"], 'TEXT'],
									['MIME_type', data["MIME_type"], 'TEXT'],
									['filename', data["filename"], 'TEXT'],
									['file_content', data["file_content"], 'BLOB']);
			window.opener.insertRowIntoDatabase(fileObj, values, table_name);

		} else {

			var values = new Array(['cdp_id', data["cdp_id"], 'TEXT'],
									['MIME_type', data["MIME_type"], 'TEXT'],
									['filename', data["filename"], 'TEXT'],
									['file_content', data["file_content"], 'BLOB']);
			window.opener.insertRowIntoDatabase(fileObj, values, table_name);

		}
	}
	
	var copyMaster = function(table_name, type, tempDownloadPath, destinationDbPath) {
		var self = this;
		
		var fileObj = window.opener.getFileObjectFromPath(tempDownloadPath);
		if (type == 'ACO') {
			var values = ['aco_id','title','aco_content','aco_info','search_content','search_coordinate', 'section_type'];
		} else if (type == 'CAT') {
			var values = ['cat_id','title','description','publisher','cat_content','cat_info'];
		} else {
			var values = ['cdp_id','title','author','description','identifier','published_date','publisher','cdp_content'];
		}
		var statement = window.opener.getValuesFromDatabase(fileObj, values, table_name);
		if(!statement) {
			throw new Error("Database corrupted.")
		}
		var presentationData = new Array();
		while (statement.executeStep()) {
			var data = new Array();

			if (type == 'ACO') {
				data.push(statement.row.aco_id);
				data.push(statement.row.title);
				data.push(statement.row.aco_content);
				data.push(statement.row.aco_info);
				data.push(statement.row.search_content);
				data.push(statement.row.search_coordinate);
				data.push(statement.row.section_type);
			} else if (type == 'CAT') {
				data.push(statement.row.cat_id);
				data.push(statement.row.title);
				data.push(statement.row.description);
				data.push(statement.row.cat_content);
				data.push(statement.row.cat_info);
			} else {
				data.push(statement.row.cdp_id);
				data.push(statement.row.title);
				data.push(statement.row.author);
				data.push(statement.row.description);
				data.push(statement.row.identifier);
				data.push(statement.row.published_date);
				data.push(statement.row.publisher);
				data.push(statement.row.cdp_content);
			}

			presentationData.push(data);
			self.moveMaster(data, type, table_name, destinationDbPath);
		}
		statement.finalize();
	}
	
	var moveMaster = function(data, type, table_name, destinationDbPath) {
		var self = this;
		
		var fileObj = window.opener.getFileObjectFromPath(destinationDbPath);

		if (type == 'ACO') {

			var values = new Array(['aco_id', data[0], 'TEXT'],
			['title', data[1], 'TEXT'],
			['aco_content', data[2], 'TEXT'],
			['aco_info', data[3], 'TEXT'],
			['search_content', data[4], 'TEXT'],
			['search_coordinate', data[5], 'TEXT'],
			['section_type', data[6], 'TEXT']);

			window.opener.insertRowIntoDatabase(fileObj, values, table_name);
		} else if (type == 'CAT') {

			var values = new Array(['cat_id', data[0], 'TEXT'],
			['title', data[1], 'TEXT'],
			['description', data[2], 'TEXT'],
			['publisher', data[3], 'TEXT'],
			['cat_content', data[4], 'TEXT'],
			['cat_info', data[5], 'TEXT']);

			window.opener.insertRowIntoDatabase(fileObj, values, table_name);
		} else {

			var values = new Array(['cdp_id', data[0], 'TEXT'],
			['title', data[1], 'TEXT'],
			['author', data[2], 'TEXT'],
			['description', data[3], 'TEXT'],
			['identifier', data[4], 'TEXT'],
			['published_date', data[5], 'TEXT'],
			['publisher', data[6], 'TEXT'],
			['cdp_content', data[7], 'TEXT']);
			window.opener.insertRowIntoDatabase(fileObj, values, table_name);
		}
	}
	
	var copyProprietary = function(table_name, type, tempDownloadPath, destinationDbPath) {
		var self = this;
		
		var fileObj = window.opener.getFileObjectFromPath(tempDownloadPath);
		if (!fileObj.exists()) {
			throw new Error("Database corrupted.")
		}

		var storageService = Components
							.classes["@mozilla.org/storage/service;1"]
							.getService(Components.interfaces.mozIStorageService);

		conObject = storageService.openDatabase(fileObj);
		var rows = new Array();

		if(conObject != "") {

			if(type == 'ACO') {

				var statement = conObject.createStatement('SELECT aco_id, MIME_type, filename, file_content FROM ACO_Proprietary ');
				var mystatus = statement.executeAsync({
					handleResult: function(aResultSet) {
						var i = 0;
						for (row = aResultSet.getNextRow();   row; row = aResultSet.getNextRow()) {
							var data = new Array();
							rows[i] = row;
							data['aco_id'] = rows[i].getResultByName('aco_id');
							data['MIME_type'] = rows[i].getResultByName('MIME_type');
							data['filename'] = rows[i].getResultByName('filename');
							data['file_content'] = rows[i].getResultByName('file_content');
							++i;
							self.moveProprietary(data, table_name, type, destinationDbPath);
						}
					},
					handleError: function(anError) {
						conObject.close();
						statement.finalize();
						throw new Error("Database corrupted.")
					},
					handleCompletion: function(aReason) {
						if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED) {
							throw new Error("Database corrupted.")
						} else {
						}
						conObject.close();
						statement.finalize();
					}
				});
			} else if(type == 'CAT') {

				var statement = conObject.createStatement('SELECT cat_id, MIME_type, filename, file_content FROM CAT_Proprietary ');
				var mystatus = statement.executeAsync({
					handleResult: function(aResultSet) {
						var i = 0;
						for (row = aResultSet.getNextRow();   row; row = aResultSet.getNextRow()) {
							var data = new Array();
							rows[i] = row;
							data['cat_id'] = rows[i].getResultByName('cat_id');
							data['MIME_type'] = rows[i].getResultByName('MIME_type');
							data['filename'] = rows[i].getResultByName('filename');
							data['file_content'] = rows[i].getResultByName('file_content');
							++i;
							self.moveProprietary(data, table_name, type, destinationDbPath);
						}
					},
					handleError: function(anError) {
						conObject.close();
						statement.finalize();
						throw new Error("Database corrupted.")
					},
					handleCompletion: function(aReason) {
						if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED) {
							throw new Error("Database corrupted.")
						} else {
						}
						conObject.close();
						statement.finalize();
					}
				});
			} else {

				var statement = conObject.createStatement('SELECT cdp_id, MIME_type, filename, file_content FROM CDP_Proprietary ');
				var mystatus = statement.executeAsync({
					handleResult: function(aResultSet) {
						var i = 0;
						for (row = aResultSet.getNextRow();   row; row = aResultSet.getNextRow()) {
							var data = new Array();
							rows[i] = row;
							data['cdp_id'] = rows[i].getResultByName('cdp_id');
							data['MIME_type'] = rows[i].getResultByName('MIME_type');
							data['filename'] = rows[i].getResultByName('filename');
							data['file_content'] = rows[i].getResultByName('file_content');
							++i;
							self.moveProprietary(data, table_name, type, destinationDbPath);
						}
					},
					handleError: function(anError) {
						conObject.close();
						statement.finalize();
						throw new Error("Database corrupted.")
					},
					handleCompletion: function(aReason) {
						if (aReason != Components.interfaces.mozIStorageStatementCallback.REASON_FINISHED) {
							throw new Error("Database corrupted.")
						} else {
						}
						conObject.close();
						statement.finalize();
					}
				});
			}

		}
	}
	
	var moveProprietary = function(data, table_name, type, destinationDbPath) {
	
		var fileObj = window.opener.getFileObjectFromPath(destinationDbPath);
		if (!fileObj.exists()) {
			throw new Error("Database corrupted.")
		}

		if( type == 'ACO') {

			var values = new Array(['aco_id', data["aco_id"], 'TEXT'],
									['MIME_type', data["MIME_type"], 'TEXT'],
									['filename', data["filename"], 'TEXT'],
									['file_content', data["file_content"], 'BLOB']);
			window.opener.insertRowIntoDatabase(fileObj, values, table_name);

		} else if( type == 'CAT') {

			var values = new Array(   ['cat_id', data["cat_id"], 'TEXT'],
									['MIME_type', data["MIME_type"], 'TEXT'],
									['filename', data["filename"], 'TEXT'],
									['file_content', data["file_content"], 'BLOB']);
			window.opener.insertRowIntoDatabase(fileObj, values, table_name);

		} else {

			var values = new Array(   ['cdp_id', data["cdp_id"], 'TEXT'],
									['MIME_type', data["MIME_type"], 'TEXT'],
									['filename', data["filename"], 'TEXT'],
									['file_content', data["file_content"], 'BLOB']);
			window.opener.insertRowIntoDatabase(fileObj, values, table_name);
		}
	}
	
	var copyMetadata = function(table_name, tempDownloadPath, destinationDbPath) {
		var self = this;
		
		var fileObj = window.opener.getFileObjectFromPath(tempDownloadPath);
		var values = ['cdp_id','key','value'];
		var statement = window.opener.getValuesFromDatabase(fileObj, values, table_name);
		if(!statement) {
			return [];
		}
		
		while (statement.executeStep()) {
			var data = new Array();
			data.push(statement.row.cdp_id);
			data.push(statement.row.key);
			data.push(statement.row.value);
			self.moveMetadata(data, table_name, destinationDbPath);
		}
		statement.finalize();
	}
	
	var moveMetadata = function(data, table_name, destinationDbPath) {
		var self = this;
		
		var fileObj = window.opener.getFileObjectFromPath(destinationDbPath);
		var values = new Array(['cdp_id', data[0], 'TEXT'],
								['key', data[1], 'TEXT'],
								['value', data[2], 'TEXT']);

		window.opener.insertRowIntoDatabase(fileObj, values, table_name);
	}
	
	var copySubscriptionmaster = function (table_name, tempDownloadPath, destinationDbPath) {
		var self = this;
		
		var fileObj = window.opener.getFileObjectFromPath(tempDownloadPath);

		var values = ['id', 'cdp_id'];
		var statement = window.opener.getValuesFromDatabase(fileObj, values, table_name);
		if(!statement) {
			throw new Error("Database corrupted.")
		}

		while (statement.executeStep()) {
			var data = new Array();
			data.push(statement.row.cdp_id);
			
			self.moveSubscriptionmaster(data, table_name, destinationDbPath);
		}
		statement.finalize();
	}
	
	var moveSubscriptionmaster = function(data, table_name, destinationDbPath) {
		var self = this;
		
		var fileObj = window.opener.getFileObjectFromPath(destinationDbPath);
		var values = new Array(['cdp_id', data[0], 'TEXT']);

		window.opener.insertRowIntoDatabase(fileObj, values, table_name);
	}
	
	var copyRafmaster = function(table_name, tempDownloadPath, destinationDbPath) {
		var self = this;
		
		var fileObj = window.opener.getFileObjectFromPath(tempDownloadPath);
		var values = ['cdp_id','raf_key','raf_value', 'type'];
		var statement = window.opener.getValuesFromDatabase(fileObj, values, table_name);
		if(!statement) {
			throw new Error("Database corrupted.")
		}
		
		while (statement.executeStep()) {
			var data = new Array();
			data.push(statement.row.cdp_id);
			data.push(statement.row.raf_key);
			data.push(statement.row.raf_value);
			// data.push(statement.row.type);
			self.moveRafmaster(data, table_name, destinationDbPath);
		}
		statement.finalize();
	}
	
	var moveRafmaster = function(data, table_name, destinationDbPath) {
		var self = this;
	
		var fileObj = window.opener.getFileObjectFromPath(destinationDbPath);

		var values = new Array(['cdp_id', data[0], 'TEXT'],
							   ['raf_key', data[1], 'TEXT'],
							   ['raf_value', data[2], 'TEXT']//,
							   // ['type', data[3], 'TEXT']
							   );

		window.opener.insertRowIntoDatabase(fileObj, values, table_name);
	}
	
	var copyMasterSyc = function(table_name, tempDownloadPath, destinationDbPath, cdpId) {
		var self = this;
		
		var fileObj = window.opener.getFileObjectFromPath(tempDownloadPath);
		var values = ['aco_id','title','aco_content','aco_info','search_content','search_coordinate'];

		var statement = window.opener.getValuesFromDatabase(fileObj, values, table_name);
		if(!statement) {
			throw new Error("Database corrupted.")
		}
		presentationData = new Array();
		while (statement.executeStep()) {
			var data = new Array();
			var temp = '';
			data.push(statement.row.aco_id);
			data.push(statement.row.title);
			data.push(statement.row.aco_content);
			var stat= statement.row.aco_info;
			if(stat != ''){
				var my = JSON.parse(stat);
				temp = my["RPN"];
			}
			data.push(stat);
			data.push(statement.row.search_content);
			data.push(statement.row.search_coordinate);
			data.push(cdpId);
			data.push(temp);

			presentationData.push(data);
			self.moveMasterSyc(data, "ContentSearch", destinationDbPath);
		}
		statement.finalize();
	}
	
	var moveMasterSyc = function (data, table_name, destinationDbPath) {
		var self = this;
		
		var fileObj = window.opener.getFileObjectFromPath(destinationDbPath);
		var values = new Array(['aco_id', data[0], 'TEXT'],
		['title', data[1], 'TEXT'],
		['aco_content', data[2], 'TEXT'],
		['aco_info', data[3], 'TEXT'],
		['search_content', data[4], 'TEXT'],
		['search_coordinate', data[5], 'TEXT'],
		['cdp_id', data[6], 'TEXT'],
		['rpn', data[7], 'TEXT']);
		config.allAcoContent += ' '+data[4];
		window.opener.insertRowIntoDatabase(fileObj, values, table_name);
	}
	
	function copyTitle(table_name, tempDownloadPath, destinationDbPath) {
		var self = this;
		
		var fileObj = window.opener.getFileObjectFromPath(tempDownloadPath);
		var values = ['cdp_id','title','author'];
		var statement = window.opener.getValuesFromDatabase(fileObj, values, table_name);
		if(!statement) {
			throw new Error("Database corrupted.")
		}
		while (statement.executeStep()) {
			var data = new Array();
			data.push(statement.row.cdp_id);
			data.push(statement.row.title);
			data.push(statement.row.author);
			self.moveTitle(data, table_name, destinationDbPath);
		}
		statement.finalize();
	}
	
	function moveTitle(data, table_name, destinationDbPath) {
		var self = this;
		
		var fileObj = window.opener.getFileObjectFromPath(destinationDbPath);
		var values = new Array(['cdp_content', config.allAcoContent, 'TEXT'],
							   ['cdp_id', data[0], 'TEXT'],
							   ['title', data[1], 'TEXT'],
							   ['author', data[2], 'TEXT']);

		window.opener.insertRowIntoDatabase(fileObj, values, table_name);
	}
	
	var copyFilter = function (table_name, tempDownloadPath, destinationDbPath) {
		var self = this;
		
		var fileObj = window.opener.getFileObjectFromPath(tempDownloadPath);
		var values = ['cdp_id','key','value'];
		var statement = window.opener.getValuesFromDatabase(fileObj, values, table_name);
		if(!statement) {
			throw new Error("Database corrupted.")
		}
	
		while (statement.executeStep()) {
			var data = new Array();
			data.push(statement.row.cdp_id);
			data.push(statement.row.key);
			data.push(statement.row.value);
			self.moveFilter(data,"CDP_Info", destinationDbPath);
		}
		statement.finalize();
	}
	
	var moveFilter = function (data, table_name, destinationDbPath) {
		var self = this;
		
		var fileObj = window.opener.getFileObjectFromPath(destinationDbPath);
		var values = new Array(['cdpid', data[0], 'TEXT'],
							   ['key', data[1], 'TEXT'],
							   ['value', data[2], 'TEXT']);

		window.opener.insertRowIntoDatabase(fileObj, values, table_name);
	}

	return {
		config: config,
		init: init,
		init2: init2,
		copyPresentation: copyPresentation,
		movePresentation: movePresentation,
		copyAudio: copyAudio,
		moveAudio: moveAudio,
		copyVideo: copyVideo,
		moveVideo: moveVideo,
		copyImages: copyImages,
		moveImages: moveImages,
		copyMaster: copyMaster,
		moveMaster: moveMaster,
		copyProprietary: copyProprietary,
		moveProprietary: moveProprietary,
		copyMetadata: copyMetadata,
		moveMetadata: moveMetadata,
		copySubscriptionmaster: copySubscriptionmaster,
		moveSubscriptionmaster: moveSubscriptionmaster,
		copyRafmaster: copyRafmaster,
		moveRafmaster: moveRafmaster,
		copyMasterSyc: copyMasterSyc,
		moveMasterSyc: moveMasterSyc,
		copyTitle: copyTitle,
		moveTitle: moveTitle,
		moveFilter: moveFilter,
		copyFilter: copyFilter
	}
}();