/**
 * AZARDI READER AND AZARDI INTERACTIVE ENGINE EXTENSIONS
 * Copyright 2007-2012 Infogrid Pacific Pte. Ltd. All rights reserved
 * Modified Date: 2012-04-25
 * 
 * @version: 1-2012-04-25
 * @author Anup Dhabarde
 */

var DownloadUrl = function(){

	/**
	 * 	Private properties and methods.
	 */
	
	var config = {
		
	}
	
	var get = function (cdpId, catalogId, downloadLink) {
		var self = this;

		document.title = window.opener.AME.getTitle();
		$('#modal-message').attr('value', 'Starting Download. Please Wait...');
		
		var token = self.getToken();
		
		var request = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
					  .createInstance(Components.interfaces.nsIXMLHttpRequest);
		request.onload = function(aEvent) {
			var text = aEvent.target.responseText;
			try{
				var jsObject = JSON.parse(text);
			}
			catch(e){
				// Response is not a proper JSON object.
				window.arguments[0].out.error_message = 'There is some problem for downloading the book. Please try again later.';
				window.arguments[0].out.out = false;
				window.close();
			}
			
			var status = jsObject.status;
			var downloadUrl, raf;
			if(!status){
				window.arguments[0].out.error_message = jsObject.message;
				window.arguments[0].out.out = false;
				window.close();
			}
			else{
				if(jsObject.raf == '') {
					window.arguments[0].out.error_message = 'There is some problem for downloading the book. Please try again later.';
					window.arguments[0].out.out = false;
					window.close();
				}
				window.arguments[0].out.raf = jsObject.raf;
				window.arguments[0].out.download_url = jsObject.download_url;
				window.arguments[0].out.out = true;
				window.close();
			}
		};
		request.onerror = function(aEvent) {
			window.arguments[0].out.error_message = 'There is some problem for downloading the book. Please try again later.';
			window.arguments[0].out.out = false;
			window.close();
		};
		request.open("POST", downloadLink, true);
		request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		request.send("readerid=" + token + "&cdpid=" + cdpId + "&catalogid=" + catalogId);
	}
	
	var getToken = function () {
		var self = this;
		
		var fileObj = window.opener.getFileObject(window.opener.AME.getDbFilePath());
		table_name = 'System';
		var conditions = new Array(['key', 'token', 'TEXT']);
		var values = ['value'];
		
		var statement = window.opener.getValuesFromDatabase(fileObj, values, table_name, conditions);
		var value;
		while (statement.executeStep()) {
			value = statement.row.value
		}
		statement.finalize();
		
		return value;
	}
	
	var getBSInfo = function (bsLink) {
		try {
		var self = this;

		document.title = window.opener.AME.getTitle();
		var msg = getPropertiesString("azd_download_Wait");
		$('#modal-message').attr('value', msg);
		
		var request = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
					  .createInstance(Components.interfaces.nsIXMLHttpRequest);
		request.onload = function(aEvent) {
			var text = aEvent.target.responseText;
			try{
				var jsObject = JSON.parse(text);
				
			}
			catch(e){
				// Response is not a proper JSON object. 
				var msg = getPropertiesString("azd_download_connFailed");
				window.arguments[0].out.error_message = msg;
				window.arguments[0].out.out = false;
				window.close();
			}
			
			window.arguments[0].out.out = true;			
			window.arguments[0].out.bsinfo = jsObject;
			window.close();
		
		};
		request.onerror = function(aEvent) { 
			var msg = getPropertiesString("azd_download_connFailed");
			window.arguments[0].out.error_message = msg;
			window.arguments[0].out.out = false;
			window.close();
		};
		request.open("GET", bsLink, true);
		request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		request.send();
		} catch(e) { 
			var msg = getPropertiesString("azd_download_connFailed");
			window.arguments[0].out.error_message = msg;
			window.arguments[0].out.out = false;
			window.close();
		}
	}
	
	var regWithACFS  = function (bsLink, params) {
		try {
			var self = this;
			document.title = window.opener.AME.getTitle();
			var msg = getPropertiesString("azd_download_Register");
			$('#modal-message').attr('value', msg);
			
			var request = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
						  .createInstance(Components.interfaces.nsIXMLHttpRequest);
			
			request.onload = function(aEvent) {
				var text = aEvent.target.responseText;
				try{
					var jsObject = JSON.parse(text);
				}
				catch(e){
					// Response is not a proper JSON object. 
					var msg = getPropertiesString("azd_download_connFailed");
					window.arguments[0].out.error_message = msg;					
					window.arguments[0].out.out = false;
					window.close();
				}
				
				window.arguments[0].out.out = jsObject["status"];
				window.arguments[0].out.bsinfo = jsObject;
				window.close();
			
			};
			request.onerror = function(aEvent) { 
				var msg = getPropertiesString("azd_download_connFailed");
				window.arguments[0].out.error_message = msg;			
				window.arguments[0].out.out = false;
				window.close();
			};
			request.open("POST", bsLink, true);			
			request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
			request.send(params);
		} catch(e) { 
			var msg = getPropertiesString("azd_download_connFailed");
			window.arguments[0].out.error_message = msg;
			window.arguments[0].out.out = false;
			window.close();
		}
	}
	
	var changeDeviceWithACFS  = function (bsLink, params) {
		try {
			var self = this;

			document.title = window.opener.AME.getTitle();
			var msg = getPropertiesString("azd_download_Register");
			$('#modal-message').attr('value', msg);
			
			var request = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
						  .createInstance(Components.interfaces.nsIXMLHttpRequest);
			request.onload = function(aEvent) {
				var text = aEvent.target.responseText;
				try{
					var jsObject = JSON.parse(text);
				}
				catch(e){
					// Response is not a proper JSON object. 
					var msg = getPropertiesString("azd_download_connFailed");
					window.arguments[0].out.error_message = msg;
					window.arguments[0].out.out = false;
					window.close();
				}
				
				window.arguments[0].out.out = jsObject["status"];
				window.arguments[0].out.bsinfo = jsObject;
				window.close();
			
			};
			request.onerror = function(aEvent) { 
				var msg = getPropertiesString("azd_download_connFailed");
				window.arguments[0].out.error_message = msg;			
				window.arguments[0].out.out = false;
				window.close();
			};
			request.open("POST", bsLink, true);
			request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
			request.send(params);
		} catch(e) { 
			var msg = getPropertiesString("azd_download_connFailed");
			window.arguments[0].out.error_message = msg;
			window.arguments[0].out.out = false;
			window.close();
		}
	}
	
	var dACFBook = function(bsLink, params, shelf_md){
		try {
			var self = this;
			document.title = window.opener.AME.getTitle();
			var msg = getPropertiesString("azd_download_Starts");
			$('#modal-message').attr('value', msg);
			
			var request = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
						  .createInstance(Components.interfaces.nsIXMLHttpRequest);
			
			request.onload = function(aEvent) {
				var text = aEvent.target.responseText;
				try{
					var jsObject = JSON.parse(text);
				}
				catch(e){
					// Response is not a proper JSON object. 
					var msg = getPropertiesString("azd_download_connFailed");
					window.arguments[0].out.error_message = msg;					
					window.arguments[0].out.out = false;
					window.arguments[0].out.bsitems = {};
					window.arguments[0].out.bsitems["status"] = false;
					window.arguments[0].out.bsitems["reason"] = "Exception raised. Reason: " + e;
					window.close();
				}
				
				window.arguments[0].out.out = jsObject["status"];			
				window.arguments[0].out.bsitems = jsObject;
				window.close();
			
			};
			request.onerror = function(aEvent) { 
				var msg = getPropertiesString("azd_download_connFailed");
				window.arguments[0].out.error_message = msg;
				window.arguments[0].out.out = false;
				window.arguments[0].out.bsitems = {};
				window.arguments[0].out.bsitems["status"] = false;
				window.arguments[0].out.bsitems["reason"] = "Exception raised. Reason: " + e;	
				window.close();
			};
			request.open("POST", bsLink, true);
			request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
			request.send(params);
		} catch(e) { 
			var msg = getPropertiesString("azd_download_connFailed");
			window.arguments[0].out.error_message = msg;
			window.arguments[0].out.out = false;
			window.arguments[0].out.bsitems = {};
			window.arguments[0].out.bsitems["status"] = false;
			window.arguments[0].out.bsitems["reason"] = "Exception raised. Reason: " + e;
			window.close();
		}
	}
	
	var getACFSAccountItems = function (bsLink, params) {
		try {
			var self = this;
			document.title = window.opener.AME.getTitle();
			var msg = getPropertiesString("azd_download_updateShelf");
			$('#modal-message').attr('value', msg);
			
			var request = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
						  .createInstance(Components.interfaces.nsIXMLHttpRequest);
			request.onload = function(aEvent) {
				var text = aEvent.target.responseText;
				try{
					var jsObject = JSON.parse(text);
					
					if (jsObject.hasOwnProperty("cdps")) {
						var cdps = jsObject["cdps"];
						for (var i=0; i<cdps.length; i++) {
							var s_binfo = cdps[i];
							var s_workuid =  s_binfo["workuid"];
							var component_bucket_name = s_binfo["component_bucket_name"];
							var cover = s_binfo["cover"];
							var coverfn = cover.split("/").pop();
							var resurl = component_bucket_name + cover;
							downloadCover(resurl, coverfn)
						}
					}
				} catch(e){
					// Response is not a proper JSON object. 
					var msg = getPropertiesString("azd_download_connFailed");
					window.arguments[0].out.error_message = msg;					
					window.arguments[0].out.out = false;
					window.close();
				}
				
				window.arguments[0].out.out = true;			
				window.arguments[0].out.bsitems = jsObject;
				window.close();
			
			};
			request.onerror = function(aEvent) { 
				var msg = getPropertiesString("azd_download_connFailed");
				window.arguments[0].out.error_message = msg;			
				window.arguments[0].out.out = false;
				window.close();
			};
			request.open("POST", bsLink, true);
			request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
			request.send(params);
		} catch(e) { 
			var msg = getPropertiesString("azd_download_connFailed");
			window.arguments[0].out.error_message = msg;
			window.arguments[0].out.out = false;
			window.close();
		}
	}
	
	var downloadCover = function (resUrl, filename) {
		try {
			var destObj = window.opener.getFileObject(['ProfD', 'quizfx', 'covers']);
				
			if (!destObj.exists()) {
				destObj.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
			}
			destObj.append(filename);
			downloadFile(destObj.path, resUrl);
			return;
		} catch(e) {
			var msg = getPropertiesString("azd_download_Failed");
			alert(msg + ' ' + e);
			return "";
		}
		return "";
	}
	
	var dACFBookBInfo = function (bsLink, params) {
		try {
			var self = this;
			document.title = window.opener.AME.getTitle();
			var msg = getPropertiesString("azd_download_bookInfo");
			$('#modal-message').attr('value', msg);
			
			var request = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
						  .createInstance(Components.interfaces.nsIXMLHttpRequest);
			request.onload = function(aEvent) {
				var text = aEvent.target.responseText;
				try{
					var jsObject = JSON.parse(text);
				}
				catch(e){
					// Response is not a proper JSON object. 
					var msg = getPropertiesString("azd_download_connFailed");
					window.arguments[0].out.error_message = msg;					
					window.arguments[0].out.out = false;
					window.close();
				}
				
				window.arguments[0].out.out = true;			
				window.arguments[0].out.bsitems = jsObject;
				window.close();
			
			};
			request.onerror = function(aEvent) { 
				var msg = getPropertiesString("azd_download_connFailed");
				window.arguments[0].out.error_message = msg;			
				window.arguments[0].out.out = false;
				window.close();
			};
			request.open("POST", bsLink, true);
			request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
			request.send(params);
		} catch(e) { 
			var msg = getPropertiesString("azd_download_connFailed");
			window.arguments[0].out.error_message = msg;
			window.arguments[0].out.out = false;
			window.close();
		}
	}
	
	var checkURLInJSON = function(url_info, manifest_item) {
		for (urlentry in url_info) {
			if (urlentry.indexOf(manifest_item) > -1) {
				return url_info[urlentry];
			}
		}
		return "";
	};
	
	
	var dACFBookBMain = function (bsLink, params, sessioninfo, shelfinfo, url_info) {
		try {
			var self = this;
			document.title = window.opener.AME.getTitle();
			var msg = getPropertiesString("azd_download_Starts");
			$('#modal-message').attr('value', msg);
			var bucketloc = sessioninfo.bucketloc;
			var accountuid = sessioninfo.accountuid;
			var workuid = sessioninfo.bookuid;
			var url_info = url_info;
			var request = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
						  .createInstance(Components.interfaces.nsIXMLHttpRequest);
			request.onload = function(aEvent) {
				var text = aEvent.target.responseText;
				try{
					var hash = window.CryptoJS.SHA1(text);
					hash = hash.toString(CryptoJS.enc.Hex);
					var destinationDb = window.opener.getFileObject(window.opener.AME.getCdpDbFilePath());
					window.opener.createPubDataTables(destinationDb);
					
					var jsObject = JSON.parse(text);
					var manifest = jsObject.manifest;
					for (var m = 0; m < manifest.length; m++) {
						if (typeof manifest[m] != "object"){
							continue;
						}
						var itemref = manifest[m].href;
						var itemid = manifest[m].id;
						var mimetype = manifest[m].mediaType;
						
						if ((mimetype.indexOf('audio') > -1) || (mimetype.indexOf('video') > -1)) {
							var lookup = itemref.split("/").pop();
							var resUrl = checkURLInJSON(url_info, lookup);
							if (resUrl) {
								var filename = itemref.split("/").pop();
								self.dACFAudioVideo(workuid, resUrl, mimetype, filename);
							} else {
								dump("Not found " + lookup);
							}
						} else {
							var lookup = itemref.split("/").pop();
							var lookup1 = itemref.split("/");
							if (lookup1[0] === "fonts") {
								var fontUrl = checkURLInJSON(url_info, lookup);
								if (fontUrl) {
									var filename = itemref.split("/").pop();
									self.dFonts(workuid, fontUrl, mimetype, filename);
								}
							} else {
								var jsonUrl = checkURLInJSON(url_info, lookup);
								if (jsonUrl) {
									var filename = itemref.split("/").pop();
									var h = self.dACFBookBParts(destinationDb, mimetype, jsonUrl);
									if (h) {
										jsObject.manifest[m]["hash"] = h;
									}
								} else {
									
								}
							}	
						}
						var pe = (m*1.0/manifest.length) * 100;
						pe = Math.floor(pe);
						var msg = getPropertiesString("azd_download_progressMsg");
						$('#modal-message').attr('value', msg + " " + (pe) + "%.   ");
					}
					
					var table_name = "store";
					values = new Array(['uid', hash, 'TEXT'],
									['type', "application/xhtml+xml", 'TEXT'],
									['data', JSON.stringify(jsObject), 'TEXT']);
					window.opener.insertRowIntoDatabase(destinationDb, values, table_name);
					
					
					shelfinfo[workuid] = hash;
					var fileObj1 = window.opener.getFileObject(window.opener.AME.getDbFilePath());
					var table_name = "shelf_info";
					var values = new Array(['shelf_metadata', JSON.stringify(shelfinfo), 'TEXT']);
					var conditions = new Array(['shelf_id', shelfinfo.shelfid, 'TEXT']);
					window.opener.updateRowIntoDatabase(fileObj1, values, table_name, conditions);
					
					var table_name = "pub_docs";
					var values = new Array(['bookstate', 'READY', 'TEXT']);
					var conditions = new Array(['workuid', workuid, 'TEXT']);
					window.opener.updateRowIntoDatabase(fileObj1, values, table_name, conditions);
					window.opener.Library.setClickedBookState('READY', workuid, hash);
					
					var msg = getPropertiesString("azd_download_Finished");
					alert(msg);
					window.arguments[0].out.error_message = msg;
					window.arguments[0].out.out = true;
					window.close();
					
					
				}
				catch(e){
					azDump("dACFBookBMain",  e);
					// Response is not a proper JSON object.
					var msg = getPropertiesString("azd_download_connFailed");
					window.arguments[0].out.error_message = msg;
					window.arguments[0].out.out = false;
					window.close();
				}
			};
			request.onerror = function(aEvent) {
				var msg = getPropertiesString("azd_download_connFailed");
				window.arguments[0].out.error_message = msg;
				window.arguments[0].out.out = false;
				window.close();
			};
			request.open("GET", bsLink, true);
			request.send("");
		} catch(e) {
			azDump("dACFBookBMain OUTER",  e);
			var msg = getPropertiesString("azd_download_connFailed");
			window.arguments[0].out.error_message = msg + ' ' + e;
			window.arguments[0].out.out = false;
			window.close();
		}
	}
	
	var dACFBookBParts = function (destinationDb, mimetype, bsLink) {
		try {
			var self = this;
			var h = "";
			var request = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
						  .createInstance(Components.interfaces.nsIXMLHttpRequest);
			request.onload = function(aEvent) {
				var text = aEvent.target.responseText;
				try{
					h = window.CryptoJS.SHA1(text);
					h = h.toString(CryptoJS.enc.Hex);
					var jsObject = JSON.parse(text);
					var table_name = "store";
					values = new Array(['uid', h, 'TEXT'],
									['type', mimetype, 'TEXT'],
									['data', text, 'TEXT']);
					window.opener.insertRowIntoDatabase(destinationDb, values, table_name);
					return ""+h;
				}
				catch(e){
					h = "";
				}
				
				return "";
			
			};
			request.onerror = function(aEvent) {
				h = "";
				return h;
			};
			request.open("GET", bsLink, false);
			request.send("");
		} catch(e) {
			h = "";
			return "";
		}
		return h;
	}
	
	var dACFBookDel = function (bid) {
		try {
			var self = this;
			document.title = window.opener.AME.getTitle();
			var msg = getPropertiesString("azd_download_deleteBookStart");
			$('#modal-message').attr('value', msg);
			
			try {
				if (typeof bid == "undefined") {
					var bookMD = window.opener.Library.getClickedBookMD();
				} else {
					var bookMD = window.opener.Library.getClickedBookMDByID(bid);
				}	
				var shelfId = window.opener.Library.config.shelfId;
				var fileObj = window.opener.getFileObject(window.opener.AME.getDbFilePath());
				if (!fileObj.exists()){
					return false;
				}
				
				var table_name = "shelf_info";
				var values = ['shelf_id', 'shelf_metadata'];
				var conditions = new Array(['shelf_id', shelfId, 'TEXT']);
				var statement = window.opener.getValuesFromDatabase(fileObj, values, table_name, conditions);
				var shelf_md_obj = {}
				while (statement.executeStep()){
					var shelf_id = statement.row.shelf_id;
					var shelf_md = statement.row.shelf_metadata;
					shelf_md_obj = JSON.parse(shelf_md);
					shelf_md_obj.shelfid = shelf_id;
					break
				}
				statement.finalize();
				
				var md = window.opener.BookMetadata.getBSBookAdditionalMetadata(shelf_md_obj[bookMD["workuid"]]);
				var destinationDb = window.opener.getFileObject(window.opener.AME.getCdpDbFilePath());
				for (var i = 0; i < md.manifest.length; i++) {
					try {
						var data = md.manifest[i];
						table_name = 'store';
						condition = new Array(['uid', data["hash"], 'TEXT']);
						window.opener.deleteRowFromDatabase(destinationDb, table_name, condition);	
					} catch(e) {
					
					}
				}

				try {
					table_name = 'store';
					condition = new Array(['uid', shelf_md_obj[bookMD["workuid"]], 'TEXT']);
					window.opener.deleteRowFromDatabase(destinationDb, table_name, condition);
				} catch (e) {
				
				}
				
				table_name = 'pub_docs';
				condition = new Array(['workuid', bookMD["workuid"], 'TEXT']);
				window.opener.deleteRowFromDatabase(fileObj, table_name, condition);	

				
			} catch(e) {
				
			}
			
			var msg = getPropertiesString("azd_download_deleteBookSuccess");
			window.arguments[0].out.error_message = msg;
			window.arguments[0].out.out = true;
			window.close();
				
		} catch(e) {
			var msg = getPropertiesString("azd_download_deleteBookFail");
			window.arguments[0].out.error_message =  msg + ' ' + e;
			window.arguments[0].out.out = false;
			window.close();
		}
	}
	
	var downloadFile = function (tempDownloadPath, httpLocation) {
		var self = this;
		
		try {
			var obj_URI = Components.classes["@mozilla.org/network/io-service;1"]
									.getService(Components.interfaces.nsIIOService)
									.newURI(httpLocation, null, null);
			
			var obj_TargetFile = Components.classes["@mozilla.org/file/local;1"]
										   .createInstance(Components.interfaces.nsILocalFile);

			obj_TargetFile.initWithPath(tempDownloadPath);
			
			//	Create the file if it doesn't exists.
			if(!obj_TargetFile.exists()) {
				obj_TargetFile.create(0x00,0644);
			}

			config.obj_Persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"]
									.createInstance(Components.interfaces.nsIWebBrowserPersist);

			const nsIWBP = Components.interfaces.nsIWebBrowserPersist;
			const flags = nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES;
			config.obj_Persist.persistFlags = flags | nsIWBP.PERSIST_FLAGS_BYPASS_CACHE | nsIWBP.PERSIST_FLAGS_CLEANUP_ON_FAILURE;

			config.obj_Persist.progressListener = {
				onProgressChange: function(aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {
					if($('#download-progressbar').attr('mode') == 'undetermined'){
						$('#download-progressbar').attr('mode', 'determined');
					}
					var percentComplete = (aCurTotalProgress/aMaxTotalProgress)*100;
					$('#download-progressbar').attr('value', percentComplete);
				},
				
				onStateChange: function(aWebProgress, aRequest, aStateFlags, aStatus) {
					if(config.obj_Persist.currentState == config.obj_Persist.PERSIST_STATE_FINISHED) {
						var chan =	aRequest.QueryInterface(Components.interfaces.nsIHttpChannel);
						if (!chan.requestSucceeded) {
							return;
						}
						if(aStatus == 0){		
							//aStatus gives '0' if download is finished.
						} else {
							
						}
					} 
				}
			}
			config.obj_Persist.saveURI(obj_URI,null,null,null,null,obj_TargetFile, null);
		} catch (e) {
			dump('Error while downloading: ' + e);
		}
	}
	
	var dFonts = function (workuid, resUrl, mimetype, filename) {
		try {
			var destObj = window.opener.getFileObject(['ProfD', 'quizfx', 'buffer', workuid]);
				
			if (!destObj.exists()) {
				destObj.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
			}
			destObj.append(filename);
			downloadFile(destObj.path, resUrl);
			return;
		} catch(e) {
			return "";
		}
		return "";
	}
	
	var dACFAudioVideo = function (workuid, resUrl, mimetype, filename) {
		try {
			var destObj = window.opener.getFileObject(['ProfD', 'quizfx', 'buffer', workuid]);
				
			if (!destObj.exists()) {
				destObj.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
			}
			destObj.append(filename);
			downloadFile(destObj.path, resUrl);
			return;
		} catch(e) {
			return "";
		}
		return "";
	}
	
	return{
		get: get,
		getToken: getToken,
		getBSInfo: getBSInfo,
		regWithACFS: regWithACFS,
		changeDeviceWithACFS: changeDeviceWithACFS,
		getACFSAccountItems: getACFSAccountItems,
		dACFBook: dACFBook,
		dACFBookBInfo: dACFBookBInfo,
		dACFBookBMain: dACFBookBMain,
		dACFBookDel: dACFBookDel,
		dACFAudioVideo: dACFAudioVideo,
		dFonts: dFonts,
		dACFBookBParts: dACFBookBParts
	}
}();

function azDump(prefix){
	dump("\n" + prefix + ">>>>  ");
	result = ""
	 // iterate through non-separator arguments
	  for (var i = 1; i < arguments.length; i++) {
			result += JSON.stringify(arguments[i]) + "\n";
	  }
	dump("\n" + result);
	dump("----------------------------------------------");
}