/**
 * AZARDI READER AND AZARDI INTERACTIVE ENGINE EXTENSIONS
 * Copyright 2007-2012 Infogrid Pacific Pte. Ltd. All rights reserved
 * Modified Date: 2012-04-25
 * 
 * @version: 1-2012-04-25
 * @author Deepak Chandran
 */

/**
 * @class Contains all the functions necessary for loading epub.
 */
var Epub = function(){
	//	FIXME: variable extractLocation and extractedFolder needs to go into the file_common.js.
	var config = {
		lang: 'en',
		title: '',
		author: '',
		cover_image: '',
		cover_type: '',
		extractedFolder: '',
		extractLocation: '',
		htmlCounter: 0,
		customCss: 1,
		tocPath: '',
		tocFound: false,
		epub3TocHref: '',
		epub3TocData: '',
		epub3LandmarkData: '',
		epub3PageNavData: '',
		version: '',
		previewSpine: false,
		spineList: [],
		bookData: [],
		cssImports: {},
		unavailableItem: [],
		prompts: Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService),
		XUL_NS: "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul",
		containErrors: false,
		epubId: '',
		epub2FullPageTocData: null,
		epub2InPageTocData: null,
		rendition_layout: "reflowable", //DC - FLO UPDATE - 201211
		rendition_orientation: "auto",
		rendition_spread: "auto",
		spineProperties: {},
		page_progression_dir: "ltr",
		opfFilePath: "",
		identifier: "",
		metainfo: {},
		pubFileMap: {},
		ispubdownload: false,
		isexternalimages: false,
		pubdoc_ext_images: {},
		tmpfolders: []
	};
	
	var is_fixed_layout = false;
	var is_fixed_scroll_mode = false;
	var doc_orientation = "auto";
	var doc_spread = "auto";
	var nav_list = [];
	var nav_lookup = {};
	var filename_lookup = {};
	var fontfile_lookup = {};
	//DC - FLO UPDATE - 201211 - STARTS
	//Structure to be injected into the content
	
	//It seems that setting chrome path in iframe does not work. So we get the actual path 
	//for following resources and turn them into a abs path (file:///)
	var pagecss = getAbsPathFromChromeURL("chrome://azardi2/content/css/pagination-ape.css");
	var jq = getAbsPathFromChromeURL("chrome://azardi2/content/js/core/jquery/jquery.min.js");
	var jqui = getAbsPathFromChromeURL("chrome://azardi2/content/js/core/jquery/jquery-ui-1.8.11.custom.min.js");
	var rangy = getAbsPathFromChromeURL("chrome://azardi2/content/js/core/rangy/rangy-core.js");
	var rangys = getAbsPathFromChromeURL("chrome://azardi2/content/js/core/rangy/rangy-serializer.js");
	var iscroll = getAbsPathFromChromeURL("chrome://azardi2/content/js/core/iscroll/iscroll.js");
	var pagevar = getAbsPathFromChromeURL("chrome://azardi2/content/js/core/page-variables.js");
	var loadinggif = getAbsPathFromChromeURL("chrome://azardi2/content/icons/loading.gif");
	
	try {
		var aiepath = "chrome://azardi2/content/js/aie/";
		var pubsub = getAbsPathFromChromeURL( aiepath + "pubsub.js");
		var aie_core = getAbsPathFromChromeURL(aiepath + "aie_core.js");
		var aie_explore = getAbsPathFromChromeURL(aiepath + "aie_explore.js");
		var aie_qaa = getAbsPathFromChromeURL(aiepath + "aie_qaa.js");
		var aie_storyline = getAbsPathFromChromeURL(aiepath + "aie_storyline.js");
		var aie_events = getAbsPathFromChromeURL(aiepath + "aie_events.js");
		var igp_audio = getAbsPathFromChromeURL(aiepath + "igp_audio.js");
		var aie_gameutils = getAbsPathFromChromeURL(aiepath + "aie_gameutils.js");
		var aie_textsound = getAbsPathFromChromeURL(aiepath + "aie_textsound.js");
		
		var appSMILJS = '';
		
		appSMILJS = '<script language="javascript" type="text/javascript" src="' + aie_textsound + '"></script>';
		
		var appHeaderComponents = '';
	} catch(e) {
		//alert(e);
	}
	
	var appPrevControl = '<div class="onpage-nav-prev" onclick="javascript:xulconnector.send_request({action: \'previousPage\'});"></div>';
	var appNextControl = '<div class="onpage-nav-next" onclick="xulconnector.send_request({action: \'nextPage\'});"></div>';
	var appBody = '<div id="custom-style-igp" class="custom-style-igp" lang="en"></div>';
	
	var appControlStructure = '<div class="warning_message_box">\
		</div>\
		<div class="bookProgressbar"></div>\
		<div class="progressbar"></div>\
		<div class="notes-ape" id="add_notes" style="display:none;">\
			<div class="notes-header-ape">$makeanote_label$\
				<span class="notes-close-ape">\
					<a href="javascript:void(0);" onclick="javascript:xulconnector.send_request({action: \'saveNotes\'});">$makeanote_done$</a>\
				</span>\
			</div>\
			<div style="text-align:center;" class="note_description">\
				<textarea id="notesDescription" style="width: 90%; height:260px;"></textarea>\
			</div>\
			<div style="display:none;">\
				<div id="notes-serialized"></div>\
				<div id="notes-book-id"></div>\
				<div id="notes-current-chapter"></div>\
				<div id="notes-selection-string"></div>\
			</div>\
		</div>\
		<div id="white_overlay" class="white_overlay"></div>\
		<div id="loading_overlay" class="loading_overlay" style="display:none;">\
			<img id="loading_image" alt="" class="loading_image" src="'+loadinggif+'" border="0" />\
		</div>\
		';
	
	var hasJSRef = function(content, jsname) {
		if (content.indexOf(jsname) > -1) return true;
		return false;
	}
	
	var getAppCustomCSS = function () {
		var customcss = '<link rel="stylesheet" type="text/css" href="' + pagecss +'" />';
		return customcss;
	};
	
	var getAppHeaderComponents = function (content) {
		appHeaderComponents = '<script language="javascript" type="text/javascript" src="' + iscroll + '"></script>';
		
		if (!hasJSRef(content, "jquery")) {
			appHeaderComponents = appHeaderComponents + 
				'<script language="javascript" type="text/javascript" src="' + jq + '"></script>';
		}
		
		if (!hasJSRef(content, "jquery-ui")) {
			appHeaderComponents = appHeaderComponents + 
				'<script language="javascript" type="text/javascript" src="' + jqui + '"></script>';
		}
		
		appHeaderComponents = appHeaderComponents + 
				'<script language="javascript" type="text/javascript" src="' + rangy + '"></script>\
				<script language="javascript" type="text/javascript" src="' + rangys + '"></script>\
				<script language="javascript" type="text/javascript" src="' + pagevar + '"></script>';
		
		if (!hasJSRef(content, "aie_core.js")) {
			appHeaderComponents = appHeaderComponents + 
				'<script language="javascript" type="text/javascript" src="' + pubsub + '"></script>\
				 <script language="javascript" type="text/javascript" src="' + aie_core + '"></script>\
			     <script language="javascript" type="text/javascript" src="' + aie_explore + '"></script>\
			     <script language="javascript" type="text/javascript" src="' + aie_qaa + '"></script>\
			     <script language="javascript" type="text/javascript" src="' + aie_storyline + '"></script>\
			     <script language="javascript" type="text/javascript" src="' + aie_events + '"></script>\
			     <script language="javascript" type="text/javascript" src="' + aie_gameutils + '"></script>\
			     <script language="javascript" type="text/javascript" src="' + igp_audio + '"></script>';
		} 
		
		//add a style element to override any margin or padding styles done on body
		//This is to make sure that the column based pagination works
		appHeaderComponents = appHeaderComponents + 
				'<style>\
				  body {margin: 0; padding: 0;}\
				 </style>';
		
		return appHeaderComponents;
	
	}
	
	//DC - FLO UPDATE - 201211 - ENDS
	/**
	 * Loads the content of the epub into the variables
	 * @params bookLocation Location of the book on the users system
	 * @params bookVersion Epub version
	 * @params bookTitle Title of the book
	 * @params bookAuthor Author of the book
	 * @params bookImageType image|avatar
	 * @params openAtFirst Open the book at first page true|false
	 */
	var loadPubBook = function(bookLocation, bookVersion, bookTitle, bookAuthor, bookImageType, openAtFirst, additionalparams, opfdata){
		try{
			azLogTime("LOAD STARTS");
			var self = this;
			
			config.epubId = Library.config.currentBookId;
			config.version = bookVersion.split('.')[0];
			config.title = bookTitle;
			config.author = bookAuthor;
			// config.cover_image = bookImage;
			config.cover_type = bookImageType;
			config.ispubdownload = true;
			
			//DC - FLO UPDATE - 201211 - new epub3 variables
			try {
				config.rendition_layout = additionalparams['rendition_layout'];
				config.rendition_orientation = additionalparams['rendition_orientation'];
				config.rendition_spread = additionalparams['rendition_spread'];
				config.identifier = additionalparams['identifier'];
				if (config.rendition_layout == "scrolling") {
					Epub.is_fixed_scroll_mode = true;
				};
				
				if (config.rendition_layout == "pre-paginated"){
					self.is_fixed_layout = true;
				}
				self.doc_orientation = config.rendition_orientation;
				self.doc_spread = config.rendition_spread;
				
			} catch (e) {
			
			}
			
			Chapter.config.openAtFirst = openAtFirst;
			
			$('#book_context_menu').show();
			
			config.spineList.splice(0, config.spineList.length);
			//Get the spine of the epub
			self.getSpineJSON(opfdata);
			//TODO - Handle the metadata loading here.
			//At the moment the metadata package does not have it
			
			//Set Language
			//TODO - NO LANGUAGE MD IN THE PACKAGE
			config.lang = "en";
			self.setLang(config.lang);
			
			for (i = 0; i < opfdata.manifest.length; i++) {
				var data = opfdata.manifest[i];
				config.bookData.push(data);
			}
			
			getTocDataEpub3JSON(opfdata);
			
			getTocDataEpub2JSON(opfdata);
			
			if (opfdata.hasOwnProperty("cover_image") && opfdata["cover_image"] != "") {
				config.cover_image = opfdata["cover_image"];
			}

			/* TODO - WHAT IS THE STRATEGY FOR SMIL AND AUDIO FILES?
				if(config.version == 3) {
					//Get the .smil file data
					self.getSmilData(opfFilePath);
				}
				//Copy audio and video files in temp location
				self.copyAudioAndVideo(opfFilePath);
			*/
			
			//DC - FLO UPDATE - 201211 - Preprocessing stuff inside the epub files
			//preprocess the html files to insert our custom scripts
			var dl = new Array();
			for (var i=0; i<4; i++) {
				var r = generateRandString(7);
				dl.push(r);
			}
			
			//Create the images here
			try {
				for(var i = 0; i < config.bookData.length; i++){
					if(config.bookData[i]['mediaType'] == 'application/vnd.igp.image-json'){
						var dbdata = BookMetadata.getBSBookAdditionalMetadata(config.bookData[i]['hash']);
						jQuery.extend(config.pubdoc_ext_images, dbdata);
					}	
				}
				config.isexternalimages = true;
			} catch(e) {
				alert(e);
			}
			
			var styledata = "";
			for(var i = 0; i < config.bookData.length; i++){
				if(config.bookData[i]['mediaType'] == 'text/css'){
					styledata = config.bookData[i]['data'];
					fontsUrl = "fonts/";
					try {
						fontsObj = getFileObject(['ProfD', 'quizfx', 'buffer', Epub.config.epubId]);
						fontsUrl = getURL(fontsObj);
					} catch (e) {
						
					}
					var styledata = styledata.replace(/url\((.+)\)/gm, function(a,b){
						if (b.indexOf('fonts')!= -1) {
							var fontfilename = b.split('/').pop();
							return 'url(\''+ fontsUrl + fontfilename + '\')';
						} else {
							var fname = b.split('/').pop();
							if (Epub.config.pubdoc_ext_images.hasOwnProperty(fname)) {
								return 'url(\''+ Epub.config.pubdoc_ext_images[fname] + '\')';
							}
						
							return a;
						}
					});
					break;
				}
			}
			
			//Fixme - The above regex sometime fails to extract the imagename properly. 
			//So the following 3 lines handle the remaining images
			styledata = styledata.replace(/\.\.\/images\//g, "");
			for (imgfn in Epub.config.pubdoc_ext_images) {
				styledata = styledata.replace(imgfn, Epub.config.pubdoc_ext_images[imgfn]);
			}
			
			var jsdata = {};
			for(var i = 0; i < config.bookData.length; i++){
				if(config.bookData[i]['mediaType'] == 'text/javascript'){
					var jsfile = config.bookData[i]["href"].split("/").pop();
					jsdata[jsfile] = config.bookData[i]['data'];
				}
			}
			
			
			
			var sourceObj = getFileObject(['CurProcD', 'chrome', 'content', 'html', 'page-t.html']);
			var htmltplContent = readFileUTF(sourceObj.path);
			for(var i = 0; i < config.bookData.length; i++){
				if(config.bookData[i]['mediaType'] == 'text/html' || config.bookData[i]['mediaType'] == 'application/xhtml+xml'){
					var sec = BookMetadata.getBSBookAdditionalMetadata(config.bookData[i]['hash']);
					var s = htmltplContent;
					s = s.replace("$styledata$", styledata);
					s = s.replace("$data$", sec["data"]);
					var ri = getRandomInt(0,3);
					var savefilep = Components.classes["@mozilla.org/file/directory_service;1"]
							 .getService(Components.interfaces.nsIProperties)
							 .get("ProfD", Components.interfaces.nsIFile);
					savefilep.append("tqwyui");
					savefilep.append(dl[ri]);
					if (!savefilep.exists()) {
				    	savefilep.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
				    }
					
					config.tmpfolders.push(savefilep.path);
					
					var jsinclude = "";
					var jstpl = '<script language="javascript" type="text/javascript" src="$fb$"></script>';
					for (var g=0; g <config.bookData[i]['jsRef'].length; g++) {
						
						var jsfile = config.bookData[i]['jsRef'][g].split("/").pop();
						if (jsdata.hasOwnProperty(jsfile)) {
							var jsref = jstpl.replace("$fb$", jsfile);
							jsinclude = jsinclude + jsref;
							var savefilep1 = Components.classes["@mozilla.org/file/directory_service;1"]
							 .getService(Components.interfaces.nsIProperties)
							 .get("ProfD", Components.interfaces.nsIFile);
							savefilep1.append("tqwyui");
							savefilep1.append(dl[ri]);
							var jspath = savefilep1;
							jspath.append(jsfile);
							writeFileUTF(jspath.path, jsdata[jsfile]);
						}
					}
					
					savefilep.append(generateRandString(19)+".html");
					headers = getAppHeaderComponents(s);
					var appcss = getAppCustomCSS();
					s = s.replace("<head>", "<head>" + appcss);
					s = s.replace("</body>", headers + "</body>\n")
					//Force the smil aie_textsound to override the book aie textsound js
					s = s.replace("</body>", appSMILJS + "</body>");
					if (jsinclude) {
						s = s.replace("</body>", jsinclude + "</body>");
					}
					
					writeFileUTF(savefilep.path, s);
					//save the file
					var htmlObj = getFileObjectFromPath(savefilep.path);
					var htmlUrl = getURL(htmlObj);
					var fn = config.bookData[i]['href'];
					config.pubFileMap[fn] = htmlUrl;
					filename_lookup[fn] = i;
					config.bookData[i]['available'] = 'true';
					config.bookData[i]['htmlUrl'] = htmlUrl;
				}
			}
			
			config.htmlCounter = 0;
			config.customCss = 1;
			$('#pageContainerIframe').unbind('DOMContentLoaded');
			
			try {
				self.processSpine();
			} catch(e) {
				config.prompts.alert(null, AME.getTitle(), e.message);
				self.unload();
				AME.showLibrary();
				return;
			}
			
			
			
			$('#pageContainerIframe').attr('src', '');
			//Initilize the chapter
			azLogTime("loadfinishes 2");
			setTimeout( function(){
				Chapter.init();
				}, 100);
			
			Toolbar.showEpub();
		
		} catch(e) {
			alert(e);
		}
	}
	
	//DC - FLO UPDATE - 201211 - ENDS
	/**
	 * Loads the content of the epub into the variables
	 * @params bookLocation Location of the book on the users system
	 * @params bookVersion Epub version
	 * @params bookTitle Title of the book
	 * @params bookAuthor Author of the book
	 * @params bookImageType image|avatar
	 * @params openAtFirst Open the book at first page true|false
	 */
	var load = function(bookLocation, bookVersion, bookTitle, bookAuthor, bookImageType, openAtFirst, additionalparams){
		try{
		azLogTime("LOAD STARTS");
		var self = this;
		
		config.epubId = Library.config.currentBookId;
		config.version = bookVersion.split('.')[0];
		config.title = bookTitle;
		config.author = bookAuthor;
		// config.cover_image = bookImage;
		config.cover_type = bookImageType;
		
		//DC - FLO UPDATE - 201211 - new epub3 variables
		try {
			if (additionalparams['rendition_layout'] == "scrolling") {
				Epub.is_fixed_scroll_mode = true;
			};
			config.rendition_layout = additionalparams['rendition_layout'];
			config.rendition_orientation = additionalparams['rendition_orientation'];
			config.rendition_spread = additionalparams['rendition_spread'];
			config.identifier = additionalparams['identifier'];

			if (config.rendition_layout == "pre-paginated"){
				self.is_fixed_layout = true;
			}
			self.doc_orientation = config.rendition_orientation;
			self.doc_spread = config.rendition_spread;
			
		} catch (e) {
		
		}
		
		Chapter.config.openAtFirst = openAtFirst;
		
		if (config.version === "e0") {
			$('#book_context_menu').show();
			Epub0.loadE0(bookLocation, bookVersion, bookTitle, bookAuthor, bookImageType, openAtFirst, additionalparams);
			
			$('#pageContainerIframe').unbind('DOMContentLoaded');
			setTimeout( function(){
				Chapter.init();
				}, 100);
		
			Toolbar.showEpub();
			return;
		}
		
		try{
			$('#book_context_menu').show();
			var epubFile = getFileObjectFromPath(bookLocation);
			if(!epubFile.exists() || !epubFile.isFile()) {
				var epubnotfound = getPropertiesString("azd_epub_notFound");
				if (!epubnotfound) {
					epubnotfound = "Epub not found."
				}
				throw new Error(epubnotfound);
			}
			
			
			try{
				unzipFile(epubFile.path, false);
			}
			catch(e){
				//	Throw error if archive file is corrupted.
				throw new Error('An error occurred while trying to load the book.');
			}
			self.getExtractLocation();
			self.getExtractedFolderName(epubFile.leafName);
			
			var containerXmlPath = getAppendFilePath(config.extractLocation, [config.extractedFolder, 'META-INF', 'container.xml']);
			
			try{
				var containerXmlContent = readFileUTF(containerXmlPath);
			}
			catch(e){
				//So we have a dir, but it does not have the contents, so delete folder
				//for the next time load
				deleteFolder(getAppendFilePath(config.extractLocation, [config.extractedFolder]));
				// Throw error if META-INF folder or container.xml file is missing.
				throw new Error('An error occurred while trying to load the book.');
			}
			if(containerXmlContent == '') {
				//	Throw error if conatainer.xml file is empty.
				throw new Error('An error occurred while trying to load the book.');
			}
			var opfFilePath = self.getOpfFilePath(containerXmlContent);
			config.opfFilePath = opfFilePath;
			
			try{
				var opfFileContent = readFileUTF(opfFilePath);
			}
			catch(e){
				// Throw error if .opf file is not found at described location.
				throw new Error('An error occurred while trying to load the book.');
			}
			if(opfFileContent == '') {
				// Throw error if .opf file is empty.
				throw new Error('An error occured while trying to load the book.');
			}
			
			config.spineList.splice(0, config.spineList.length);
			//Get the spine of the epub
			self.getSpine(opfFileContent);
			
			self.loadMetaProperties(opfFileContent);
			
			//Get and set the language of the epub
			config.lang = self.getLang(opfFileContent);
			self.setLang(config.lang);
			if(config.version == 3){
				//	If the book is ePub 3 then go with following function (Need to check for the toc file)
				self.getManifestEpub3(opfFileContent);
			}
			else{
				self.getManifestEpub2(opfFileContent);
			}
			// self.processSpine();
		}
		catch(e){
			config.prompts.alert(null, AME.getTitle(), e.message);
			self.unload();
			AME.showLibrary();
			return;
		}
		
		if(config.version == 3){
			if(config.epub3TocHref !== ''){
				self.getTocDataEpub3(opfFilePath);
			}
			else{
				// use ncx as fallback if available.
				self.getTocDataEpub2(opfFilePath);
			}
		}
		else{
			self.getTocDataEpub2(opfFilePath);
		}
		
		
		//	Get the cover image information, and collect the datauri of the cover to show on the cover page.
		var coverImageInfo = self.getCoverImage(opfFileContent, opfFilePath, config.version);
		var coverImagePath = coverImageInfo.coverImagePath;
		config.cover_image = generateDataURI(coverImagePath);
		
		//Get the font and image data as datauri
		self.getFontAndImageData(opfFilePath);
		//Get the epub js data
		//self.getScriptData(opfFilePath);
		
		
		if(config.version == 3) {
			//Get the .smil file data
			try {
				self.getSmilData(opfFilePath);
			} catch(e) {
			
			}
		}
		//Copy audio and video files in temp location
		self.copyAudioAndVideo(opfFilePath);
		
		 //DC - FLO UPDATE - 201211 - Preprocessing stuff inside the epub files
		//preprocess the html files to insert our custom scripts
		for(var i = 0; i < config.bookData.length; i++){
			if(config.bookData[i]['mediaType'] == 'text/html' || config.bookData[i]['mediaType'] == 'application/xhtml+xml'){
				try {
				var htmlPath = getEntityAbsolutePath(opfFilePath, config.bookData[i]['href']);
				var htmlObj = getFileObjectFromPath(htmlPath);
				var filename = htmlObj.leafName.split('.');
				var name = filename[0];
				var extension = filename[1];
				filename_lookup[htmlObj.leafName] = i;
				var htmlXmlContent = readFileUTF(htmlPath);
				config.bookData[i]["htmlXmlContent"] = htmlXmlContent;
				headers = getAppHeaderComponents(htmlXmlContent);
				var appcss = getAppCustomCSS();
				
				var bodytag = htmlXmlContent.match(/<body[^>]*>/gi);
				if (bodytag.length > 0) {
					bodytag = bodytag[0];
					if (bodytag) {
						//azDump("-----------------", bodytag);
						var divtags = '<div id="container-ape"><div id="custom-style-igp" class="custom-style-igp" lang="en">';
						//htmlXmlContent = htmlXmlContent.replace(bodytag, bodytag + divtags);
						//htmlXmlContent = htmlXmlContent.replace("</body>", "</div></div>" + "</body>");
					}
				}
				
				htmlXmlContent = htmlXmlContent.replace("<head>", "<head>" + appcss);
				htmlXmlContent = htmlXmlContent.replace("</head>", headers + "</head>\n")
				//Force the smil aie_textsound to override the book aie textsound js
				htmlXmlContent = htmlXmlContent.replace("</head>", appSMILJS + "</head>")
				writeFileUTF(htmlPath, htmlXmlContent);
				} catch(e) {
				
				}
			}
		}

		azLogTime("LOAD STARTS 1");
		
		self.processFonts();
		//Get the html content and css content
		self.getHtmlData(opfFilePath);
		
		}catch(e){
			//alert(e);
			
		}
	};
	
	//Create a nav list from the spine items. Idea is to create a array of navitems.
	//each navitem contains the spine index no for left, right OR center spread.
	//the navlist is used for the actual button based navigation
	var createNavList = function(){
		nav_list.splice(0, nav_list.length);
		var tempnav = {};
		for (var i = 0; i < config.spineList.length; i ++) { 
			var k = config.spineList[i];
			var display_item = config.spineProperties[k];
			if (display_item.hasOwnProperty("linear") && (display_item["linear"] == false)){
				//This spine item is not part of linear nav. so do not add it to
				// the nav list
				continue;
			}
			
			if (display_item['page-spread'] == 'left') {
				if (!jQuery.isEmptyObject(tempnav)){
					//Prev item already exists. so push it to nav list
					//create a new item with type spread and left set
					nav_list.push(tempnav);
					tempnav = {};
					tempnav["navtype"] = "spread";
					tempnav["left"] =k;
					tempnav["center"] = "page-blank.html";
				} else {
					//empty nav object. so setup left spread values
					tempnav["navtype"] = "spread";
					tempnav["left"] = k;
					tempnav["right"] = "";
					tempnav["center"] = "page-blank.html";
				}
			} else if (display_item['page-spread'] == 'right') {
				if (!jQuery.isEmptyObject(tempnav)){
					//Nav object set. So set the right spread value,
					//push the item to nav list. Reset the nav object
					tempnav["navtype"] = "spread";
					tempnav["right"] = k;
					tempnav["center"] = "page-blank.html";
					nav_list.push(tempnav);
					tempnav = {}
				} else {
					//empty nav object. This means that the left spread is blank
					//and right spread is the current item. create and push the
					//nav object directly
					tempnav["navtype"] = "spread";
					tempnav["left"] = "page-blank.html";
					tempnav["right"] =k;
					tempnav["center"] = "page-blank.html";
					nav_list.push(tempnav);
					tempnav = {};
				}
			}  else if (display_item['page-spread'] == 'center') {
				if (!jQuery.isEmptyObject(tempnav)){
					//push the current object into nav list. and
					//create a new nav object to store the center spread
					nav_list.push(tempnav);
					tempnav = {}
				} 
				tempnav["navtype"] = "flow";
				tempnav["left"] = "page-blank.html";
				tempnav["right"] = "page-blank.html";
				tempnav["center"] = k;
				nav_list.push(tempnav);
				tempnav = {};
			} else if (display_item['page-spread'] == 'reflow') {
				if (!jQuery.isEmptyObject(tempnav)){
					//push the current object into nav list. and
					//create a new nav object to store the center spread
					nav_list.push(tempnav);
					tempnav = {}
				} 
				tempnav["navtype"] = "reflow";
				tempnav["left"] = "page-blank.html";
				tempnav["right"] = "page-blank.html";
				tempnav["center"] = k;
				nav_list.push(tempnav);
				tempnav = {};
			} else {
				//default case: auto
				if (!jQuery.isEmptyObject(tempnav)){
					//the nav object is not empty. So this must be the right spread
					tempnav["navtype"] = "spread";
					tempnav["right"] = k;
					tempnav["center"] = "page-blank.html";
					nav_list.push(tempnav);
					tempnav = {};
				} else {
					//empty object. So lets populate the left spread
					tempnav["navtype"] = "spread";
					tempnav["left"] = k;
					tempnav["right"] = "";
					tempnav["center"] = "page-blank.html";
				}
			}
		}
		
		
		if (!jQuery.isEmptyObject(tempnav)){
			//push the last item into the nav list
			nav_list.push(tempnav);
			tempnav = {}
		} 
		
		//Create a reverse lookup from idref to the actual nav list pos
		for (var i = 0; i < nav_list.length; i ++) { 
			var lspread = nav_list[i]["left"];
			var rspread = nav_list[i]["right"];
			var cspread = nav_list[i]["center"];
			
			//Swap the left and right spread values for the 
			//Right to left books
			if (config.page_progression_dir == "rtl") {
				nav_list[i]["right"] = lspread;
				nav_list[i]["left"] = rspread;
			}
			
			if ((lspread != "") && (lspread != "page-blank.html")) {
				nav_lookup[lspread] = i;
			}
			if ((rspread != "") && (rspread != "page-blank.html")) {
				nav_lookup[rspread] = i;
			}
			if ((cspread != "") && (cspread != "page-blank.html")) {
				nav_lookup[cspread] = i;
			}
		}
	};
	
	var preprocessDisplaySettings = function() {
		//Setting global reflowable property
		//if epub is set to reflowable, and the spine item is not prepaginated, then 
		//display the spine item as reflowable content
		for (k in config.spineProperties){
			var display_item = config.spineProperties[k];
			if ((Epub.is_fixed_layout == false)&& (display_item['layout'] != "pre-paginated")) {
				display_item['page-spread'] = 'reflow';
			} else if ((Epub.is_fixed_layout == false) && (display_item['layout'] == "pre-paginated")) {
				//Even if we have a single item in the spine which is prepaginated
				//We switch tot the fixed layout mode
				Epub.is_fixed_layout = true;
				
				//if a spine item spread is set to none, display it as center spread
				if (display_item['spread'] == 'none') {
					if ((display_item['page-spread'] == "") || (display_item['page-spread'] == "auto")) {
						display_item['page-spread'] = 'center';
					}
				}
				
				//if epub is set to pre-paginated, and the document spread is set to none, then 
				//display the spine items as center spread
				if (doc_spread == "none") {
					if ((display_item['page-spread'] == "") || (display_item['page-spread'] == "auto")) {
						display_item['page-spread'] = 'center';
					}
				}
			} else if ((Epub.is_fixed_layout) && (display_item['layout'] == "pre-paginated")) {
				if (display_item['spread'] == 'none') {
					if ((display_item['page-spread'] == "") || (display_item['page-spread'] == "auto")) {
						display_item['page-spread'] = 'center';
					}
				}
			} else if ((Epub.is_fixed_layout) && (display_item['layout'] == "reflowable") && display_item['reflowmode'] ) {
				display_item['page-spread'] = 'reflow';
			}
			
			
			if (display_item['spread'] != "none") {
				//Auto spread setup based on section epubtypes
				//Cover::center, TitlePage::right, CopyrightPage::left
				try {
					if (display_item['epubtype'].indexOf('cover')!= -1) {
						//do this only if the spine item does not have a predefined page spread
						if ((display_item['page-spread'] == "") || (display_item['page-spread'] == "auto")) display_item['page-spread'] = 'center';
					}
					
					if (display_item['epubtype'].indexOf('titlepage')!= -1) {
						if ((display_item['page-spread'] == "") || (display_item['page-spread'] == "auto")) display_item['page-spread'] = 'right';
					}
					
					if (display_item['epubtype'].indexOf('copyright')!= -1) {
						if ((display_item['page-spread'] == "") || (display_item['page-spread'] == "auto")) display_item['page-spread'] = 'left';
					}
					
					if (display_item['epubtype'].indexOf('part')!= -1) {
						if ((display_item['page-spread'] == "") || (display_item['page-spread'] == "auto")) display_item['page-spread'] = 'right';
					}
				} catch(e) {
				
				}
			}
			
			config.spineProperties[k] = display_item;
		}
		
		for (k in config.spineProperties){
			var display_item = config.spineProperties[k];
			if (Epub.is_fixed_layout == true)  {
				//here we want to find out which spine items need to be displayed as 
				//center spread
				
				//if a spine item spread is set to reflowable, display it as reflow item
				if (display_item['layout'] == 'reflowable') {
					if (display_item['reflowmode']) {
						display_item['page-spread'] = 'reflow';
					} else {
						if (display_item['page-spread'] == "") display_item['page-spread'] = 'auto';
						if (display_item['spread'] == "none") {
							if ((display_item['page-spread'] == "left") || (display_item['page-spread'] == "right")) {
								//In this case do nothing. This will then get used for vertical stacking
							} else {
								//else display the spread in the center
								display_item['page-spread'] = 'center';
							}
						}
					}
					config.spineProperties[k] = display_item;
					k = k + 1;
					//stop further evaluations and continue to the next item
					continue;
				}
					
				//if a spine item spread has no dimensions set, display it as center spread
				if ((!display_item.hasOwnProperty("width")) || (!display_item['width'])) {
					display_item['page-spread'] = 'center';
					display_item["width"] = -1;
					display_item["height"] = -1;
					config.spineProperties[k] = display_item;
					continue;
				}
				if ((!display_item.hasOwnProperty("height")) || (!display_item['height'])) {
					display_item["width"] = -1;
					display_item["height"] = -1;
					config.spineProperties[k] = display_item;
					display_item['page-spread'] = 'center';
					continue;
				}
				
				//if a spine item spread is set to none, display it as center spread
				if (display_item['spread'] == 'none') {
					if ((display_item['page-spread'] == "left") || (display_item['page-spread'] == "right")){
						//IGP Special case: display as top and bottom spread
					} else {
						//Disable spread and Show this in the center 
						display_item['page-spread'] = 'center';
					}
				}
				
				//if a spine item spread is set to landscape and doc orientation is portait, display it as center spread
				if ((display_item['spread'] == 'landscape') && (self.doc_orientation == 'portrait')) {
					display_item['page-spread'] = 'center';
				}
				
				//if a spine item spread is set to portrait and doc orientation is landscape, display it as center spread
				if ((display_item['spread'] == 'portrait') && (self.doc_orientation == 'landscape')) {
					display_item['page-spread'] = 'center';
				}
				
				//if epub is set to pre-paginated, and the document spread is set to none, then 
				//display the spine items as center spread
				if (doc_spread == "none") {
					display_item['page-spread'] = 'center';
				}
			}			
			
			config.spineProperties[k] = display_item;
			
		}
		
		createNavList();
	}
	
	/**
	 * Unloads the epub by resetting all the variables used.
	 */
	var unload = function(){
		try {
			$('#but_toc').removeAttr('checked');
			$('#but_landmark').removeAttr('checked');
			$('#book_context_menu').hide();
			$('#doc-viewer-azd').attr('src', '');
			$("#doc-flo-viewer-azd").attr('src', '');
			Chapter.config.currentChapter = 0;
			Chapter.flo_pageref_display_index = 3;
			Chapter.config.currentNavPos = 0;
			config.spineList.splice(0, config.spineList.length);
			config.bookData.splice(0, config.bookData.length);
			config.unavailableItem.splice(0, config.unavailableItem.length);
			config.tocPath = '';
			config.tocFound = false;
			config.version = '';
			config.containErrors = false;
			config.epubId = '';
			config.epub3TocData = '';
			config.epub3TocHref = '';
			config.epub3LandmarkData = '';
			config.epub3PageNavData = '';
			config.epub2FullPageTocData = null;
			config.epub2InPageTocData = null;
			//DC - FLO UPDATE - 201211
			config.rendition_layout = "reflowable";
			config.rendition_orientation = "auto";
			config.rendition_spread = "auto";
			config.spineProperties = {};
			config.page_progression_dir = "ltr",
			Epub.is_fixed_layout = false;
			config.ispubdownload = false;
			config.isexternalimages = false;
			config.pubdoc_ext_images = {};
			Epub.doc_orientation = "auto";
			Epub.doc_spread = "auto";
			nav_list.splice(0, nav_list.length);
			for (var k = 0; k < config.tmpfolders.length; k++) {
				var path = config.tmpfolders[k];
				deleteFolder(path);
			}
			config.tmpfolders.splice(0, config.tmpfolders.length);
			
			if(BookPref.config.columns){
				Columns.unbindResize();
			}
		} catch(e) {
			 //alert(e);
		}
	};
	
	/**
	 * Get the epub unzip location
	 */
	var getExtractLocation = function() {
		var file = Components.classes["@mozilla.org/file/directory_service;1"]
							 .getService(Components.interfaces.nsIProperties)
							 .get("ProfD", Components.interfaces.nsIFile);
		file.append("quizfx");

		config.extractLocation = file.path;
	};
	
	/**
	 * Get the name of the folder which is extracted.
	 */
	var getExtractedFolderName = function(fileName){
		config.extractedFolder = fileName.substr(0, fileName.lastIndexOf('.'));
	};
	
	var getNavListPos = function(targetitem) {
		for(var i=0; i < nav_list.length; i++) {
			var navitem = nav_list[i];
			if ((navitem["left"] == targetitem) || (navitem["right"] == targetitem) || (navitem["center"] == targetitem)) {
				return i;
			}
		}
		
		return -1;
	}
	
	
	/**
	 * Get the epub js data
	 * @params opfFilePath Path of the .opf file
	 */
	var getScriptData = function(opfFilePath) {
		var self = this;
		
		for(var i=0; i<config.bookData.length; i++) {
			if(config.bookData[i]['mediaType'] == 'text/javascript' || config.bookData[i]['mediaType'] == 'application/javascript') {
				var scriptPath = self.getEntityAbsolutePath(opfFilePath, config.bookData[i]['href']);
				try{
					config.bookData[i]['data'] = readFileUTF(scriptPath);
					config.bookData[i]['available'] = 'true';
				} catch(e) {
					config.bookData[i]['data'] = '';
					config.bookData[i]['available'] = 'false';
				}
			}
		}
	};
	
	/**
	 * Get the content of .smil file
	 * @params opfFilePath Path of .opf file
	 */
	var getSmilData = function(opfFilePath) {
		var self = this;
		
		for(var i = 0; i < config.bookData.length; i++){
			if (config.bookData[i]['mediaType'] == 'application/smil+xml') { 
				var smilPath = self.getEntityAbsolutePath(opfFilePath, config.bookData[i]['href']);
				try{
					//Get the content of .smil file ready for applying xsl
					var smilContent = self.extractSmilContent(smilPath);
				}
				catch(e){
					// If the file not found at the location.
					config.bookData[i]['data'] = '';
					config.bookData[i]['available'] = 'false';
					continue;
				}
				writeFileUTF(smilPath, smilContent);
				
				var smilFile = getFileObjectFromPath(smilPath);
				var smilUrl = getURL(smilFile);
				
				var xml = loadXMLDoc(smilUrl);
				
				var xslSmilPage = loadXMLDoc("xsl/smil-to-array_conversion.xsl");
			    
		        if(document.implementation && document.implementation.createDocument){
		            var xsltProcessorSmilPage = new XSLTProcessor();
					
		            xsltProcessorSmilPage.importStylesheet(xslSmilPage);
					
		            var resultDocumentSmilPage = xsltProcessorSmilPage.transformToFragment(xml, document);
					
					var smilData = eval($(document.getElementById('doc-viewer-azd').contentWindow.document.createElement('div'))
													.html(resultDocumentSmilPage)
													.html());
													
					smilData = self.processSmilData(smilData);
					config.bookData[i]['data'] = smilData;
					config.bookData[i]['available'] = 'true';
				}
			}
		}
	};
	
	/* font de-obfuscation function */
	/* http://www.idpf.org/epub/20/spec/FontManglingSpec.html */
	var fixFonts = function(content) {
		if ((content.indexOf("OTTO") == 0)|| (content.indexOf("wOFF") == 0)) {
			return content;
		} else {
			var prefix = content.slice(0, 1040);
			var bytes = string2Bin(prefix);
			var masklen = g_uid_hashed.length;
			for (var i = 0; i < 1040; i++) {
				bytes[i] = bytes[i] ^ (g_uid_hashed[i % masklen]);
			}
			var results = bin2String(bytes);
			return results + content.slice(1040);
		}
	}

	var setupUIDHashKey = function(uid) {
		var utf8_str = encode_utf8(uid.trim());
		var digestBytes = window.Crypto.SHA1(utf8_str, { asBytes: true });
		window.g_uid_hashed = digestBytes; 
	}
	/*font de-obfuscation ends here*/
	
	/*
		Process fonts for de obfuscation
	*/
	var processFonts = function() {
		try {
			/*
				We load the encryption file and get all the EncryptionMethod elements
				with algorithm value set to font embedding. We then store the font names
				in a array and then check it with the opf font lookup. If found, we use the
				fixFonts method to de-obf the font
			*/
			var fflist = [];
			var parser = Components.classes["@mozilla.org/xmlextras/domparser;1"]
								.createInstance(Components.interfaces.nsIDOMParser);
			var encryptionXmlPath = getAppendFilePath(config.extractLocation, [config.extractedFolder, 'META-INF', 'encryption.xml']);
			try{
				var encryptionXmlContent = readFileUTF(encryptionXmlPath);
				var parser = new DOMParser();
				var doc = parser.parseFromString(encryptionXmlContent, "application/xml");
				var doc_elem = doc.documentElement;
				
				for(i = 0; i < doc_elem.childNodes.length; i++){
					var el = doc_elem.childNodes[i];
					if (el.localName == "EncryptedData") {
						var enc_method = el.getElementsByTagName("enc:EncryptionMethod")[0];
						if (!enc_method) {
							var enc_method = el.getElementsByTagName("EncryptionMethod")[0];
						}
						var algorithm = "";
						if (enc_method && enc_method.hasAttribute("Algorithm")) {
							algorithm = enc_method.getAttribute("Algorithm");
							if (algorithm != "http://www.idpf.org/2008/embedding") continue;
						}
						try {
						var cipher_ref = el.getElementsByTagName("enc:CipherReference")[0];
						if(!cipher_ref) {
							var cipher_ref = el.getElementsByTagName("CipherReference")[0];
						}
						if (cipher_ref && cipher_ref.hasAttribute("URI")) {
							var uri = cipher_ref.getAttribute("URI");
							fflist.push(uri);
						}
						
						} catch(e) {
							
						}
					}
				}
			}
			catch(e){
				//dont do any de obs operation
				return;
			}
			
			var identifier = config.identifier;
			for (var i=0; i < fflist.length; i++) {
				var fontname = fflist[i].split("/").pop();
				setupUIDHashKey(identifier);
				for (ffname in fontfile_lookup) {
					if (ffname.indexOf(fontname) < 0) continue;
					var content = loadBinaryFile(fontfile_lookup[ffname]);
					var newfontcontent = fixFonts(content);
					saveBindata(fontfile_lookup[ffname],string2Bin(newfontcontent));
					break;
				}
		    }
		} catch(e) {
			
		}
	}
	
	/**
	 * Get the font and image data as datauri
	 * @params opfFilePath Path to .opf file
	 */
	var getFontAndImageData = function(opfFilePath){
		var self = this;
		
		for(var i = 0; i < config.bookData.length; i++){
			if(config.bookData[i]['mediaType'].search(/font/ig) != -1 || config.bookData[i]['mediaType'] == 'application/vnd.ms-opentype'){
				var fontPath = self.getEntityAbsolutePath(opfFilePath, config.bookData[i]['href']);
				try{
					config.bookData[i]['data'] = generateDataURI(fontPath);
					config.bookData[i]['available'] = 'true';
					fontfilename = fontPath.split("/").pop();
					fontfile_lookup[fontfilename] = fontPath;
				} catch(e) {
					config.bookData[i]['data'] = '';
					config.bookData[i]['available'] = 'false';
					config.containErrors = true;
				}
			}
			else if(config.bookData[i]['mediaType'].split('/')[0] == 'image'){
				var imagePath = self.getEntityAbsolutePath(opfFilePath, config.bookData[i]['href']);
				try{
					config.bookData[i]['data'] = generateDataURI(imagePath);
					config.bookData[i]['available'] = 'true';
				}
				catch(e){
					config.bookData[i]['data'] = '';
					config.bookData[i]['available'] = 'false';
					config.containErrors = true;
				}
			}
		}
	};
	
	/**
	 * Copy audio and video files in temp location
	 * @params opfFilePath Path to .opf file
	 */
	var copyAudioAndVideo = function(opfFilePath) {
		var self = this;
		for(var i=0; i<config.bookData.length; i++) {
			if(config.bookData[i]['mediaType'] == 'unknown' ||
			   config.bookData[i]['mediaType'] == 'audio/mp4' || 
			   config.bookData[i]['mediaType'] == 'video/mp4' || 
			   config.bookData[i]['mediaType'] == 'audio/mpeg' || 
			   config.bookData[i]['mediaType'] == 'video/mpeg' || 
			   config.bookData[i]['mediaType'] == 'audio/ogg' || 
			   config.bookData[i]['mediaType'] == 'video/ogg' ||
			   config.bookData[i]['mediaType'] == 'audio/webm' ||
			   config.bookData[i]['mediaType'] == 'video/webm' ||
			   config.bookData[i]['mediaType'] == 'application/x-shockwave-flash' ||
			   config.bookData[i]['mediaType'] == 'application/pdf'){
				var contentPath = self.getEntityAbsolutePath(opfFilePath, config.bookData[i]['href']);
				var sourceFile = getFileObjectFromPath(contentPath);
				var filename = config.bookData[i]['href'].split('/').pop();
				
				try {
					var destObj = getFileObject(['ProfD', 'quizfx', 'buffer', config.epubId]);
					
				    if (!destObj.exists()) {
				    	destObj.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
				    }
					sourceFile.copyTo(destObj, null);
					config.bookData[i]['available'] = 'true';
				}
				catch(e){
					config.bookData[i]['available'] = 'false';
					config.containErrors = true;
				}
			}
		}
	};
	
	//CAUTION: Style data has to extracted in following manner, so we can change fonts and background images with datauri
	/**
	 * Get the style data from stylesheet
	 * @params opfFilePath Path to .opf file
	 */
	var getStyleData = function(opfFilePath, opfFilePath){
		var self = this;
		try{
			var extStyleSheets = document.getElementById('pageContainerIframe').contentWindow.document.styleSheets;
			
			
			var styleSheetUrl = new Array();
			for(var i = 0; i < extStyleSheets.length; i++){
				styleSheetUrl.push(extStyleSheets[i].href);
			}
			
			for (var i = 0; i < styleSheetUrl.length; i++) {
				for (var j = 0; j < config.bookData.length; j++) {
					if (config.bookData[j]['mediaType'] == 'text/css') {
						var cssPath = self.getEntityAbsolutePath(opfFilePath, config.bookData[j]['href']);
						var cssUrl = getURL(getFileObjectFromPath(cssPath));
						if(cssUrl == styleSheetUrl[i]){
							if(config.bookData[j]['data'] == ''){
								//Get all the rules
								var currstylesheet = extStyleSheets[i];
								var tempcssUrl = cssUrl;
							
								var ruleList = self.getCSSDataFromFile(currstylesheet.href, opfFilePath);
								config.bookData[j]['data'] = ruleList;
								config.bookData[j]['available'] = 'true';
								
							}
							break;
						}
					}
				}
			}
			//TODO: again use a for loop on config.bookdata and then check if everything is true, if not then set containerrors variable to true
		}catch(e){}
	};
	
	var getCSSDataFromFile = function(cssurl, opfFilePath){
		var self = this;
		try {
			var basefilename = cssurl.split('/').pop();
			for (var j = 0; j < config.bookData.length; j++) {
				if (config.bookData[j]['mediaType'] == 'text/css') {
					var currCSSName = config.bookData[j]['href'].split('/').pop();
					
					if (basefilename == currCSSName) {
						var cssPath = self.getEntityAbsolutePath(opfFilePath, config.bookData[j]['href']);
						var cssdata = readFileUTF(cssPath);
						var cssdata1 = "";
						var parser = new CSSParser(); 
						var sheet = parser.parse(cssdata, false, true); 
						var frlist = [];
						
						for (var k =0; k<sheet.cssRules.length; k++ ){
							var ruleText = sheet.cssRules[k].cssText();
							if (ruleText.indexOf("@import")!= -1){
								var cssfilename = self.extractCSSName(ruleText);
								var fdata = self.getCSSDataFromFile(cssfilename, opfFilePath);
								frlist.push([ruleText, fdata]);
							} else {
								try {
									var temp = ruleText.split('{');
									if(typeof temp[1] != 'undefined'){
										ruleArray = temp[1].split('}')[0].split(';');
									
										for(var j = 0; j < ruleArray.length; j++){
											if(ruleArray[j].search(/url/ig) != -1){
												var url = ruleArray[j].replace(/\"/g, '\'');
												url = url.split('\'')[1].split('\'')[0];
												//Get the datauri
												var dataUri = self.getUri(url);
												ruleText = ruleText.replace('\''+url+'\'', dataUri);
												frlist.push([url, dataUri]);
											}
										}
									}
								}catch(e){
									
								}
							}
						}
						//Now replace the fonts and images and import statements
						for (var k =0; k<frlist.length; k++ ){
							cssdata = cssdata.replace(frlist[k][0],frlist[k][1]);
						}
						
						return cssdata;
					}
				}
			}
		}catch(e){
			return "";
		}
		return "";
	};
	
	var extractCSSName = function(ruleText) {
		var fileText = ruleText.replace("@import","");
		fileText = fileText.replace(/"/g,"").replace(/'/g,"").replace(/url\(|\)$/ig, "");
		fileText = fileText.replace(");","");
		fileText = $.trim(fileText);
		return fileText;
	};
	
	/**
	 * Returns the css rules from stylesheet
	 * @params styleSheet Stylesheet object
	 * @returns {string} List of all rules in current stylesheet
	 */
	var getCssRules = function (styleSheet, opfFilePath) {
		try{
			var self = this;
			var ruleList = '';
			var rules = styleSheet.cssRules;
			for (var i=0; i < rules.length; i++) {
				var ruleText = "";
				if ( rules[i].type == 3 ) {
					var temps = rules[i].styleSheet;
					var innerrules = self.getCSSDataFromFile(rules[i].href, opfFilePath);
					ruleText = innerrules;
				} else {
					ruleText = rules[i].cssText;
					var temp = ruleText.split('{');
					if(typeof temp[1] != 'undefined'){
						ruleArray = temp[1].split('}')[0].split(';');
					
						for(var j = 0; j < ruleArray.length; j++){
							if(ruleArray[j].search(/url/ig) != -1){
								var url = ruleArray[j].split('"')[1].split('"')[0];
								//Get the datauri
								var dataUri = self.getUri(url);
								ruleText = ruleText.replace('"'+url+'"', dataUri);
							}
						}
					}  
				}
				ruleText = ruleText + "\n";
				ruleList += ruleText;
			}
			
			return ruleList;
		} catch(e) {
			return "";
		}
	};
	
	/**
	 * Get the dataUri of the file
	 * @params url Url of the file
	 * @returns {string} DataUri of the file
	 */
	var getUri = function (url) {
		var self =this;
		
		var dataUri = '';
		for (var i=0; i < config.bookData.length; i++) {
			if(config.bookData[i]['href'].split('/').pop() == url.split('/').pop()){
				dataUri = config.bookData[i]['data'];
				break;
			}
		}
		return dataUri;
	};
	
	var getCustomPresentationDataDom = function(docobj) {
		try {
			var self = this;
			$.each($(docobj).contents().find('head meta'), function(e) {
				var metaName = $(this).attr('name');
				if(typeof metaName != 'undefined' && metaName != '') {
					switch(metaName) {
						case 'azardi-presentation':
							config.bookData[config.htmlCounter]['azardi-presentation'] = $(this).attr('content');
							break;
						case 'azardi-width':
							config.bookData[config.htmlCounter]['azardi-width'] = $(this).attr('content');
							break;
						case 'azardi-height':
							config.bookData[config.htmlCounter]['azardi-height'] = $(this).attr('content');
							break;
						case 'azardi-margins':
							config.bookData[config.htmlCounter]['azardi-margins'] = $(this).attr('content');
							break;
						case 'azardi-toc':
							config.bookData[config.htmlCounter]['azardi-toc'] = $(this).attr('content');
							break;
						case 'viewport': 
							//DC - FLO UPDATE - 201211
							var meta_val = $(this).attr('content');
							meta_val = $.trim(meta_val);
							meta_val_l = meta_val.split(",");
							if (meta_val_l.length < 2) break;
							var width = "";
							var height = "";
							try {
								for(var i=0; i < meta_val_l.length; i++) {
									var prop = meta_val_l[i];
									if (prop.indexOf("width=")!= -1) {
										width = prop.split("=")[1];
									}
									if (prop.indexOf("height=")!= -1) {
										height = prop.split("=")[1];
									}
								}
							} catch(e) {
								dump("\ngetCustomPresentationData exception " + e);
							} 
							
							config.bookData[config.htmlCounter]['viewport-width'] = width;
							config.bookData[config.htmlCounter]['viewport-height'] = height;
							break;
					} 
				}
			});
			
			config.bookData[config.htmlCounter]['epubtype'] = "";
			var sections = $(docobj).contents().find('body section');
			if (sections.length > 0) {
				var first_section = sections[0];
				var epubtype = $(first_section).attr("epub:type");
				if (epubtype) config.bookData[config.htmlCounter]['epubtype'] = epubtype;
			}
		} catch(e) {
			
		}
	}
	
	//CAUTION: Modify the following function if you really know what you are doing.
	/*
	 	Following two functions are used to get the html content as well as css content from the html file.
	 	The target html page is first loaded in hidden iframe, and when the page is completely loaded,
	 	then the content is extracted from it and saved in variables.
	 	After every html page is processed, then we proceed to Chapter.init() which initilizes the chapter.
	 */
	/**
	 * Extracts the html content from the hidden iframe
	 * @params opfFilePath Path to .opf file
	 */
	var getHtmlData = function(opfFilePath){
		var self = this;
		for(var i = 0; i < config.bookData.length; i++){
			config.htmlCounter = i;
			if(config.bookData[config.htmlCounter]['mediaType'] == 'text/html' || config.bookData[config.htmlCounter]['mediaType'] == 'application/xhtml+xml'){
				try {
					var htmlPath = getEntityAbsolutePath(opfFilePath, config.bookData[config.htmlCounter]['href']);
					var htmlObj = getFileObjectFromPath(htmlPath);
					var filename = htmlObj.leafName.split('.');
					var name = filename[0];
					var extension = filename[1];
					
					if(config.bookData[config.htmlCounter]['mediaType'] === 'application/xhtml+xml' && extension !== 'xhtml') {
						//	Mozilla doesn't recognize XML declaration if the file-extension is incorrect, hence renaming the file.
						htmlObj.moveTo(null, name+'.xhtml');
					}
					
					var htmlUrl = getURL(htmlObj);
					
					//	If the required file does not exists then set available as false.
					if(!htmlObj.exists()) {
						config.bookData[config.htmlCounter]['available'] = 'false';
					}
					var parser = new DOMParser();
					var stringContainingXMLSource = config.bookData[config.htmlCounter]["htmlXmlContent"];			
					var doc = parser.parseFromString(stringContainingXMLSource, "application/xml");
					getCustomPresentationDataDom(doc);
					config.bookData[config.htmlCounter]['available'] = 'true';
					config.bookData[config.htmlCounter]['htmlUrl'] = htmlUrl;
				} catch(e) {
					config.bookData[config.htmlCounter]['available'] = 'false';
				}
			}
		}
		
		config.htmlCounter = 0;
		config.customCss = 1;
		$('#pageContainerIframe').unbind('DOMContentLoaded');
		
		try {
			self.processSpine();
		} catch(e) {
			config.prompts.alert(null, AME.getTitle(), e.message);
			self.unload();
			AME.showLibrary();
			return;
		}
		
		
		
		$('#pageContainerIframe').attr('src', '');
		//Initilize the chapter
		azLogTime("loadfinishes 2");
		setTimeout( function(){
			Chapter.init();
			}, 100);
		
		Toolbar.showEpub();
		
		/*var self = this;
		$('#pageContainerIframe').bind('DOMContentLoaded', function(e){
			config.bookData[config.htmlCounter]['available'] = 'true';
			//config.bookData[config.htmlCounter]['data'] =  $('#pageContainerIframe').contents().find('body').html();
			//Get the style data from stylesheet
			//self.getStyleData(opfFilePath, opfFilePath);
			//Get the external css references for this page
			//self.getCssReferences();
			//Get the external js references for this page
			//self.getJsReferences();
			//Get the fixed layout presentation information for this page.
			self.getCustomPresentationData();
			// self.getScriptData(opfFilePath);
			
			config.htmlCounter = config.htmlCounter + 1;
			if(config.htmlCounter < config.bookData.length){
				self.loadHtmlPage(opfFilePath);
			} else {
				config.htmlCounter = 0;
				config.customCss = 1;
				$('#pageContainerIframe').unbind('DOMContentLoaded');
				try{
					//Remove the unavailable items from the spine
					self.processSpine();
				}
				catch(e){
					config.prompts.alert(null, AME.getTitle(), e.message);
					self.unload();
					AME.showLibrary();
					return;
				}
				$('#pageContainerIframe').attr('src', '');
				//Initilize the chapter
				azLogTime("loadfinishes 1");
				Chapter.init();
				//DC - FLO UPDATE - 201211 - dont delete the epub
				//deleteFolder(getAppendFilePath(config.extractLocation, [config.extractedFolder]));
			}
		});
		
		self.loadHtmlPage(opfFilePath);*/
	}
	
	//CAUTION: Modify the following function if you really know what you are doing.
	/**
	 * Opens the html page in hidden iframe, once the page is loaded getHtmlData is called
	 * @params opfFilePath Path to .opf file
	 */
	var loadHtmlPage = function(opfFilePath){
		var self = this;
		if(config.bookData[config.htmlCounter]['mediaType'] == 'text/html' || config.bookData[config.htmlCounter]['mediaType'] == 'application/xhtml+xml'){
			var htmlPath = getEntityAbsolutePath(opfFilePath, config.bookData[config.htmlCounter]['href']);
			var htmlObj = getFileObjectFromPath(htmlPath);
			var filename = htmlObj.leafName.split('.');
			var name = filename[0];
			var extension = filename[1];
			
			if(config.bookData[config.htmlCounter]['mediaType'] === 'application/xhtml+xml' && extension !== 'xhtml') {
				//	Mozilla doesn't recognize XML declaration if the file-extension is incorrect, hence renaming the file.
				htmlObj.moveTo(null, name+'.xhtml');
			}
			
			var htmlUrl = getURL(htmlObj);
			
			//	If the required file does not exists then set available as false.
			if(!htmlObj.exists()) {
				config.bookData[config.htmlCounter]['available'] = 'false';
				config.htmlCounter = config.htmlCounter + 1;
				if (config.htmlCounter < config.bookData.length) {
					Epub.loadHtmlPage(opfFilePath);
				}
				else {
					config.htmlCounter = 0;
					config.customCss = 1;
					$('#pageContainerIframe').unbind('DOMContentLoaded');
					try{
						//Remove the unavailable items from the spine
						self.processSpine();
					}
					catch(e){
						config.prompts.alert(null, AME.getTitle(), e.message);
						self.unload();
						AME.showLibrary();
						return;
					}
					$('#pageContainerIframe').attr('src', '');
					//Initilize the chapter
					azLogTime("loadfinishes 2");
					Chapter.init();
					//DC - FLO UPDATE - 201211 - dont delete the epub
					//deleteFolder(getAppendFilePath(config.extractLocation, [config.extractedFolder]));
				}
			} else {
				$('#pageContainerIframe').attr('src', '');
				$('#pageContainerIframe').attr('src', htmlUrl);
				//DC - FLO UPDATE - 201211 - Store url for actual presentation
				config.bookData[config.htmlCounter]['htmlUrl'] = htmlUrl;
			}
		} else {
			config.htmlCounter = config.htmlCounter + 1;
			if (config.htmlCounter < config.bookData.length) {
				Epub.loadHtmlPage(opfFilePath);
			} else {
				config.htmlCounter = 0;
				config.customCss = 1;
				$('#pageContainerIframe').unbind('DOMContentLoaded');
				try{
					//Remove the unavailable items from the spine
					self.processSpine();
				}
				catch(e){
					config.prompts.alert(null, AME.getTitle(), e.message);
					self.unload();
					AME.showLibrary();
					return;
				}
				$('#pageContainerIframe').attr('src', '');
				//Initilize the chapter
				Chapter.init();
				azLogTime("loadfinishes 3");
				//DC - FLO UPDATE - 201211 - dont delete the epub
				//deleteFolder(getAppendFilePath(config.extractLocation, [config.extractedFolder]));
			}
		}
	}
	
	/**
	 * Extracts the toc data for epub3
	 * @params opfFilePath Path of .opf file
	 */
	var getTocDataEpub3 = function (opfFilePath) {
		var self =this;
		
		config.epub3PageNavData = '<div class="no_page-nav">No Page Navigation for this book.</div>';
		config.epub3LandmarkData = '<div class="no_landmark">No Landmarks for this book.</div>';
		
		$('#tocContainerIframe').bind('DOMContentLoaded', function(e){
			var navEle = $('#tocContainerIframe').contents().find('nav');
			//Get toc, landmark and page-list data
			$.each(navEle, function() {
				var navType = $(this).attr('epub:type');
				if(navType.toLowerCase() === 'toc') {
					config.epub3TocData =  $(this).html();
				} else if(navType.toLowerCase() === 'landmarks'){
					config.epub3LandmarkData = $(this).html();
				} else if(navType.toLowerCase() === 'page-list') {
					config.epub3PageNavData = $(this).html();
				}
			});
			// config.epub3TocData[0]['data'] =  $('#tocContainerIframe').contents().find('nav[epub:type="toc"]').html();
			$('#tocContainerIframe').unbind('DOMContentLoaded');
			$('#tocContainerIframe').attr('src', '');
			config.tocFound = true;
		});
		
		var htmlPath = getEntityAbsolutePath(opfFilePath, config.epub3TocHref);
		var htmlObj = getFileObjectFromPath(htmlPath);
		var htmlUrl = getURL(htmlObj);
		if(!htmlObj.exists()) {
			config.tocFound = false;
			$('#tocContainerIframe').unbind('DOMContentLoaded');
			self.getTocDataEpub2(opfFilePath);
		}
		else{
			$('#tocContainerIframe').attr('src', '');
			$('#tocContainerIframe').attr('src', htmlUrl);
		}
	};
	
	/**
	 * Extracts the toc data for epub3
	 * @params opfFilePath Path of .opf file
	 */
	var getTocDataEpub3JSON = function (opfData) {
		var self =this;
		
		config.epub3TocData =  '<div class="no_toc">No TOC for this book.</div>';
		config.epub3PageNavData = '<div class="no_page-nav">No Page Navigation for this book.</div>';
		config.epub3LandmarkData = '<div class="no_landmark">No Landmarks for this book.</div>';
		
		if (opfData.hasOwnProperty("landmark") && opfData["landmark"] != "") {
			config.epub3LandmarkData = opfData["landmark"];
		}
		
		if (opfData.hasOwnProperty("page_nav") && opfData["page_nav"] != "") {
			config.epub3PageNavData = opfData["page_nav"];
		}
		
		//TODO - LOAD THE ACTUAL TOC HERE 
		if (opfData.hasOwnProperty("side_toc") && opfData["side_toc"] != "") {
			config.epub3TocData = opfData["side_toc"];
		}
	};
	
	
	/**
	 * Get toc data for epub2
	 * @params opfFilePath Path for .opf file
	 */
	var getTocDataEpub2JSON = function(opfData){
		var self = this;
		
		config.epub2FullPageTocData = '<ol><li><a href="javascript: void(0);" class="azd-cover-link" onclick="javascript:parent.AME.goToCoverPage(\'full-page\');">COVER</a></li></ol>';
		config.epub2InPageTocData = '<div id="toc-azd" class="toc-azd"><ol><li><a href="javascript: void(0);" class="azd-cover-link" onclick="javascript:parent.AME.goToCoverPage(\'side\');">COVER</a></li></ol></div>';
		
		var parser = Components.classes["@mozilla.org/xmlextras/domparser;1"]
													.createInstance(Components.interfaces.nsIDOMParser);
		var domTree = parser.parseFromString(opfData["side_toc"], "text/html");
		
		if (opfData.hasOwnProperty("side_toc") && opfData["side_toc"] != "") {
			var tocdata = opfData["side_toc"];
			var fval = new Array();
			var t = "class=\"$h1$\"  onclick=\"xulconnector.send_request({action: \'goToFromToc\', param1: \'$h$\', param2: \'side\'});\" href=\"javascript: void(0);\"";
			var t1 = "href=\"$h$\"";
			var aNodes = domTree.getElementsByTagName("a");
			for (var i=0; i < aNodes.length; i++ ){
				var anode = aNodes[i];
				var href = anode.getAttribute("href");
				var rv = t.replace("$h$", href);
				var rv = rv.replace("$h1$", href);
				var fv = t1.replace("$h$", href);
				tocdata = tocdata.replace(fv, rv);
			}
			
			tocdata = tocdata.replace(/<text>/g, " ");
			tocdata = tocdata.replace(/<\/text>/g, " ");
			config.epub2InPageTocData = '<div id="toc-azd" class="toc-azd">' + tocdata + '</div>';
		}
		
		//TODO - LOAD THE ACTUAL TOC HERE
		if (opfData.hasOwnProperty("side_toc") && opfData["side_toc"] != "") {
			if (opfData.hasOwnProperty("side_toc") && opfData["side_toc"] != "") {
				var tocdata = opfData["side_toc"];
				var fval = new Array();
				var t = "class=\"$h1$\"  onclick=\"javascript:parent.AME.goToFromToc('$h$','full-page');\" href=\"javascript: void(0);\"";
				var t1 = "href=\"$h$\"";
				var aNodes = domTree.getElementsByTagName("a");
				for (var i=0; i < aNodes.length; i++ ){
					var anode = aNodes[i];
					var href = anode.getAttribute("href");
					var rv = t.replace("$h$", href);
					var rv = rv.replace("$h1$", href);
					var fv = t1.replace("$h$", href);
					var ta = [fv, rv];
					tocdata = tocdata.replace(fv, rv);
				}
				
				tocdata = tocdata.replace(/<text>/g, " ");
				tocdata = tocdata.replace(/<\/text>/g, " ");
			}
			config.epub2FullPageTocData = tocdata;
		}
		
	};
	
	/**
	 * Get toc data for epub2
	 * @params opfFilePath Path for .opf file
	 */
	var getTocDataEpub2 = function(opfFilePath){
		var self = this;
		
		for(var i = 0; i < config.bookData.length; i++){
			if (config.bookData[i]['mediaType'] == 'application/x-dtbncx+xml' || config.bookData[i]['id'] == 'ncx' || config.bookData[i]['id'] == 'dtbncx'){ 
				config.tocPath = self.getEntityAbsolutePath(opfFilePath, config.bookData[i]['href']);
				try{
					// Make the toc content ready for applying xsl
					var tocContent = self.extractTocContent(config.tocPath);
				}
				catch(e){
					// If the file not found at the location.
					config.tocFound = false;
					break;
				}
				writeFileUTF(config.tocPath, tocContent);
				config.tocFound = true;
				break;
			}
		}
		
		if(config.tocFound){
			var tocFile = getFileObjectFromPath(config.tocPath);
			var tocUrl = getURL(tocFile);
			
			var xml = loadXMLDoc(tocUrl);
			
			var xslFullPage = loadXMLDoc("xsl/ncx-to-li_nested.xsl");
	        var xslInPage = loadXMLDoc("xsl/ncx-to-li_conversion.xsl");
		    
	        if(document.implementation && document.implementation.createDocument){
	            var xsltProcessorFullPage = new XSLTProcessor();
				var xsltProcessorInPage = new XSLTProcessor();
				
	            xsltProcessorFullPage.importStylesheet(xslFullPage);
				xsltProcessorInPage.importStylesheet(xslInPage);
				
	            var resultDocumentFullPage = xsltProcessorFullPage.transformToFragment(xml, document);
				var resultDocumentInPage = xsltProcessorInPage.transformToFragment(xml, document);
				
				config.epub2FullPageTocData = $(document.getElementById('doc-viewer-azd').contentWindow.document.createElement('div'))
												.html(resultDocumentFullPage)
												.html();
												
				config.epub2FullPageTocData = config.epub2FullPageTocData.replace(/&nbsp;/g, " ")
				config.epub2InPageTocData = $(document.getElementById('doc-viewer-azd').contentWindow.document.createElement('div'))
												.html(resultDocumentInPage)
												.html();
				config.epub2InPageTocData = config.epub2InPageTocData.replace(/&nbsp;/g, " ")
	        }
		}
		else{
			config.epub2FullPageTocData = '<ol><li><a href="javascript: void(0);" class="azd-cover-link" onclick="javascript:parent.AME.goToCoverPage(\'full-page\');">COVER</a></li></ol>';
			
			config.epub2InPageTocData = '<div id="toc-azd" class="toc-azd"><ol><li><a href="javascript: void(0);" class="azd-cover-link" onclick="javascript:parent.AME.goToCoverPage(\'side\');">COVER</a></li></ol></div>';
		}
	};
	
	/**
	 * Removes DOCTYPE declaration, ncx:, ncx tag
	 * @params tocPath Path to the .ncx file
	 * @returns {string} manipulated toc content
	 */
	var extractTocContent = function(tocPath){
		var self = this;
		
		var tocContent = readFileUTF(tocPath);
		
		if (tocContent.search(/<!DOCTYPE/i) != -1){
			var startPos = tocContent.search(/<!DOCTYPE/i);
			var endPos = tocContent.indexOf('>', startPos);
			tocContent = tocContent.substr(0, startPos) + '' + tocContent.substr(endPos + 1);
		}
		
		var re = new RegExp('ncx:', "g");
		tocContent = tocContent.replace(re, '');
		
		if (tocContent.search(/<ncx/i) != -1){
			var startPos = tocContent.search(/<ncx/i);
			var endPos = tocContent.indexOf('>', startPos);
			tocContent = tocContent.substr(0, startPos) + '<ncx>' + tocContent.substr(endPos + 1);
		}
		
		return tocContent;
	};
	
	/**
	 * Get the content of .smil file ready for applying xsl
	 * @params smilPath Path to the .smil file
	 * @returns {string} Edited content of .smil file
	 */
	var extractSmilContent = function(smilPath){
		var self = this;
		
		var smilContent = readFileUTF(smilPath);
		
		var re = new RegExp('xmlns="http://www.w3.org/ns/SMIL"', "g");
		smilContent = smilContent.replace(re, '');
		
		return smilContent;
	};
	
	/**
	 * Epub2 - Set full page toc content in toc page
	 */
	var setFullPageTocDataEpub2 = function() {
		var self = this;
		$('#doc-viewer-azd').contents().find('.toc_placeholder').html(config.epub2FullPageTocData);
		self.processFullPageToc();
	};
	
	/**
	 * Set fly-out toc data in epub2
	 */
	var setInPageTocDataEpub2 = function(){
		var self = this;
		$('#doc-viewer-azd').contents().find('body').prepend(config.epub2InPageTocData);
		
		// if(config.tocFound){
			// var tocFile = getFileObjectFromPath(config.tocPath);
			// var tocUrl = getURL(tocFile);
// 			
			// var xml = loadXMLDoc(tocUrl);
// 			
			// var xslFullPage = loadXMLDoc("xsl/ncx-to-li_nested.xsl");
	        // var xslInPage = loadXMLDoc("xsl/ncx-to-li_conversion.xsl");
// 		    
	        // if(document.implementation && document.implementation.createDocument){
	            // var xsltProcessorFullPage = new XSLTProcessor();
				// var xsltProcessorInPage = new XSLTProcessor();
// 				
	            // xsltProcessorFullPage.importStylesheet(xslFullPage);
				// xsltProcessorInPage.importStylesheet(xslInPage);
// 				
	            // var resultDocumentFullPage = xsltProcessorFullPage.transformToFragment(xml, document);
				// var resultDocumentInPage = xsltProcessorInPage.transformToFragment(xml, document);
// 				
				// // config.epub2FullPageTocData = resultDocumentFullPage;
				// config.epub2FullPageTocData = $(document.getElementById('doc-viewer-azd').contentWindow.document.createElement('div'))
												// .html(resultDocumentFullPage)
												// .html();
				// // $('#toc-viewer-azd').contents().find('.toc_placeholder').html(resultDocumentFullPage);
// 				
				// $('#doc-viewer-azd').contents().find('body').prepend(resultDocumentInPage);
// 				
				self.processInPageToc();
	        // }
		// }
		// else{
			// // $('#toc-viewer-azd').contents().find('.toc_placeholder').html('<div class="no_toc">No Table of Content for this book.</div>');
			// config.epub2FullPageTocData = '<div class="no_toc">No Table of Content for this book.</div>';
// 				
			// $('#doc-viewer-azd').contents().find('body').prepend('<div class="toc-azd" id="toc-azd"><div class="no_toc">No Table of Content for this book.</div></div>');
		// }
	}
	
	var loadXMLDoc = function(dname){
	    if (window.XMLHttpRequest){
	        xhttp = new XMLHttpRequest();
	    }
	    else{
	        xhttp = new ActiveXObject("Microsoft.XMLHTTP");
	    }
	    xhttp.open("GET", dname, false);
	    xhttp.send("");
	    return xhttp.responseXML;
	};
	
	/**
	 * Sets the landmark data in landmark container
	 */
	var setLandmarkDataEpub3 = function () {
		var self = this;
		$('#doc-viewer-azd').contents().find('.landmark_placeholder').html(config.epub3LandmarkData);
		
		// $('#doc-viewer-azd').contents().find('.landmark_placeholder nav').removeAttr('hidden');
		
		$('#doc-viewer-azd').contents().find('.landmark_placeholder a').each(function () {
			var src = $(this).attr('href');
			$(this).attr('href', 'javascript: void(0);');
			var class_name = src.split('#')[0].split('/').pop();
			if (filename_lookup.hasOwnProperty(class_name)) {
				$(this).bind('click', function () {
					parent.AME.goToFromLandmark(src);
				});
			}
		});
		
		//Commented: as we only set the event handler to existing files
		//self.processLandmark();
	}
	
	/**
	 * Sets the page-nav data in page-nav container
	 */
	var setPageNavDataEpub3 = function() {
		var self = this;
		
		$('#doc-viewer-azd').contents().find('.page-nav_placeholder').html(config.epub3PageNavData);
		
		// $('#doc-viewer-azd').contents().find('.page-nav_placeholder nav').removeAttr('hidden');
		
		$('#doc-viewer-azd').contents().find('.page-nav_placeholder a').each(function () {
			var src = $(this).attr('href');
			$(this).attr('href', 'javascript: void(0);');
			var class_name = src.split('#')[0].split('/').pop();
			if (filename_lookup.hasOwnProperty(class_name)) {
				$(this).bind('click', function () {
					parent.AME.goToFromPageNav(src);
				});
			}
		});
		
		//Commented: as we only set the event handler to existing files
		//self.processPageNav();
	}
	
	/**
	 * Epub3 - Set full page toc data in toc page
	 */
	var setFullPageTocDataEpub3 = function(){
		var self = this;
		
		$('#doc-viewer-azd').contents().find('.toc_placeholder').html(config.epub3TocData);
		
		$('#doc-viewer-azd').contents().find('.toc_placeholder a').each(function () {
			var src = $(this).attr('href');
			$(this).attr('href', 'javascript: void(0);');
			var class_name = src.split('#')[0].split('/').pop();
			if (filename_lookup.hasOwnProperty(class_name)) {
				$(this).bind('click', function () {
					parent.AME.goToFromToc(src, 'full-page');
				});
			}
		});
		
		//Commented: as we only set the event handler to existing files		
		//self.processFullPageToc();
		
		if(!Epub.is_fixed_layout) {
			$('#doc-viewer-azd').contents().find('.toc_placeholder ol:first')
				.prepend('<li><a href="javascript: void(0);" class="azd-cover-link" onclick="javascript:parent.AME.goToCoverPage(\'full-page\');">COVER</a></li>');
		}
	};
	
	/**
	 * Set fly-out toc data in epub3
	 */
	var setInPageTocDataEpub3 = function(){
		var self = this;
		// if(config.tocFound){
			// $('#toc-viewer-azd').contents().find('.toc_placeholder').html(config.epub3TocData[0]['data']);
			
			if (config.epub3TocData.indexOf('class="toc-azd"') != -1) {
				$('#doc-viewer-azd').contents().find('body').prepend(config.epub3TocData);
			} else {
				$('#doc-viewer-azd').contents().find('body').prepend('<div class="toc-azd" id="toc-azd">'+config.epub3TocData+'</div>');
			}
			
			// $('#toc-viewer-azd').contents().find('.toc_placeholder a').each(function () {
				// var src = $(this).attr('href');
				// $(this).addClass(src);
				// $(this).attr('href', 'javascript: void(0);');
				// $(this).bind('click', function () {
					// parent.Chapter.goToFromToc(src, 'full-page');
				// });
			// });
			
			//Apply click event on each link
			$('#doc-viewer-azd').contents().find('.toc-azd a').each(function () {
				var src = $(this).attr('href');
				$(this).attr('href', 'javascript: void(0);');
				var class_name = src.split('#')[0].split('/').pop();
				if (filename_lookup.hasOwnProperty(class_name)) {
					$(this).bind('click', function () {
						parent.AME.goToFromToc(src, 'side');
					});
				}
			});
			
			//Change css class of the links which point to unavailable items
			//Commented - the check is done while setting the event handler itself
			//self.processInPageToc();
			
			if(!Epub.is_fixed_layout) {
				$('#doc-viewer-azd').contents().find('.toc-azd ol:first')
					.prepend('<li><a href="javascript: void(0);" class="azd-cover-link" onclick="xulconnector.send_request({action: \'goToCoverPage\', param1: \'side\'});">COVER</a></li>');
			}
			
		// }
		// else{
			// // $('#toc-viewer-azd').contents().find('.toc_placeholder').html('<div class="no_toc">No Table of Content for this book.</div>');
// 				
			// $('#doc-viewer-azd').contents().find('body').prepend('<div class="toc-azd" id="toc-azd"><div class="no_toc">No Table of Content for this book.</div></div>');
		// }
	} 
	
	/**
	 * This function changes the css class of the links which point to the unavailable items
	 */
	var processInPageToc = function () {
		var self = this;
		
		$('#doc-viewer-azd').contents().find('.toc-azd a').each(function () {
			//Do not touch following cover link
			//TODO: Check if this if condition can be removed
			if($(this).attr('class') === 'azd-cover-link') {
				//Continue the $.each loop
				return true;
			}
			
			var class_name = $(this).attr('class').split('#')[0].split('/').pop();
			if (!filename_lookup.hasOwnProperty(class_name)) {
				config.containErrors = true;
				$(this).addClass('missing-entry');
				$(this).removeAttr('onclick');
				$(this).unbind('click');
			}
		});
	};
	
	/**
	 * This function changes the css class of the links which point to the unavailable items
	 */
	var processPageNav = function() {
		var self = this;
		
		$('#doc-viewer-azd').contents().find('.section-label-rw').each(function() {
			var title = $(this).attr('title');
			var cloneEle = $(this).clone();
			$(cloneEle).insertBefore(this)
					   .html(title);
			$(this).removeClass('section-label-rw')
				   .removeAttr('title');
		});
		
		$('#doc-viewer-azd').contents().find('.page-nav_placeholder a').each(function () {
			var found = false;
			for (var i=0; i < config.bookData.length; i++) {
				var class_name = $(this).attr('class').split('#')[0].split('/').pop();
				var href = config.bookData[i]['href'].split('/').pop();
				if(class_name == href && config.bookData[i]['available'] == 'true'){
					found = true;
					break;
				}
			}
			if(!found){
				config.containErrors = true;
				$(this).addClass('missing-entry');
				$(this).removeAttr('onclick');
				$(this).unbind('click');
			}
		});
	}
	
	/**
	 * Process the landmark page and change the class of any missing link
	 */
	var processLandmark = function () {
		var self = this;
		
		$('#doc-viewer-azd').contents().find('.landmark_placeholder a').each(function () {
			var found = false;
			for (var i=0; i < config.bookData.length; i++) {
				var class_name = $(this).attr('class').split('#')[0].split('/').pop();
				var href = config.bookData[i]['href'].split('/').pop();
				if(class_name == href && config.bookData[i]['available'] == 'true'){
					found = true;
					break;
				}
			}
			if(!found){
				config.containErrors = true;
				$(this).addClass('missing-entry');
				$(this).removeAttr('onclick');
				$(this).unbind('click');
			}
		});
	}
	
	/**
	 * Process the full page toc and change the class of any missing link.
	 */
	var processFullPageToc = function () {
		var self = this;
		
		$('#doc-viewer-azd').contents().find('.toc_placeholder a').each(function () {
			if($(this).attr('class') === 'azd-cover-link') {
				return true;
			}
			
			var found = false;
			for (var i=0; i < config.bookData.length; i++) {
				var class_name = $(this).attr('class').split('#')[0].split('/').pop();
				var href = config.bookData[i]['href'].split('/').pop();
				if(class_name == href && config.bookData[i]['available'] == 'true'){
					found = true;
					break;
				}
			}
			if(!found){
				config.containErrors = true;
				$(this).addClass('missing-entry');
				$(this).removeAttr('onclick');
				$(this).unbind('click');
			}
		});
		
	};
	
	/**
	 * Get the fixed layout presentation information for this page.
	 */
	var getCustomPresentationData = function() {
		try {
			var self = this;
			
			$.each($('#pageContainerIframe').contents().find('head meta'), function(e) {
				var metaName = $(this).attr('name');
				
				if(typeof metaName != 'undefined' && metaName != '') {
					switch(metaName) {
						case 'azardi-presentation':
							config.bookData[config.htmlCounter]['azardi-presentation'] = $(this).attr('content');
							break;
						case 'azardi-width':
							config.bookData[config.htmlCounter]['azardi-width'] = $(this).attr('content');
							break;
						case 'azardi-height':
							config.bookData[config.htmlCounter]['azardi-height'] = $(this).attr('content');
							break;
						case 'azardi-margins':
							config.bookData[config.htmlCounter]['azardi-margins'] = $(this).attr('content');
							break;
						case 'azardi-toc':
							config.bookData[config.htmlCounter]['azardi-toc'] = $(this).attr('content');
							break;
						case 'viewport': 
							//DC - FLO UPDATE - 201211
							var meta_val = $(this).attr('content');
							meta_val = $.trim(meta_val);
							meta_val_l = meta_val.split(",");
							if (meta_val_l.length < 2) break;
							var width = "";
							var height = "";
							try {
								for(var i=0; i < meta_val_l.length; i++) {
									var prop = meta_val_l[i];
									if (prop.indexOf("width=")!= -1) {
										width = prop.split("=")[1];
									}
									if (prop.indexOf("height=")!= -1) {
										height = prop.split("=")[1];
									}
								}
							} catch(e) {
								dump("\ngetCustomPresentationData exception " + e);
							} 
							
							config.bookData[config.htmlCounter]['viewport-width'] = width;
							config.bookData[config.htmlCounter]['viewport-height'] = height;
							break;
					} 
				}
			});
			
			config.bookData[config.htmlCounter]['epubtype'] = "";
			var sections = $('#pageContainerIframe').contents().find('body section');
			if (sections.length > 0) {
				var first_section = sections[0];
				var epubtype = $(first_section).attr("epub:type");
				if (epubtype) config.bookData[config.htmlCounter]['epubtype'] = epubtype;
			}
		} catch(e) {
		
		}
	}
	
	/**
	 * Get the js references of the current html page
	 */
	var getJsReferences = function() {
		try {
			var self = this;
			
			var jsRef = new Array();
			$.each($('#pageContainerIframe').contents().find('script'), function(e) {
				var path = $(this).attr('src');
				jsRef.push(path);
			});
			config.bookData[config.htmlCounter]['jsRef'] = jsRef;
		} catch(e) {
		
		}
	}
	
	/**
	 * Get the css references of the current html page
	 */
	var getCssReferences = function(){
		try {
			var cssRef = new Array();
			//Get css references of the external stylesheets
			$.each($('#pageContainerIframe').contents().find('link'), function(e){
				var path = $(this).attr('href');
				if(path.split('/').pop().split('.')[1] == 'css'){
					cssRef.push(path);
				}
			});
			
			//Create and append custom css references for internal stylesheets
			$.each($('#pageContainerIframe').contents().find('style'), function(e){
				var data = new Array();
				data['id'] = 'customCssAzd' + config.customCss;
				data['href'] = 'customCssAzd' + config.customCss;
				data['mediaType'] = 'text/css';
				data['data'] = $(this).html();
				data['cssRef'] = '';
				config.bookData.push(data);
				
				cssRef.push('customCssAzd'+config.customCss);
				
				config.customCss = config.customCss + 1;
			});
			config.bookData[config.htmlCounter]['cssRef'] =  cssRef;
		} catch(e) {
			
		}
	};
	
	/**
	 * Get the css references for the current chapter
	 * @params idref Spine id of the current chapter
	 * @returns {array} css references of the current chapter
	 */
	var getChapterCssRef = function(idref){
		var cssRef;
		for(var i=0; i < config.bookData.length; i++){
			if(config.bookData[i]['id'] == idref){
				cssRef = config.bookData[i]['cssRef'];
				break;
			}
		}
		
		return cssRef;
	};
	
	/**
	 * Get the js references for the current chapter
	 * @params idref Spine id of the current chapter
	 * @returns {array} js references of the current chapter
	 */
	var getChapterJsRef = function(idref) {
		var jsRef;
		for(var i=0; i < config.bookData.length; i++){
			if(config.bookData[i]['id'] == idref){
				jsRef = config.bookData[i]['jsRef'];
				break;
			}
		}
		
		return jsRef;
	};
	
	/**
	 * Get the css data for the current referenced css
	 * @params cssRef Css reference of the current chapter
	 * @returns {cssData} Css Data
	 */
	var getCssData = function(cssRef){
		var cssData = '';
		for(var i = 0; i < config.bookData.length; i++){
            var href = config.bookData[i]['href'].split('/').pop();
            cssRef = cssRef.split('/').pop();
			if(href == cssRef){
				cssData = config.bookData[i]['data'];
				break;
			}
		}
		
		return cssData
	};
	
	var getJsData = function(jsRef){
		var jsData = '';
		for(var i = 0; i < config.bookData.length; i++){
			if(config.bookData[i]['href'].split('/').pop() == jsRef.split('/').pop()){
				jsData = config.bookData[i]['data'];
				break;
			}
		}
		
		return jsData
	}
	
	/**
	 * Extracts the path of .opf file from container.xml file
	 * @params containerXmlContent Contents of container.xml file
	 * @returns path of .opf file
	 */
	var getOpfFilePath = function(containerXmlContent){
		var parser = Components.classes["@mozilla.org/xmlextras/domparser;1"]
													.createInstance(Components.interfaces.nsIDOMParser);
		var domTree = parser.parseFromString(containerXmlContent, "text/xml");
		var rootfileNode = domTree.getElementsByTagName("rootfile").item(0);
		if(rootfileNode == null){
			//	Throw error if the XML file is poorly formatted or full-path attribute is missing.
			throw new Error('An error occured while trying to load the book.');
		}
 		
		var opfFilePathRelative = rootfileNode.attributes.getNamedItem('full-path').nodeValue;
		
		if(opfFilePathRelative == ''){
			//	Throw error if the full-path attribute is empty.
			throw new Error('An error occured while trying to load the book.');
		}
		opfFilePathRelative = opfFilePathRelative.split('/');
		opfFilePathRelative.unshift(config.extractedFolder);
		var opfFilePath = getAppendFilePath(config.extractLocation, opfFilePathRelative);
		
		return opfFilePath;
	};
	
	/**
	 * Load rendition properties in the spine item
	 * @idRef spine item reference id
	 * @spineNode DOM Node representing the spine item
	 */
	var loadSpineItemProperties = function(idRef, spineNode) {
		//DC - FLO UPDATE - 201211
		//Default Spine object. Takes the global rendition properties as initial values
		var spine_prop = {
		    "id": idRef,
            "layout": "",
            "orientation": "",
            "spread": "",
            "page-spread": "",
            "width": "0",
            "height": "0",
            "href": "",
			"linear": true,
            "media-type": "application/xhtml+xml",
            "reflowmode": false,
            "layout_scrolling": false,
        };

		
		if (spineNode.attributes.getNamedItem('properties') != null) {
			var properties_s = spineNode.attributes.getNamedItem('properties').nodeValue;
			var properties_l = properties_s.split(' ');
			for (var i = 0; i < properties_l.length; i++) {
				var prop =  properties_l[i];
				if ((prop.indexOf("rendition:")!= -1) || (prop.indexOf("page-spread")!= -1)){
					prop = prop.replace("rendition:", "");
					prop_l = prop.split("-");
					if (prop_l.length < 2) continue;
					if ((prop_l[0] == "page") && (prop_l[1] == "spread")) {
						spine_prop["page-spread"] = prop_l[2]; 
					}
					
					if (prop_l[0] == "layout") {
						if (prop_l[1] !== "scrolling") {
							spine_prop["layout"] = prop_l[1]; 
							if (prop_l[1] == "pre") spine_prop["layout"] = spine_prop["layout"] + "-" + prop_l[2]; 
						} else {
							spine_prop["layout_scrolling"] = true;
						}
					}
				
					if (prop_l[0] == "orientation") {
						spine_prop["orientation"] = prop_l[1]; 
					}
					
					if (prop_l[0] == "spread") {
						spine_prop["spread"] = prop_l[1]; 
					}
					
				}
			}
		} 
		
		//If a spine item marked as reflowable has additional properties in spread and
		//page spread, we are going to force it to act like a spread page instead 
		//of loading the AZD default reflowable engine
		if ((spine_prop["layout"] == "reflowable") || (spine_prop["layout"] == "")) {
			if ((spine_prop["spread"] !== "") || (spine_prop["page-spread"] !== "")) {
				spine_prop["reflowmode"] = false;
			} else {
				spine_prop["reflowmode"] = true;
			}
		}
		
		//SEt the default values if they are not available
		if (spine_prop["layout"] == "") {
			spine_prop["layout"] = config.rendition_layout;
		}
		
		if (spine_prop["orientation"] == "") {
			spine_prop["orientation"] = config.rendition_orientation;
		}
		
		if (spine_prop["spread"] == "") {
			spine_prop["spread"] = config.rendition_spread;
		}
		
		if (spine_prop["page-spread"] == "") {
			spine_prop["page-spread"] = "auto";
		}
		if (Epub.is_fixed_scroll_mode) {
			spine_prop["layout_scrolling"] = true;
		}
		
		return spine_prop;
	};
	
	/**
	 * Load rendition properties in the spine item
	 * @idRef spine item reference id
	 * @spineInfo JSON Node representing the spine item
	 */
	var loadSpineItemPropertiesJSON = function(idRef, spineInfo) {
		//DC - FLO UPDATE - 201211
		//Default Spine object. Takes the global rendition properties as initial values
		var spine_prop = {
		    "id": idRef,
            "layout": "",
            "orientation": "",
            "spread": "",
            "page-spread": "",
            "width": "0",
            "height": "0",
            "href": "",
			"linear": true,
            "media-type": "application/xhtml+xml",
            "reflowmode": false,
			"layout_scrolling": false,
        };

		if (spineInfo.hasOwnProperty("rendition-layout") && spineInfo["rendition-layout"] != "") {
			spine_prop["layout"] = spineInfo["rendition-layout"];
		}
		
		if (spineInfo.hasOwnProperty("rendition-layout") && spineInfo["rendition-layout"] == "scrolling") {
			spine_prop["layout_scrolling"] = true;
			spine_prop["layout"] = "";
		}
		
		//If a spine item marked as reflowable has additional properties in spread and
		//page spread, we are going to force it to act like a spread page instead 
		//of loading the AZD default reflowable engine
		if ((spine_prop["layout"] == "reflowable") || (spine_prop["layout"] == "")) {
			if ((spine_prop["spread"] !== "") || (spine_prop["page-spread"] !== "")) {
				spine_prop["reflowmode"] = false;
			} else {
				spine_prop["reflowmode"] = true;
			}
		}
		
		
		if (spineInfo.hasOwnProperty("rendition-orientation") && spineInfo["rendition-orientation"] != "") {
			spine_prop["orientation"] = spineInfo["rendition-orientation"];
		}
		
		if (spineInfo.hasOwnProperty("page-spread") && spineInfo["page-spread"] != "") {
			spine_prop["page-spread"] = spineInfo["page-spread"];
		}
		
		if (spineInfo.hasOwnProperty("rendition-spread") && spineInfo["rendition-spread"] != "") {
			spine_prop["spread"] = spineInfo["rendition-spread"];
		}
		
		if (spineInfo.hasOwnProperty("viewport-height") && spineInfo["viewport-height"] != "") {
			spine_prop["height"] = spineInfo["viewport-height"];
		}
		
		if (spineInfo.hasOwnProperty("viewport-width") && spineInfo["viewport-width"] != "") {
			spine_prop["width"] = spineInfo["viewport-width"];
		}
		
		//SEt the default values if they are not available
		if (spine_prop["layout"] == "") {
			spine_prop["layout"] = config.rendition_layout;
		}
		
		if (spine_prop["orientation"] == "") {
			spine_prop["orientation"] = config.rendition_orientation;
		}
		
		if (spine_prop["spread"] == "") {
			spine_prop["spread"] = config.rendition_spread;
		}
		
		if (spine_prop["page-spread"] == "") {
			spine_prop["page-spread"] = "auto";
		}
		
		
		if (Epub.is_fixed_scroll_mode) {
			spine_prop["layout_scrolling"] = true;
		}
		
		return spine_prop;
	};
	
	/**
	 * Get the spine content from the .opf file
	 * @params opfFileContent Content of the .opf file
	 */
	var getSpine = function(opfFileContent){
		var parser = Components.classes["@mozilla.org/xmlextras/domparser;1"]
								.createInstance(Components.interfaces.nsIDOMParser);
		var domTree = parser.parseFromString(opfFileContent, "text/xml");
		var spineNode = domTree.getElementsByTagName("spine").item(0);
		if(spineNode == null){
			//	Throw error if the opf file is poorly formatted or spine node is not present.
			throw new Error('An error occured while trying to load the book.');
		}
		
		//DC - FLO UPDATE - 201211 - get the page progression direction
		if (spineNode.attributes.getNamedItem('page-progression-direction') != null) {
			var ppd = spineNode.attributes.getNamedItem('page-progression-direction').nodeValue;
			if (typeof ppd != 'undefined' && ppd != '' ) {
				config.page_progression_dir = ppd;
			}
		}
		
		for(i = 0; i < spineNode.childNodes.length; i++){
			var childNode = spineNode.childNodes.item(i);
	        var nodeType = childNode.nodeType;
			if(nodeType == 1){
				//If spine element contains "linear="
				if (childNode.attributes.getNamedItem('linear') != null) {
					var linear = childNode.attributes.getNamedItem('linear').nodeValue;
					//Then only add the elements with "linear=yes"
					var idRef = childNode.attributes.getNamedItem('idref').nodeValue;
					if(linear == 'yes'){
						config.spineList.push(idRef);
						
						props = loadSpineItemProperties(idRef, childNode); //DC - FLO UPDATE - 201211
						config.spineProperties[idRef] = props;
					} else {
						props = loadSpineItemProperties(idRef, childNode); //DC - FLO UPDATE - 201211
						props["linear"] = false;
						config.spineProperties[idRef] = props;
					}
				} else {
					var idRef = childNode.attributes.getNamedItem('idref').nodeValue;
					config.spineList.push(idRef);
					
					props = loadSpineItemProperties(idRef, childNode); //DC - FLO UPDATE - 201211
					config.spineProperties[idRef] = props;
				}
			}
		}
	};
	
	/**
	 * Get the spine content from the .opf file
	 * @params opfFileContent Content of the .opf file
	 */
	var getSectionInfo = function(id, manifest) {
		for(i = 0; i < manifest.length; i++){
			if (manifest[i]["id"] == id) {
				return manifest[i];
			}
		}
		return {};
	}
	 
	var getSpineJSON = function(opfData){
		if (opfData.hasOwnProperty('page-progression-direction')) {
			var ppd = opfData['page-progression-direction'];
			if (typeof ppd != 'undefined' && ppd != '' ) {
				config.page_progression_dir = ppd;
			}
		}
		
		for(k = 0; k < opfData.spine.length; k++){
			try {
			
			var idRef = opfData.spine[k];
			config.spineList.push(idRef);
			
			var secinfo = getSectionInfo(idRef, opfData.manifest);
			props = loadSpineItemPropertiesJSON(idRef, secinfo); //DC - FLO UPDATE - 201301
			config.spineProperties[idRef] = props;
			}catch(e){
			alert(e);
			}
		}
		try {
			//Push the linear no items into the data structure
			for (var j = 0; j < opfData.manifest.length; j++) {
				if(opfData.manifest[j]['mediaType'] == 'text/html' || opfData.manifest[j]['mediaType'] == 'application/xhtml+xml'){
					var idRef = opfData.manifest[j]['id'];
					if (!config.spineProperties.hasOwnProperty(idRef)) {
						var secinfo = getSectionInfo(idRef, opfData.manifest);
						props = loadSpineItemPropertiesJSON(idRef, secinfo); //DC - FLO UPDATE - 201301
						config.spineProperties[idRef] = props;
					}
				}
			}
		} catch(e){
			
		}
	};
	
	
	var loadMetaProperties = function(opfFileContent) {
		try {
			var parser = Components.classes["@mozilla.org/xmlextras/domparser;1"]
														.createInstance(Components.interfaces.nsIDOMParser);
			var domTree = parser.parseFromString(opfFileContent, "text/xml");
			var metadataNode = domTree.getElementsByTagName("metadata").item(0);
			if(metadataNode == null){
				return;
			}
			
			var metainfo = {};
			for(i = 0; i < metadataNode.childNodes.length; i++){
				var childNode = metadataNode.childNodes.item(i);
				var nodeType = childNode.nodeType;
				if(nodeType == 1){
					if(childNode.childNodes.length > 0){
						var key = metadataNode.childNodes.item(i).nodeName;
						var value = metadataNode.childNodes.item(i).firstChild.nodeValue;
						if (key == "meta") {
							var param = metadataNode.childNodes.item(i).getAttribute("property");
							if (param) key = param;
							else continue; //skip this attribute
						}
						metainfo[key] = value;
					}
				}
			}
			config.metainfo = metainfo;
		}catch(e) {
		
		}
		
	}
	
	
	/**
	 * Get the language of the epub from .opf file
	 * @params opfFileContent Content of the .opf file
	 * @return {string} Language code of the epub
	 */
	var getLang = function(opfFileContent) {
		var lang = 'en';
		
		var parser = Components.classes["@mozilla.org/xmlextras/domparser;1"]
													.createInstance(Components.interfaces.nsIDOMParser);
		var domTree = parser.parseFromString(opfFileContent, "text/xml");
		var metadataNode = domTree.getElementsByTagName("metadata").item(0);
		if(metadataNode == null){
			return lang;
		}
		
		for(i = 0; i < metadataNode.childNodes.length; i++){
	        var childNode = metadataNode.childNodes.item(i);
	        var nodeType = childNode.nodeType;
			if(nodeType == 1){
	            if(childNode.childNodes.length > 0){
	                var key = metadataNode.childNodes.item(i).nodeName;
	                if(key === 'dc:language') {
	                	lang = metadataNode.childNodes.item(i).firstChild.nodeValue;
	                	break;
	                }
	            }
	        }
	    }
	    return lang;
	};
	
	/**
	 * Sets the language of the container div as the language of the epub.
	 */
	var setLang = function(lang) {
		$('#doc-viewer-azd').contents().find('#custom-style-igp').attr('lang', lang);
	};
	
	/**
	 * 	This function removes unavailable items from the spine
	 */
	var processSpine = function () {
		var self = this;
		
		for (var i = 0; i < config.spineList.length; i ++) {
			var found = false;
			for (var j = 0; j < config.bookData.length; j ++) {
				if (config.spineList[i] == config.bookData[j]['id']) {
					if(config.bookData[j]['available'] != 'false') {
						found = true;
					}
					break;
				}
			}
			if(!found) {
				config.containErrors = true;
				config.unavailableItem.push(config.spineList[i]);
			}
		}
		for(var i = 0; i < config.unavailableItem.length; i ++) {
			for (var j = 0; j < config.spineList.length; j ++) {
				if(config.spineList[j] == config.unavailableItem[i]) {
					config.spineList.splice(j, 1);
					break;
				} 
			}
		}
		
		//DC - FLO UPDATE - 201211 - Update url, width, height to the spineitem properties
		for (var j = 0; j < config.bookData.length; j ++) {
			if (config.bookData[j]['available'] != 'false') {
				var idref = config.bookData[j]['id'];
				if (config.spineProperties.hasOwnProperty(idref)) {
					config.spineProperties[idref]["orighref"] = config.bookData[j]['href'];
					config.spineProperties[idref]["href"] = config.bookData[j]['htmlUrl'];
					config.spineProperties[idref]["width"] = config.bookData[j]['viewport-width'];
					config.spineProperties[idref]["height"] = config.bookData[j]['viewport-height'];
					config.spineProperties[idref]["media-type"] = config.bookData[j]['mediaType'];
					config.spineProperties[idref]["epubtype"] = config.bookData[j]['epubtype'];
				}
			}
		}
		
		//If all the items are removed
		if(config.spineList.length <= 0) {
			throw new Error('An error occured while trying to load the book.');
		}
		
		preprocessDisplaySettings();
	};
	
	/**
	 * Get the current chapter id from spine
	 * @returns {string} current chapter id from spine
	 */
	var getCurrentChapterFromSpine = function(){
		var idref = config.spineList[Chapter.config.currentChapter];
		return idref;
	};
	
	/**
	 * Get html data of current chapter
	 * @params idref Spine id of current chapter
	 * @returns html data of the current chapter
	 */
	var getChapterData = function(idref){
		var data = '';
		for(var i = 0; i < config.bookData.length; i++){
			if(config.bookData[i]['id'] == idref){
				data = config.bookData[i]['data'];
				break;
			}
		}
		return data;
	}
	
	/**
	 * Get the fixed layout details of the current chapter
	 * @returns {object} fixed layout details
	 */
	var getChapterPresentationDetails = function(idref) {
		var presentationDetails = new Array();
		for (var i=0; i < config.bookData.length; i++) {
			if(config.bookData[i]['id'] == idref){
				//DC - FLO UPDATE - 201211
				var additionalprop = {};
				if (config.spineProperties.hasOwnProperty(idref)) {
					additionalprop = config.spineProperties[idref];
				}
				presentationDetails['azardi-presentation'] = config.bookData[i]['azardi-presentation'];
				presentationDetails['azardi-width'] = config.bookData[i]['azardi-width'];
				presentationDetails['azardi-height'] = config.bookData[i]['azardi-height'];
				presentationDetails['azardi-margins'] = config.bookData[i]['azardi-margins'];
				presentationDetails['azardi-toc'] = config.bookData[i]['azardi-toc'];
				
				//DC - FLO UPDATE - 201211 - get the new properties
				if (additionalprop.hasOwnProperty("layout") && (additionalprop["layout"] == "pre-paginated") ){
					presentationDetails['azardi-presentation'] = "";
				} 
				
				if (additionalprop.hasOwnProperty("width") && (additionalprop["width"] != "") ){
					presentationDetails['azardi-width'] = additionalprop["width"];
				}
				
				if (additionalprop.hasOwnProperty("height") && (additionalprop["height"] != "") ){
					presentationDetails['azardi-height'] = additionalprop["height"];
				}
				
				break;
			}
		}
		return presentationDetails;
	};
	
	/**
	 * Get media type of current chapter
	 * @params idref Spine id of current chapter
	 * @returns media type of current chapter
	 */
	var getChapterMediaType = function(idref){
		var mediaType = '';
		for(var i = 0; i < config.bookData.length; i++){
			if(config.bookData[i]['id'] == idref){
				mediaType = config.bookData[i]['mediaType'];
				break;
			}
		}
		return mediaType;
	};
	
	
	/**
	 * Get media type of audio video files
	 * @params filename
	 * @returns media type of supplied file
	 */
	var getMediaType = function(fileref){
		var mediaType = '';
		var fn = fileref.split("/").pop();
		for(var i = 0; i < config.bookData.length; i++){
			if(config.bookData[i]['href'].split('/').pop() == fn) {
				mediaType = config.bookData[i]['mediaType'];
				break;
			}
		}
		return mediaType;
	};
	
	/**
	 * Get the media overlay property for the current chapter
	 * @params idref Spine id of the current chapter
	 * @returns {string} media overlay property of current chapter
	 */
	var getChapterOverlay = function(idref){
		var mediaOverlay = '';
		for(var i = 0; i < config.bookData.length; i++){
			if(config.bookData[i]['id'] == idref){
				mediaOverlay = config.bookData[i]['mediaOverlay'];
				break;
			}
		}
		return mediaOverlay;
	}
	
	/**
	 * Get the smil file data for current chapter
	 * @params idref id of the smil file
	 * @returns {string} smil data for the current chapter
	 */
	var getChapterSmilData = function(idref) {
		var smilData;
		for(var i = 0; i < config.bookData.length; i++){
			if(config.bookData[i]['id'] == idref){
				smilData = config.bookData[i]['data'];
				break;
			}
		}
		return smilData;
	};
	
	/**
	 * Get chapter properties using spine id
	 * @params idref spine id of current chapter
	 * @returns {string} properties of the current chapter
	 */
	var getChapterProperties = function(idref) {
		var properties = '';
		for(var i = 0; i < config.bookData.length; i++) {
			if(config.bookData[i]['id'] == idref) {
				properties = config.bookData[i]['properties'];
				break;
			}
		}
		return properties;
	};
	
	/**
	 * Get href of current chapter using spine id
	 * @params idref Spine id of current chapter
	 * @returns {string} href of current chapter
	 */
	var getChpaterHref = function(idref) {
		var href = '';
		for(var i = 0; i < config.bookData.length; i++){
			if(config.bookData[i]['id'] == idref){
				href = config.bookData[i]['href'];
				break;
			}
		}
		return href;
	}
	
	/**
	 * Get href of current chapter using spine id
	 * @params idref Spine id of current chapter
	 * @returns {string} href of current chapter
	 */
	var getChapterHrefUrl = function(idref) {
		var href = '';
		for(var i = 0; i < config.bookData.length; i++){
			if(config.bookData[i]['id'] == idref){
				href = config.bookData[i]['htmlUrl'];
				break;
			}
		}
		return href;
	}
	
	/**
	 * Get manifest information from .opf file for epub 3
	 * @params opfFileContent Content of the .opf file
	 */
	var getManifestEpub3 = function (opfFileContent) {
		var self = this;
		
		var parser = Components.classes["@mozilla.org/xmlextras/domparser;1"]
													.createInstance(Components.interfaces.nsIDOMParser);
		var domTree = parser.parseFromString(opfFileContent, "text/xml");
		var manifestNode = domTree.getElementsByTagName("manifest").item(0);
		if(manifestNode == null){
			//	Throw error if the opf file is poorly formatted or manifest node is not present.
			throw new Error('An error occured while trying to load the book.');
		}
		var tocNode = false;
		var tocNodeFound = false;
		
		for(i = 0; i < manifestNode.childNodes.length; i++){
	        var childNode = manifestNode.childNodes.item(i);
	        var nodeType = childNode.nodeType;
	        var propertiesAttr;
			if(nodeType == 1){
				var data = new Array();
				
				propertiesAttr = childNode.attributes.getNamedItem('properties');
				if(propertiesAttr != null) {
					data['properties'] = propertiesAttr.nodeValue;
				} else {
					data['properties'] = '';
				}
				
				if(!tocNodeFound){
					//	If toc node is not found yet
					//	Check if its a toc node
					if(data['properties'].search(/nav/i) != -1) {
						//	If toc node found.
						tocNode = true;
						tocNodeFound = true;
					}
				}
				
				data['id'] = childNode.attributes.getNamedItem('id').nodeValue;
				
				try{
					data['href'] = decodeURIComponent(childNode.attributes.getNamedItem('href').nodeValue);
				}
				catch(e){
					//	If href attribute is not found then put blank as href.
					data['href'] = '';
				}
				try{
					data['mediaType'] = childNode.attributes.getNamedItem('media-type').nodeValue;
				}
				catch(e){
					//	If media-type attribute is not found then put blank as media-type.
					data['mediaType'] = '';
				}
				try{
					data['mediaOverlay'] = childNode.attributes.getNamedItem('media-overlay').nodeValue;
				}
				catch(e){
					//	If media-type attribute is not found then put blank as media-type.
					data['mediaOverlay'] = '';
				}
				data['data'] = '';
				data['cssRef'] = '';
				data['jsRef'] = '';
				data['available'] = 'false';
				data['azardi-presentation'] = '';
				data['azardi-width'] = '';
				data['azardi-height'] = '';
				data['azardi-margins'] = '';
				data['azardi-toc'] = '';
				if(tocNode){
					config.epub3TocHref = data['href'];
					tocNode = false;
				}
				
				config.bookData.push(data);
	        }
	    }
	}
	
	/**
	 * Get manifest information from .opf file for epub 2
	 * @params opfFileContent Content of the .opf file
	 */
	var getManifestEpub2 = function(opfFileContent){
		var parser = Components.classes["@mozilla.org/xmlextras/domparser;1"]
													.createInstance(Components.interfaces.nsIDOMParser);
		var domTree = parser.parseFromString(opfFileContent, "text/xml");
		var manifestNode = domTree.getElementsByTagName("manifest").item(0);
		if(manifestNode == null){
			//	Throw error if the opf file is poorly formatted or manifest node is not present.
			throw new Error('An error occured while trying to load the book.');
		}
		
		for(i = 0; i < manifestNode.childNodes.length; i++){
	        var childNode = manifestNode.childNodes.item(i);
	        var nodeType = childNode.nodeType;
			if(nodeType == 1){
				var data = new Array();
				data['id'] = childNode.attributes.getNamedItem('id').nodeValue;
				try{
					data['href'] = decodeURIComponent(childNode.attributes.getNamedItem('href').nodeValue);
				}
				catch(e){
					//	If href attribute is not found then put blank as href.
					data['href'] = '';
				}
				try{
					data['mediaType'] = childNode.attributes.getNamedItem('media-type').nodeValue;
				}
				catch(e){
					//	If media-type attribute is not found then put blank as media-type.
					data['mediaType'] = '';
				}
				data['data'] = '';
				data['cssRef'] = '';
				data['jsRef'] = '';
				data['available'] = 'false';
				data['azardi-presentation'] = '';
				data['azardi-width'] = '';
				data['azardi-height'] = '';
				data['azardi-margins'] = '';
				data['azardi-toc'] = '';
				data['properties'] = '';
				data['mediaOverlay'] = '';
				config.bookData.push(data);
			}
		}
	};
	
	/**
	 * Extract metadata from the content of opf file
	 * @params opfFileContent Content of the opf file
	 * @returns {array} metadata of the epub file
	 */
	var getMetadata = function(opfFileContent){
		var parser = Components.classes["@mozilla.org/xmlextras/domparser;1"]
													.createInstance(Components.interfaces.nsIDOMParser);
		var domTree = parser.parseFromString(opfFileContent, "text/xml");
		var isfloprefixpresent = false;
		try {
			var packagenode = domTree.getElementsByTagName("package").item(0);
			var prefix  = packagenode.getAttribute("prefix");
			if (prefix) {
				var hasFLOPrefix = prefix.indexOf('rendition: http://www.idpf.org/vocab/rendition/');
				if (hasFLOPrefix!= -1) {
					isfloprefixpresent = true;
				}
			}
		} catch(e) {
			//alert(e);
		}
		var metadataNode = domTree.getElementsByTagName("metadata").item(0);
		if(metadataNode == null){
			//	Throw error if the opf file is poorly formatted.
			throw new Error('An error occured while trying to load the book.');
		}
		var metadata = new Array();	
		
		for(i = 0; i < metadataNode.childNodes.length; i++){
	        var childNode = metadataNode.childNodes.item(i);
	        var nodeType = childNode.nodeType;
			if(nodeType == 1){
	            if(childNode.childNodes.length > 0){
	                var key = metadataNode.childNodes.item(i).nodeName;
	                var value = metadataNode.childNodes.item(i).firstChild.nodeValue;
					//DC - FLO UPDATE - 201211
					if (key == "meta") {
						
						var param = metadataNode.childNodes.item(i).getAttribute("property");
						if (param) key = param;
						else continue; //skip this attribute
					}
	                var mdInfo = new Array();
	                mdInfo.push(key);
	                mdInfo.push(value);
					metadata.push(mdInfo);
					
	            }
	        }
	    }
		
		//Sometimes epub authors just put rendition: http://www.idpf.org/vocab/rendition/
		//in the prefix attr of the package element and dont specify the meta tags for FLO
		//In this case, we push the default values into the metadata array
		
		if (isfloprefixpresent) {
			var flo_meta_present = false;
			for (var i=0; i<metadata.length; i++) {
				var md_item = metadata[i];
				if ((md_item[0] == "rendition:layout") || (md_item[0] == "rendition:spread") || (md_item[0] == "rendition:orientation")) {
					flo_meta_present = true;
					break;
				}
			}
			
			if(!flo_meta_present) {
				metadata.push(["rendition:layout", "reflowable"]);
				metadata.push(["rendition:orientation", "auto"]);
				metadata.push(["rendition:spread", "auto"]);
			}
		}
		
	    return metadata;
	};
	
	/**
	 * Returns Id of the cover from metadata
	 * @params opfFileContent Content of the .opf file
	 * @returns {string} Id of the cover
	 */
	var getCoverIdFromMetadata = function(opfFileContent){
		
		var coverId = '';
		var parser = Components.classes["@mozilla.org/xmlextras/domparser;1"]
													.createInstance(Components.interfaces.nsIDOMParser);
		var domTree = parser.parseFromString(opfFileContent, "text/xml");
		
		var metadataNode = domTree.getElementsByTagName("metadata").item(0);
	    for(i = 0; i < metadataNode.childNodes.length; i++){
	        var childNode = metadataNode.childNodes.item(i);
        	if(childNode.nodeName == 'meta'){
        		if(childNode.attributes.getNamedItem('name') == null){
        			continue;
        		}
        	}
	        	
	        if(childNode.nodeName == 'meta' && childNode.attributes.getNamedItem('name').nodeValue == 'cover'){
	        	coverId = childNode.attributes.getNamedItem('content').nodeValue;
	        	break;
	        }
	    }
	   
	    return coverId;
	};
	
	/**
	 * Get the path of cover image from metadata.
	 * @params opfFileContent Content of .opf file
	 * @returns {string} Relative path to cover iamge
	 */
	var getCoverImageFromMetadata = function(opfFileContent){
		var self = this;
		
		var coverId = '';
		var coverImage = '';
		coverId = self.getCoverIdFromMetadata(opfFileContent);
		
		if(coverId == '' || typeof coverId == 'undefined'){
			return '';
		}
		
		var parser = Components.classes["@mozilla.org/xmlextras/domparser;1"]
													.createInstance(Components.interfaces.nsIDOMParser);
		var domTree = parser.parseFromString(opfFileContent, "text/xml");
		var manifestNode = domTree.getElementsByTagName('manifest').item(0);
		for(i = 0; i< manifestNode.childNodes.length; i++){
			var childNode = manifestNode.childNodes.item(i);
			if(childNode.nodeType == '1' && childNode.attributes.getNamedItem('id').nodeValue == coverId){
				//DC - FLO UPDATE - 201211 - This function was also returning values for cover html files
				var covertype = childNode.attributes.getNamedItem('media-type').nodeValue;
				if(covertype == 'text/html' || covertype == 'application/xhtml+xml') {
					return '';
				}
				coverImage = childNode.attributes.getNamedItem('href').nodeValue;
				break;
			}
		}
		
		return coverImage;
	};
	
	var getCoverImageFromGuide = function(opfFileContent){
		var coverImage = '';
		var parser = Components.classes["@mozilla.org/xmlextras/domparser;1"]
													.createInstance(Components.interfaces.nsIDOMParser);
		var domTree = parser.parseFromString(opfFileContent, "text/xml");
		
		// guide node is optional in epubs.
		
		var guideNode = domTree.getElementsByTagName('guide').item(0);
		if (guideNode == null) {
			return '';
		}
		for(i = 0; i < guideNode.childNodes.length; i++){
			var childNode = guideNode.childNodes.item(i);
			if(childNode.nodeType == '1' && childNode.attributes.getNamedItem('type').nodeValue == 'cover'){
				coverImage = childNode.attributes.getNamedItem('href').nodeValue;
				break;
			}
		}
		
		return coverImage;
	}
	
	var getFirstPageFromManifest = function(opfFileContent){
		var self = this;
		
		var coverImage = '';
		var firstPageId = self.getFirstPageIdFromSpine(opfFileContent);
		
		var parser = Components.classes["@mozilla.org/xmlextras/domparser;1"]
													.createInstance(Components.interfaces.nsIDOMParser);
		var domTree = parser.parseFromString(opfFileContent, "text/xml");
		
		var manifestNode = domTree.getElementsByTagName('manifest').item(0);
		for(i = 0; i < manifestNode.childNodes.length; i++){
			var childNode = manifestNode.childNodes.item(i);
			if(childNode.nodeType == '1' && childNode.attributes.getNamedItem('id').nodeValue == firstPageId){
				coverImage = childNode.attributes.getNamedItem('href').nodeValue;
				break;
			}
		}
		
		return coverImage;
	}
	
	var getFirstPageIdFromSpine = function(opfFileContent){
		var firstPageId = '';
		var parser = Components.classes["@mozilla.org/xmlextras/domparser;1"]
													.createInstance(Components.interfaces.nsIDOMParser);
		var domTree = parser.parseFromString(opfFileContent, "text/xml");
		
		var spineNode = domTree.getElementsByTagName('spine').item(0);
		firstPageId = spineNode.childNodes.item(1).attributes.getNamedItem('idref').nodeValue;
		
		return firstPageId; 
	}
	
	/**
	 * Get the path of cover image from manifest for epub3
	 * @params opfFileContent Content of the .opf file
	 * @returns {string} Relative path of the cover image
	 */
	var getCoverImageFromManifestEpub3 = function(opfFileContent) {
		var self = this;
		
		var coverImage = '';
		var parser = Components.classes["@mozilla.org/xmlextras/domparser;1"]
													.createInstance(Components.interfaces.nsIDOMParser);
		var domTree = parser.parseFromString(opfFileContent, "text/xml");
		
		var manifestNode = domTree.getElementsByTagName('manifest').item(0);
		
		for(i = 0; i < manifestNode.childNodes.length; i++){
			var childNode = manifestNode.childNodes.item(i);
			if(childNode.nodeType == '1'){
				var properties = childNode.attributes.getNamedItem('properties');
				if(properties && properties.nodeValue == 'cover-image') {
					coverImage = childNode.attributes.getNamedItem('href').nodeValue;
					break;
				}
			}
		}
		
		return coverImage;
	};
	
	//FIXME: for now process guide first, when we are able to get the cover from images
	// without setting them directly to iframe then process metadata first then guide then first page
	
	/**
	 * Returns the cover image path
	 * @params opfFileContent Content of the .opf file
	 * @params opfFilePath Path of the .opf file
	 * @params version Version info of the epub
	 * @returns {object} conver image path, cover type
	 */
	var getCoverImage = function(opfFileContent, opfFilePath, version){
		var self = this;
		
		var coverImage = '';
		var coverImagePath = '';
		var coverObject;
		var cover_type = 'image';
		// coverImage = self.getCoverImageFromGuide(opfFileContent);
		// if(coverImage == ''){
		version = version.split('.')[0];
		if(version == '2') {
			coverImage = self.getCoverImageFromMetadata(opfFileContent);
			coverImagePath = self.getEntityAbsolutePath(opfFilePath, coverImage);
			coverObject = getFileObjectFromPath(coverImagePath);
			if(!coverObject.exists()) {
				coverImage = '';
				coverImagePath = '';
			}
		} else if(version == '3') {
			coverImage = self.getCoverImageFromManifestEpub3(opfFileContent);
			coverImagePath = self.getEntityAbsolutePath(opfFilePath, coverImage);
			coverObject = getFileObjectFromPath(coverImagePath);
			if(!coverObject.exists()) {
				coverImage = '';
				coverImagePath = '';
			}
		}
		
		//If the cover image is not found then use default cover as image, cover type as avatar.
		if(coverImage == '') {
			coverImage = 'cover-avatar.png';
			coverObject = getFileObject(['CurProcD', 'chrome', 'content', 'icons', coverImage]);
			coverImagePath = coverObject.path;
			cover_type = 'avatar';
		}
		
		return {
			coverImagePath: coverImagePath,
			cover_type: cover_type
		};
	};
	
	/**
	 * Extracts the information from epub file
	 * @params epubFile File object of the epub selected
	 * @returns {object} metadata and cover image path
	 */
	var getInfo = function(epubFile){
		var self = this;
		
		try{
			unzipFile(epubFile.path, false);
		}
		catch(e){
			//	Throw error if archive file is corrupted.
			throw new Error('An error occured while trying to load the book.');
		}
		self.getExtractLocation();
		self.getExtractedFolderName(epubFile.leafName);
		
		var containerXmlPath = getAppendFilePath(config.extractLocation, [config.extractedFolder, 'META-INF', 'container.xml']);
		try{
			var containerXmlContent = readFileUTF(containerXmlPath);
		}
		catch(e){
			//	Throw error if META-INF folder or container.xml file is missing from the archive. 
			throw new Error('An error occured while trying to load the book1.');
		}
		
		if(containerXmlContent == '') {
			//	Throw error if conatainer.xml file is empty.
			throw new Error('An error occured while trying to load the book.');
		}
		var opfFilePath = self.getOpfFilePath(containerXmlContent);
		
		try{
			var opfFileContent = readFileUTF(opfFilePath);
		}
		catch(e){
			// Throw error if .opf file is missing from the archive or not present at the described loacation.
			throw new Error('An error occured while trying to load the book.');
		}
		
		if(opfFileContent == '') {
			// Throw error if .opf file is empty.
			throw new Error('An error occured while trying to load the book.');
		}
		var version = self.getEpubVersion(opfFileContent);
		var metadata = self.getMetadata(opfFileContent);
		var coverImageInfo = self.getCoverImage(opfFileContent, opfFilePath, version);
		var coverImagePath = coverImageInfo.coverImagePath;
		var cover_type = coverImageInfo.cover_type;
		// coverImagePath = self.getEntityAbsolutePath(opfFilePath, coverImagePath);
		metadata.push(['dc:location', epubFile.path]);
		metadata.push(['dc:version', version]);
		metadata.push(['dc:cover_type', cover_type]);
		
		// deleteFolder(getAppendFilePath(config.extractLocation, [config.extractedFolder]));
		
		return {
			metadata: metadata,
			coverImagePath: coverImagePath
		};
	};
	
	/**
	 * Extracts the epub version from content of the opf file
	 * @params opfFileContent Content of the opf file
	 * @returns {string} epub version
	 */
	var getEpubVersion = function (opfFileContent) {
		var self = this;
		
		var parser = Components.classes["@mozilla.org/xmlextras/domparser;1"]
							   .createInstance(Components.interfaces.nsIDOMParser);
		var domTree = parser.parseFromString(opfFileContent, "text/xml");
		var packageNode = domTree.getElementsByTagName("package").item(0);
		if(packageNode == null){
			return '2.0';
		}
		
		var version = packageNode.attributes.getNamedItem('version').nodeValue;
		//Treat epub as 2.0 if version info is not found
		if(version == ''){
			return '2.0';
		}
		else{
			return version;
		}
	};
	
	/**
	 * Converts the relative path into absolute path
	 * @params opfFilePath Path to .opf file
	 * @params entityPath Entities relative Path
	 * @returns {string} Entities absolute path
	 */
	var getEntityAbsolutePath = function(opfFilePath, entityPath){
		var newEntityReferenceArr = new Array();
	    var opfFileObj = getFileObjectFromPath(opfFilePath);
	    var opsFolderObj = opfFileObj.parent;    
	    var entityReferenceArr = entityPath.split('/');
	    for (var i = 0; i < entityReferenceArr.length; i++) 
	    {
	        if (entityReferenceArr[i] == '..') 
	        {
	            opsFolderObj = opsFolderObj.parent;
	        }
	        else 
	        {
	            newEntityReferenceArr.push(entityReferenceArr[i]);
	        }
	    }   
	    var newEntityPath = getAppendFilePath(opsFolderObj.path, newEntityReferenceArr);

	    return newEntityPath;
	};
	
	/**
	 * Checks href in manifest and returns corresponding id.
	 * @params fileLocation Href of file
	 * @returns {string} id of file
	 */
	var getSpineIdFromFileLocation = function(fileLocation){
		for(var i = 0; i < config.bookData.length; i++){
			try {										
				var href = config.bookData[i]['href'].split("/").pop();
				var floc = fileLocation.split("/").pop();
				if(href == floc){
					return Epub.config.bookData[i]['id'];
				}
			} catch(e) {
				
			}
		}
	};
	
	/**
	 * Returns position of the chapter in spine
	 * @params spineId Spine id of chapter
	 * @returns {integer} position of the chapter in spine
	 */
	var getChapterIdFromSpineId = function(spineId){
		for(var i = 0; i < config.spineList.length; i++){
			try {	
				if(config.spineList[i] == spineId){
					return i;
				}
			}catch(e){
				
			}
		}
		return false;
	};
	
	/**
	 * Get the html file data for current chapter
	 * @params fileLocation Location of the current chapter
	 * @returns {string} html data of the current chapter
	 */
	var getChapterDataFromFileLocation = function(fileLocation){
		var data = '';
		for(var i = 0; i < config.bookData.length; i++){
			var currhtml = config.bookData[i]['href'].split('/').pop();
			var target = fileLocation.split('/').pop();
			
			if(currhtml == target && config.bookData[i]['available'] == 'true'){
				data = config.bookData[i]['data'];
				break;
			}
		}
		return data;
	}
	
	/**
	 * Get the media type of the current chapter
	 * @params fileLocation Location of the current chapter
	 * @returns {string} media type of the current chapter
	 */
	var getChapterMediaTypeFromFileLocation = function(fileLocation){
		var mediaType = '';
		for(var i = 0; i < config.bookData.length; i++){
			var currhtml = config.bookData[i]['href'].split('/').pop();
			var target = fileLocation.split('/').pop();
			
			if(currhtml == target && config.bookData[i]['available'] == 'true'){
				mediaType = config.bookData[i]['mediaType'];
				break;
			}
		}
		return mediaType;
	};
	
	/**
	 * Get the css references for the current chapter
	 * @params fileLocation Location of the current chapter
	 * @returns {array} css references of the current chapter
	 */
	var getChapterCssRefFromFileLocation = function(fileLocation){
		var cssRef;
		for(var i=0; i < config.bookData.length; i++){
			var currcss = config.bookData[i]['href'].split('/').pop();
			var target = fileLocation.split('/').pop();
			if(currcss == target){
				cssRef = config.bookData[i]['cssRef'];
				break;
			}
		}
		return cssRef;
	};
	
	var getChapterJsRefFromFileLocation = function(fileLocation){
		var jsRef;
		for(var i=0; i < config.bookData.length; i++){
			var currjs = config.bookData[i]['href'].split('/').pop();
			var target = fileLocation.split('/').pop();
			if(currjs == target){
				jsRef = config.bookData[i]['jsRef'];
				break;
			}
		}
		return jsRef;
	}
	
	var getChapterUrlFromFileLocation = function(fileLocation){
		var url;
		for(var i=0; i < config.bookData.length; i++){
			var currjs = config.bookData[i]['href'].split('/').pop();
			var target = fileLocation.split('/').pop();
			if(currjs == target){
				url = config.bookData[i]['htmlUrl'];
				break;
			}
		}
		if (!url) {
			url = fileLocation;
		}
		return url;
	}
	
	/**
	 * Get the properties of the current chapter
	 * @params fileLocation File location of the current chapter
	 * @returns {string} properties of the current chapter
	 */
	var getChapterPropertiesFromFileLocation = function(fileLocation) {
		var properties = '';
		for(var i = 0; i < config.bookData.length; i++) {
			var filename = config.bookData[i]['href'].split('/').pop();
			var target = fileLocation.split('/').pop();
			if(filename == target) {
				properties = config.bookData[i]['properties'];
				break;
			}
		}
		return properties;
	};
	
	/**
	 * Gets the fixed layout presentation details of the current chapter
	 * @params fileLocation File location of the current chapter
	 * @returns {object} fixed layout presentation details
	 */
	var getChapterPresentationDetailsFromFileLocation = function(fileLocation) {
		var presentationDetails = new Array();
		for (var i=0; i < config.bookData.length; i++) {
			var filename = config.bookData[i]['href'].split('/').pop();
			var target = fileLocation.split('/').pop();
			if(filename == target){
				
				presentationDetails['azardi-presentation'] = config.bookData[i]['azardi-presentation'];
				presentationDetails['azardi-width'] = config.bookData[i]['azardi-width'];
				presentationDetails['azardi-height'] = config.bookData[i]['azardi-height'];
				presentationDetails['azardi-margins'] = config.bookData[i]['azardi-margins'];
				presentationDetails['azardi-toc'] = config.bookData[i]['azardi-toc'];

				break;
			}
		}
		return presentationDetails;
	};
	
	/**
	 * Display the warning popup
	 */
	var displayWarning = function () {
		var self = this;
		
		$('#doc-viewer-azd').contents().find('.warning_message_box').html(AzdMessages.minorBookError);
		$('#doc-viewer-azd').contents().find('.warning_message_box').show(500).delay(5000).hide(500);
		// $('#doc-viewer-azd').contents().find('.warning_message_box').animate({
			// 'width': '100%'
		// }, { duration: 5000, queue: false }, 'swing');
	};
	
	/**
	 * Converts the smil data from array to string which AIE can understand
	 * @params smilData An array of .smil data
	 * @returns {string} Smil data in a format which AIE can understand
	 */
	var processSmilData = function(smilData) {
		var self = this;
		for(var i = 1; i < smilData.length; i++) {
			if (!smilData[i]) {
				continue;
			}
			try {
				var pid = smilData[i][0];
				//smilData[i][0] = '#'+pid.split('#').pop();
				for(var j = 1; j < smilData[i].length; j++) {
					var time = smilData[i][j].split(':');
					var seconds;
					if(time.length == 3) {
						//	The time has hours:minutes:seconds.milliseconds format
						seconds = parseInt(time[0]*60*60)+parseInt(time[1]*60)+parseFloat(time[2]);
					} else if(time.length == 2) {
						//	The time has minutes:seconds.milliseconds format
						seconds = parseInt(time[0]*60)+parseFloat(time[1]);
					} else if(time.length == 1) {
						//	The time has seconds.milliseconds format
						seconds = time[0];
					}
					smilData[i][j] = seconds;
				}
			} catch(e) {
				continue;
			}
		}
		
		return smilData;
	};
	
	return{
		config: config,
		load: load,
		unload: unload,
		getInfo: getInfo,
		getTocDataEpub2: getTocDataEpub2,
		getTocDataEpub3: getTocDataEpub3,
		// getLandmarkDataEpub3: getLandmarkDataEpub3,
		extractTocContent: extractTocContent,
		setInPageTocDataEpub2: setInPageTocDataEpub2,
		setFullPageTocDataEpub2: setFullPageTocDataEpub2,
		setInPageTocDataEpub3: setInPageTocDataEpub3,
		setFullPageTocDataEpub3: setFullPageTocDataEpub3,
		setLandmarkDataEpub3: setLandmarkDataEpub3,
		getFontAndImageData: getFontAndImageData,
		getHtmlData: getHtmlData,
		loadHtmlPage: loadHtmlPage,
		getScriptData: getScriptData,
		getStyleData: getStyleData,
		getCSSDataFromFile: getCSSDataFromFile,
		extractCSSName: extractCSSName,
		getCssRules: getCssRules,
		getUri: getUri,
		getCustomPresentationData: getCustomPresentationData,
		getCssReferences: getCssReferences,
		getJsReferences: getJsReferences,
		getChapterCssRef: getChapterCssRef,
		getChapterJsRef: getChapterJsRef,
		getCssData: getCssData,
		getExtractLocation: getExtractLocation,
		getExtractedFolderName: getExtractedFolderName,
		getOpfFilePath: getOpfFilePath,
		getMetadata: getMetadata,
		getSpine: getSpine,
		getLang: getLang,
		setLang: setLang,
		processSpine: processSpine,
		getManifestEpub2: getManifestEpub2,
		getManifestEpub3: getManifestEpub3,
		getCoverIdFromMetadata: getCoverIdFromMetadata,
		getCoverImage: getCoverImage,
		getCoverImageFromMetadata: getCoverImageFromMetadata,
		getCoverImageFromGuide: getCoverImageFromGuide,
		getFirstPageFromManifest: getFirstPageFromManifest,
		getFirstPageIdFromSpine: getFirstPageIdFromSpine,
		getEntityAbsolutePath: getEntityAbsolutePath,
		getCurrentChapterFromSpine: getCurrentChapterFromSpine,
		getChapterData: getChapterData,
		loadXMLDoc: loadXMLDoc,
		getSpineIdFromFileLocation: getSpineIdFromFileLocation,
		getChapterIdFromSpineId: getChapterIdFromSpineId,
		getEpubVersion: getEpubVersion,
		processInPageToc: processInPageToc,
		processFullPageToc: processFullPageToc,
		processLandmark: processLandmark,
		displayWarning: displayWarning,
		copyAudioAndVideo: copyAudioAndVideo,
		getChapterDataFromFileLocation: getChapterDataFromFileLocation,
		getChapterCssRefFromFileLocation: getChapterCssRefFromFileLocation,
		getJsData: getJsData,
		getChapterJsRefFromFileLocation: getChapterJsRefFromFileLocation,
		getCoverImageFromManifestEpub3: getCoverImageFromManifestEpub3,
		getChapterMediaType: getChapterMediaType,
		getChapterMediaTypeFromFileLocation: getChapterMediaTypeFromFileLocation,
		getChpaterHref: getChpaterHref,
		getChapterPresentationDetails: getChapterPresentationDetails,
		getChapterPresentationDetailsFromFileLocation: getChapterPresentationDetailsFromFileLocation,
		getChapterProperties: getChapterProperties,
		getChapterSmilData: getChapterSmilData,
		getChapterOverlay: getChapterOverlay,
		getChapterPropertiesFromFileLocation: getChapterPropertiesFromFileLocation,
		// getPageNavDataEpub3: getPageNavDataEpub3,
		setPageNavDataEpub3: setPageNavDataEpub3,
		processPageNav: processPageNav,
		getSmilData: getSmilData,
		extractSmilContent: extractSmilContent,
		processSmilData: processSmilData,
		getChapterHrefUrl: getChapterHrefUrl,
		appPrevControl: appPrevControl, 
		appNextControl: appNextControl, 
		appControlStructure: appControlStructure,
		getChapterUrlFromFileLocation: getChapterUrlFromFileLocation,
		is_fixed_layout: is_fixed_layout,
		is_fixed_scroll_mode: is_fixed_scroll_mode,
		doc_orientation: doc_orientation,
		doc_spread: doc_spread,
		nav_list: nav_list,
		nav_lookup: nav_lookup,
		getNavListPos: getNavListPos,
		processFonts: processFonts,
		loadMetaProperties: loadMetaProperties,
		loadPubBook: loadPubBook,
		getSpineJSON: getSpineJSON,
		filename_lookup: filename_lookup,
		getAppHeaderComponents : getAppHeaderComponents ,
		getAppCustomCSS : getAppCustomCSS ,
		appSMILJS : appSMILJS ,
		getMediaType : getMediaType
	}
}();

