/**
 * AZARDI READER AND AZARDI INTERACTIVE ENGINE EXTENSIONS
 * Copyright 2007-2012 Infogrid Pacific Pte. Ltd. All rights reserved
 * Modified Date: 2012-04-25
 * 
 * @version: 1-2012-04-25
 * @author Anup Dhabarde
 */

/**
 * @class Contains all the functions necessary for hyphenation adjustments
 */
var Hyphen = function(){
	var config = {
		hyphenationStatus: ''
	};
	
	/**
	 * Remove the hyphenation for current chapter
	 */
	var setNone = function() {
		$('#doc-viewer-azd').contents().find('#custom-style-igp').css({
			'-moz-hyphens': 'none',
			'hyphens': 'none'
		});
	};
	
	/**
	 * Set the hyphenation for current chapter
	 * @params hyphenate Hyphenation status to be applied
	 */
	var set = function(hyphenate){
		var self = this;
		
		if(hyphenate) {
			$('#doc-viewer-azd').contents().find('#custom-style-igp').css({
				'-moz-hyphens': 'auto',
				'hyphens': 'auto'
			});
		} else {	
			$('#doc-viewer-azd').contents().find('#custom-style-igp').css({
				'-moz-hyphens': 'none',
				'hyphens': 'none'
			});
		}
		
		config.hyphenationStatus = hyphenate;
		BookPref.config.hyphenationStatus = hyphenate;
	};
	
	/**
	 * Set the button status
	 * @params hyphenate Current hyphenation status
	 */
	var setButton = function(hyphenate){
		var self = this;
		
		if(hyphenate)
			$('#but_hypnate').attr('checked', hyphenate);
		else
			$('#but_hypnate').removeAttr('checked');
			
		config.hyphenationStatus = hyphenate;
		BookPref.config.hyphenationStatus = hyphenate;
	};
	
	return{
		config: config,
		set: set,
		setButton: setButton,
		setNone: setNone
	};
}();