/**
 * AZARDI READER AND AZARDI INTERACTIVE ENGINE EXTENSIONS
 * Copyright 2007-2012 Infogrid Pacific Pte. Ltd. All rights reserved
 * Modified Date: 2012-04-25
 * 
 * @version: 1-2012-04-25
 * @author Anup Dhabarde
 */

/**
 * @class Contains all the functions necessary for text-align adjustments
 */
var Justify = function(){
	var config = {
		justifyStatus: ''
	};
	
	/**
	 * Set the text-align property for each paragraph
	 * @params justify justify status
	 */
	var set = function(justify){
		var $p = $('#doc-viewer-azd').contents().find('p');
		if(justify){
			$p.each(function(index) {
				var default_alignment = $(this).data('default_alignment');
				if(default_alignment == 'left' || default_alignment == 'start' || default_alignment == 'justify'){
					$(this).css('text-align',"justify");
				}
			});	
		}
		else{
			//Set the default alignment here
			$p.each(function(index) {
				var default_alignment = $(this).data('default_alignment');
				if(default_alignment == 'left' || default_alignment == 'justify'){
					$(this).css('text-align',"left");
				}
				else if(default_alignment == 'start'){
					$(this).css('text-align', 'start')
				}
			});
		}
		
		config.justifyStatus = justify;
		BookPref.config.justifyStatus = justify;
	};
	
	/**
	 * Set the button status
	 * @params justify Current text-align status
	 */
	var setButton = function(justify){
		if(justify)
			$('#but_align_ctrl').attr('checked', justify);
		else
			$('#but_align_ctrl').removeAttr('checked');
			
		config.justifyStatus = justify;
		BookPref.config.justifyStatus = justify;
	};
	
	/**
	 * Get the default alignment of each paragraph and save it as a data with that tag.
	 */
	var getParagraphsDefaultAlignment = function(){
		var $p = $('#doc-viewer-azd').contents().find('p');

		$p.each(function(index){
			var text_align = $(this).css('text-align');
			$(this).data('default_alignment', text_align)
		});
	};
	
	return{
		config: config,
		set: set,
		setButton: setButton,
		getParagraphsDefaultAlignment: getParagraphsDefaultAlignment 
	};
}();