/**
 * AZARDI READER AND AZARDI INTERACTIVE ENGINE EXTENSIONS
 * Copyright 2007-2012 Infogrid Pacific Pte. Ltd. All rights reserved
 * Modified Date: 2012-04-25
 * 
 * @version: 1-2012-04-25
 * @author Anup Dhabarde
 */

/**
 * @class Contains all the functions necessary for line-height adjustments
 */
var Line = function(){
	var config = {
		lineSpacing: '',
		minValue: 1.0
	};
	
	/**
	 * Set the minimum value for the line-height
	 */
	var setMin = function() {
		$('#doc-viewer-azd').contents().find('#custom-style-igp p').css('line-height', '1em');
	};
	
	/**
	 * Set the line-height for the current chapter
	 * @params space Line height to be applied
	 */
	var set = function(space){
		var lineSpace = space+'em';
		config.lineSpacing = space;
		BookPref.config.lineSpacing = space;
		$('#doc-viewer-azd').contents().find('#custom-style-igp p').css('line-height', lineSpace);
	};
	
	/*
	var set = function(space){
		
		var lineSpace;
		switch(parseInt(space)){
			case 1:
				lineSpace = '1em';
				break;
			case 2:
				lineSpace = '1.2em';
				break;
			case 3:
				lineSpace = '1.4em';
				break;
			case 4:
				lineSpace = '1.6em';
				break;
			case 5:
				lineSpace = '1.8em';
				break;
			case 6:
				lineSpace = '2em';
				break;
		}
		
		config.lineSpacing = space;
		BookPref.config.lineSpacing = space;
		$('#doc-viewer-azd').contents().find('#custom-style-igp p').css('line-height', lineSpace);
	}
	*/
	// var setSlider = function(space){
		// config.lineSpacing = space;
		// BookPref.config.lineSpacing = space;
		// $('#line-scale').attr('value', space);
	// };
	
	return{
		config: config,
		set: set,
		// setSlider: setSlider,
		setMin: setMin
	};
}();