/**
 * AZARDI READER AND AZARDI INTERACTIVE ENGINE EXTENSIONS
 * Copyright 2007-2012 Infogrid Pacific Pte. Ltd. All rights reserved
 * Modified Date: 2012-04-25
 * 
 * @version: 1-2012-04-25
 * @author Anup Dhabarde
 */

/**
 * @class Contains all the functions necessary for margin adjustments
 */
var Margin = function(){
	var config = {
		margin: '',
		minValue: 0
	};
	
	/**
	 * Set the minimum value for margin
	 */
	var setMin = function() {
		$('#doc-viewer-azd').contents().find('#custom-style-igp').css('padding-left', '0px');
		$('#doc-viewer-azd').contents().find('#custom-style-igp').css('padding-right', '0px');
		$('#doc-viewer-azd').contents().find('.columns').css('padding-top', '0px');
		$('#doc-viewer-azd').contents().find('.columns').css('padding-bottom', '0px');
	};
	
	//padding-top and padding-bottom is always applied half of the padding-left and padding-right
	/**
	 * Sets the margin for this chapter
	 * @params space Margin to be applied
	 */
	var set = function(space){
		$('#doc-viewer-azd').contents().find('#custom-style-igp').css('padding-left', space + 'px');
		$('#doc-viewer-azd').contents().find('#custom-style-igp').css('padding-right', space + 'px');
		$('#doc-viewer-azd').contents().find('.columns').css('padding-top', (space / 2) + 'px');
		$('#doc-viewer-azd').contents().find('.columns').css('padding-bottom', (space / 2) + 'px');
		
		config.margin = space;
		BookPref.config.margin = space;
	};
	
	// var setSlider = function(space){
		// $('#margin-scale').attr('value', space);
// 		
		// config.margin = space;
		// BookPref.config.margin = space;
	// };
	
	/**
	 * Set the margin for this chapter from fixed layout
	 * @params space Margin to be applied
	 */
	var setFromMeta = function(space){
		$('#doc-viewer-azd').contents().find('#custom-style-igp').css('padding-left', space + 'px');
		$('#doc-viewer-azd').contents().find('#custom-style-igp').css('padding-right', space + 'px');
		$('#doc-viewer-azd').contents().find('.columns').css('padding-top', (space / 2) + 'px');
		$('#doc-viewer-azd').contents().find('.columns').css('padding-bottom', (space / 2) + 'px');
	};
	
	// var setSliderFromMeta = function(space){
		// $('#margin-scale').attr('value', space);
	// };
	
	return{
		config: config,
		set: set,
		// setSlider: setSlider,
		setFromMeta: setFromMeta,
		// setSliderFromMeta: setSliderFromMeta,
		setMin: setMin
	};
}();