/**
 * AZARDI READER AND AZARDI INTERACTIVE ENGINE EXTENSIONS
 * Copyright 2007-2012 Infogrid Pacific Pte. Ltd. All rights reserved
 * Modified Date: 2012-04-25
 * 
 * @version: 1-2012-04-25
 * @author Anup Dhabarde
 */

var myScroll = null;; 
 
var config = {
	currentWidth : '',
	currentHeight : '',
	documentWidth : '',
	documentHeight : '',
	xOffset : '',
	yOffset : ''
}
	
var initPageVariables = function(){
	config.currentWidth = window.innerWidth;
	config.currentHeight = window.innerHeight;
	config.documentWidth = $(document).width();
	config.documentHeight = $(document).height();
	config.xOffset = window.pageXOffset;
	config.yOffset = window.pageYOffset;
}

var getInnerDim = function() {
	return{
		'width': window.innerWidth,
		'height': window.innerHeight
	}
}

var createNoteEditDialog = function(){
	var editDialog = $(document.createElement('div'))
		.attr({
			'class': 'notes-ape',
			 'id': 'edit_notes'
		})
		.append($(document.createElement('div'))
			.addClass('notes-header-ape')
			.append($(document.createElement('h4'))
				.addClass('notes-title-ape')
			)
			.append($('<span></span>')
				.addClass('notes-date-ape')
			)
			.append($(document.createElement('span'))
				.addClass('notes-close-ape')
				.append($(document.createElement('a'))
					.attr('href', 'javascript: void(0);')
					.click(function(){
	//													parent.AME.closeEditNotesDialog();
						xulconnector.send_request({action: 'saveEditedNotes'});
						parent.AME.saveEditedNotes();
					})
					.append($(document.createTextNode('Done')))
				)
			)
		)
		.append($(document.createElement('div'))
			.addClass('notes-description-ape')
			.attr('contenteditable', 'true')
		)
	//									.append($(document.createElement('div'))
	//										.addClass('notes-footer-ape')
	//										.append($(document.createElement('ul'))
	//											.append($(document.createElement('li'))
	//												.attr('id', 'save_notes')
	//												.addClass('notes-button-ape')
	//												.click(function(){
	//													parent.AME.saveEditedNotes();
	//												})
	//												.append($(document.createTextNode('Save')))
	//											)
	//										)
	//									)
		.append($(document.createElement('span'))
			.attr('id', 'id_anno')
			.hide()
		);
	$('body').append(editDialog);
}

var noteinstanceclicked = function(noteid) {
	xulconnector.send_request({action: 'note_clicked', note_id: noteid});
}

//DC - FLO UPDATE - 201211
/* Event dispatch and listerner */
var xulconnector = {
	send_request: function(data, callback) { // analogue of chrome.extension.sendRequest
	  var request = document.createTextNode(JSON.stringify(data));

	  request.addEventListener("azd-response", function(event) {
		request.parentNode.removeChild(request);

		if (callback) {
		  var response = JSON.parse(request.nodeValue);
		  callback(response);
		}
	  }, false);

	  document.head.appendChild(request);

	  var event = document.createEvent("HTMLEvents");
	  event.initEvent("azd-query", true, false);
	  request.dispatchEvent(event);
	},

	callback: function(response) {
	  return alert("response: " + (response ? response.toSource() : response));
	}
}

//DC - FLO UPDATE - 201211 -
//Default on load actions
$(document).ready(function(){
	$('.custom-style-igp').live("cut copy paste",function(e) {
		e.preventDefault();
	});
	
	var playing_handle = $.subscribe("AIE-TEXTSOUND-PLAYING", function() {
		xulconnector.send_request({action: 'playing_handle'});
	});
	
	var paused_handle = $.subscribe("AIE-TEXTSOUND-PAUSED", function() {
		xulconnector.send_request({action: 'paused_handle'});
	});
	
	var finished_handle = $.subscribe("AIE-TEXTSOUND-FINISHED", function() {
		xulconnector.send_request({action: 'finished_handle'});
	});
	
	var current_SPAN_handle = $.subscribe("AIE-TEXTSOUND-PLAYING", function(el_id) {
		xulconnector.send_request({action: 'aie_playing_handle', elid: el_id});
	});
	
	//Handle the side toc in new way. The psuedo class hover has 
	//been removed and we use mouse event to show/hide the side toc
	$(".toc-azd").live('mouseover mouseout', function(event) {
		  if (event.type == 'mouseover') {
			$(this).addClass("toc-azd-hover");
		  } else {
			$(this).removeClass("toc-azd-hover");
		  }
	});

	try {
		$(document).on("keypress", function(event){
		  var target = event.target.tagName;
		  target = target.toLowerCase();
		  if((target === "span") || (target === "input") || (target === "textarea")) {
			xulconnector.send_request({action: 'settargetbox', 'status': true});
		  } else {
			xulconnector.send_request({action: 'settargetbox', 'status': false});
		  }
		});
	} catch(e) {
	
	}
	
});

function playAudioEx(target, status, playBackRate) {
	try {
		//DC - FLO UPDATE - 201211
		/*AIE Cannot access the target directly as it is in the parent xul window
		  So we create a dummy hidden element and set its properties and pass
		  that to AIE library
		*/
		if ($(".temp-audio-player").length == 0){
			$("body").append("<span class='temp-audio-player' style='display:none'></span>");
		}
		if (status) {
			$(".temp-audio-player").addClass("playing");
		} else {
			$(".temp-audio-player").removeClass("playing");
		}
		target = $(".temp-audio-player")[0];
		$.publish("AIE-TEXTSOUND-PLAY", [target, playBackRate]);
	} catch (e) {
		azDump("playAudioEx", e);
	}
}

function stopAudio(target) {
	try {
		//DC - FLO UPDATE - 201211
		/*AIE Cannot access the target directly as it is in the parent xul window
		  So we create a dummy hidden element and set its properties and pass
		  that to AIE library
		*/
		if ($(".temp-audio-player").length == 0){
			$("body").append("<span class='temp-audio-player' style='display:none'></span>");
		}
		if (status) {
			$(".temp-audio-player").addClass("playing");
		} else {
			$(".temp-audio-player").removeClass("playing");
		}
		target = $(".temp-audio-player")[0];
		$.publish("AIE-TEXTSOUND-STOP", [target]);
	} catch (e) {
		azDump("stopAudio", e);
	}
}

var metainfo = "test";

function initAIE(metadata) {
	try {
		initAudio();
		
		var smil_hilite = "-epub-media-overlay-active";
		try {
			var info = $("body").attr("azdtemp");		
			metainfo = JSON.parse(info);
			
			if (metainfo.hasOwnProperty("media:active-class")) {
				smil_hilite =  metainfo["media:active-class"];
			}
		} catch(e) {
		
		}
		
		if ($(".aie-audio-text-rw").length > 0){
			AIE.TextSound.setHighlightProperty(smil_hilite);
			AIE.TextSound.launchTextandSound();
		}
		
		/*if ($(".aie-storyline-rw").length > 0) {
			var storyline = AIE.Storyline.loadStoryline();
			AIE.Storyline.setupStartStoryLine(storyline);
		}
			
		if ($(".qaa-rw").length > 0){
			AIE.Qaa.TextMatch.dragItems();
			AIE.Qaa.init();
		}
		
		if ($("pre.aie-events").length > 0){
			AIE.Events.loadEvents();
		}
		
		//	Initilizing AIE gameutils.
		AIE.GameTimer.init();
		//Initialize the game evaluation engine
		if ($(".game-evaluation")){
			this.game_eval_obj = new AIE.SimpleGameEvaluation();
			this.game_eval_obj.initGameEvents();
		}*/
	} catch(e) {
		azDump("initAIE", e);
	}
}

function initAIEFLO() {
	try {
		
		/*if ($(".aie-storyline-rw").length > 0) {
			var storyline = AIE.Storyline.loadStoryline();
			AIE.Storyline.setupStartStoryLine(storyline);
		}
			
		if ($(".qaa-rw").length > 0){
			
		}
		
		if ($("pre.aie-events").length > 0){
			AIE.Events.loadEvents();
		}
		
		//	Initilizing AIE gameutils.
		AIE.GameTimer.init();
		//Initialize the game evaluation engine
		if ($(".game-evaluation")){
			this.game_eval_obj = new AIE.SimpleGameEvaluation();
			this.game_eval_obj.initGameEvents();
		}*/
	} catch(e) {
		azDump("initAIEFLO", e);
	}
}

function initAIETextSoundFLO(metadata) {
	try {
		
		var smil_hilite = "-epub-media-overlay-active";
		try {
			var info = $("body").attr("azdtemp");		
			metainfo = JSON.parse(info);
			if (metainfo.hasOwnProperty("media:active-class")) {
				smil_hilite =  metainfo["media:active-class"];
			}
		} catch(e) {
		}
		
		if ($(".aie-audio-text-rw").length > 0){
			AIE.TextSound.setHighlightProperty(smil_hilite);
			AIE.TextSound.launchTextandSound();
		}
	} catch(e) {
		azDump("initAIETextSoundFLO", e);
	}
}


function initIScroll(target, ypos) {
	
	if (myScroll) {
		myScroll.destroy();
		myScroll = null;
	}
	
	$("#custom-style-igp").css("position", "absolute");
	
	var bodyid = $("body").attr("id");
	
	if (!bodyid) {
		bodyid = "body-igp";
		$("body").attr("id", bodyid);
		$("body").css("overflow", "auto");
	}
	myScroll = new iScroll(bodyid,  { 
					zoom: true,
					wheelAction: 'zoom',
					bounceLock: true,
					lockDirection: false,
					bounce: false
				});
	
	setTimeout(function () {
		myScroll.refresh();
		if (ypos < 0) myScroll.scrollTo(0, ypos, 0)
	}, 10);
}

function scrollToElement(target) {
	if (myScroll) {
		var el = $("#" + target).get(0);
		myScroll.scrollToElement(el, 0);
	}
}

function getIScrollPos() {
	if (myScroll)return myScroll.y;
	return "x";
}

function azDump(prefix){
	return;
	dump("\n" + prefix + ">>>>  ");
	result = ""
	 // iterate through non-separator arguments
	  for (var i = 1; i < arguments.length; i++) {
			result += JSON.stringify(arguments[i]) + "\n";
	  }
	dump("\n" + result);
	dump("----------------------------------------------");
}

function showSideToc() {
	//$(".toc-azd").trigger("mouseover");
}

function changePlaybackRate(rate) {
	try {
		AIE.TextSound.setAudioRate(rate);
		$("audio").get(0).playbackRate = rate;
	} catch(e) {
	
	}
}