/**
 * AZARDI READER AND AZARDI INTERACTIVE ENGINE EXTENSIONS
 * Copyright 2007-2012 Infogrid Pacific Pte. Ltd. All rights reserved
 * Modified Date: 2012-04-25
 * 
 * @version: 1-2012-04-25
 * @author Anup Dhabarde
 */

var RenewCdp = function(){

	/**
	 * 	Private properties and methods.
	 */
	
	var config = {
		
	}
	
	var init = function (renewCode, cdpId, readerToken, renewCdpUrl) {
		var self = this;
		
		var request = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
					  .createInstance(Components.interfaces.nsIXMLHttpRequest);
		request.onload = function(aEvent) {
			var text = aEvent.target.responseText;
			try{
				var jsObject = JSON.parse(text);
			}
			catch(e){
				var msg = getPropertiesString("azd_renew_cdp_Fail");
				alert(msg);
				window.arguments[0].out.out = false;
				window.close();
			}
			var rc = jsObject.expiry_date;
			
			if(rc == 'False') {
				var msg = getPropertiesString("azd_renew_cdp_invalidKey");
				alert(msg);
			}
			else if(rc == ''){
				var msg = getPropertiesString("azd_renew_cdp_Fail");
				alert(msg);
				window.arguments[0].out.out = false;
				window.close();
			}
			else{
				//	Update expiry date
				self.updateDatabase(rc, cdpId);
				//	Get previous cdp status (if it was installed or just downloaded)
				var cdpStatus = self.checkCdpStatus(cdpId);
				//	Update the status in database (make it 'installed' if it was installed earlier)
				self.updateStatus(cdpId, cdpStatus);
				
				window.arguments[0].out.cdpStatus = cdpStatus;
				window.arguments[0].out.out = true;
				window.close();
			}
		};
		request.onerror = function(aEvent) {
			var msg = getPropertiesString("azd_renew_cat_errStatus");
			window.alert(msg + " " + aEvent.target.status);//
			window.arguments[0].out.out = false;
			window.close();
		};
		request.open("POST", renewCdpUrl, true);
		request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		request.send("readerid=" + readerToken + "&activationkey=" + renewCode + "&id=" + cdpId+ "&type=book");
	}
	
	var updateStatus = function (cdpId, cdpStatus) {
		var self = this;
		
		var fileObj = window.opener.getFileObject(window.opener.AME.getCdpDbFilePath());
		var table_name = 'RAF_Master';
		
		if(cdpStatus == 'installed'){
			var values = new Array(['raf_value', cdpStatus, 'TEXT']);
			var conditions = new Array(['field_id', cdpId, 'TEXT'],
									   ['raf_key', 'status', 'TEXT']);
			window.opener.updateRowIntoDatabase(fileObj, values, table_name, conditions);
		}
		else if(cdpStatus == 'default'){
			var conditions = new Array(['field_id', cdpId, 'TEXT'],
									   ['raf_key', 'status', 'TEXT']);
			window.opener.deleteRowFromDatabase(fileObj,table_name, conditions);
		}
	}
	
	var updateDatabase = function (renewCode, cdpId) {
		var self = this;
		
		var readerToken = window.opener.AME.getReaderToken();
		var renewCode = window.opener.GibberishAES.enc(renewCode, readerToken+cdpId);
		var fileObj = window.opener.getFileObject(window.opener.AME.getCdpDbFilePath());
		var table_name = 'RAF_Master';
		var values = ['raf_value'];
		var conditions = new Array(['field_id', cdpId, 'TEXT'],
								   ['raf_key', 'expiry_date', 'TEXT']);
		var statement = window.opener.getValuesFromDatabase(fileObj, values, table_name, conditions);
		while (statement.executeStep()){
			var raf_value = statement.row.raf_value;
		}
		
		var values = new Array(['field_id', cdpId, 'TEXT'],
							   ['raf_key', 'expiry_date', 'TEXT'],
							   ['raf_value', renewCode, 'TEXT'],
							   ['type', 'CDP', 'TEXT']);
							   
		//	Store value for first time.
		if (typeof raf_value == 'undefined'){
			window.opener.insertRowIntoDatabase(fileObj, values, table_name)
		}
		
		//	If value exists then update it.
		else{
			window.opener.updateRowIntoDatabase(fileObj, values, table_name, conditions);
		}
	}
	
	var checkCdpStatus = function (cdpId) {
		var self = this;
		
		var fileObj = window.opener.getFileObject(window.opener.AME.getCdpDbFilePath());
		var table_name = 'CDP_Master';
		var values = ['id'];
		var conditions = new Array(['cdp_id', cdpId, 'TEXT']);
		var statement = window.opener.getValuesFromDatabase(fileObj, values, table_name, conditions);
		while(statement.executeStep()) {
			var id = statement.row.id;
		}
		if(typeof id == 'undefined') {
			return 'default';
		}
		else{
			return 'installed';
		}
	}
	
	return{
		init: init,
		updateDatabase: updateDatabase,
		checkCdpStatus: checkCdpStatus,
		updateStatus: updateStatus
	}
}();