/**
 * AZARDI READER AND AZARDI INTERACTIVE ENGINE EXTENSIONS
 * Copyright 2007-2012 Infogrid Pacific Pte. Ltd. All rights reserved
 * Modified Date: 2012-04-25
 * 
 * @version: 1-2012-04-25
 * @author Anup Dhabarde
 */

/**
 * @class Contains functions necessary for updating database when version change occurs.
 */
var Update_DB = function() {
	//Initilize updating database.
	var init = function() {
		//Need to update the Book Preferences for AZARDI 11.0
		updateBookPref();
		//Update the database version anyways.
		updateDBVersion();
	};
	
	var updateBookPref = function() {
		//Get the database version from the database.
		var destinationFile = getFileObject(AME.getDbFilePath());
    	var table_name = 'System';
		var values = ['value'];
		var conditions = new Array(['key', 'db_version', 'TEXT']);
								   
		var statement = getValuesFromDatabase(destinationFile, values, table_name, conditions);
		var value_d;
		while(statement.executeStep()) {
			value_d = parseFloat(statement.row.value);
		}
		//Change the book preferences only if old database version is before 11
		if(typeof value_d == 'undefined' || value_d < 11){
			var doc_user_data = BookPref.getAllFromDB();
		
			for(var i=0; i<doc_user_data.length; i++) {
				var bookPref = eval(doc_user_data[i][2]);
				var newBookPref = "new Array(['currentChapter', '"+bookPref[0][1]+"'],"+
								  "['fontSize', '1'],"+
								  "['lineSpacing', '1.2'],"+
								  "['margin', '"+bookPref[3][1]+"'],"+
								  "['columns', '"+bookPref[4][1]+"'],"+
								  "['hyphenationStatus', '"+bookPref[5][1]+"'],"+
								  "['justifyStatus', '"+bookPref[6][1]+"'],"+
								  "['backgroundColor', '"+bookPref[7][1]+"'],"+
								  "['openWidth', '"+bookPref[8][1]+"'],"+ 
								  "['openHeight', '"+bookPref[9][1]+"'],"+
								  "['readingDepth', '"+bookPref[10][1]+"'])";
				
				var fileObj = getFileObject(AME.getDbFilePath());
				var table_name = 'doc_user_data';
				var values = new Array(['book_pref', newBookPref, 'TEXT']);
				var conditions = new Array(['id', doc_user_data[i][0], 'TEXT']);
				updateRowIntoDatabase(fileObj, values, table_name, conditions);
			}
		}
	};
	
	/**
	 * Updates the database version.
	 */
	var updateDBVersion = function() {
		var db_version = AME.getDBVersion();
													  
		var fileObj = getFileObject(AME.getDbFilePath());
		var table_name = 'System';
		var values = ['value'];
		var conditions = new Array(['key', 'db_version', 'TEXT']);
		var statement = getValuesFromDatabase(fileObj, values, table_name, conditions);
		while (statement.executeStep()){
			var db_v = parseFloat(statement.row.value);
		}
		//	if row is not already created then create new row and then insert.
		if(typeof db_v == 'undefined'){
			values = new Array(['key', 'db_version', 'TEXT'],
							   ['value', db_version, 'TEXT']);
			insertRowIntoDatabase(fileObj, values, table_name);
		}
		//	if row already exists then update the row.
		else{
			values = new Array(['key', 'db_version', 'TEXT'],
							   ['value', db_version, 'TEXT']);
			updateRowIntoDatabase(fileObj, values, table_name, conditions);
		}
	};
	
	return {
		init: init
	};
}();
