<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<!--
NOTICE TO END USERS AND LICENSEES: This is a critical controlled system file and must not be changed or modified in any way by end users, licensees or any third parties without full approval of Infogrid Pacific. Any unauthorized change or modification of any type to this file immediately voids the full IGP:FLIP warranty and under the terms of the License Infogrid Pacific Pte. Ltd. is released from product support liability.

# Version: 1.0
# Creator: IGP
# Purpose: Used to convert ePub NCX XML to Unordered List structure
# Copyright: (c)2007-11 Copyright Infogrid Pacific Pte. Ltd. Singapore. All rights reserved.
-->

<!-- Preserve all spaces in output -->
<xsl:preserve-space elements="*"/>

<!-- Output as a HTML in UTF 8 encoding -->
<xsl:output method="html" encoding="UTF-8"/>

<!-- Remove Head and DocTitle -->
<xsl:template match="head | docTitle"></xsl:template>



<!-- Generate Outer OL -->
<xsl:template match="navMap">
    <div id="toc-azd" class="toc-azd">
        <ol>
        	<li>
    			<a href="javascript: void(0);" class="azd-cover-link">
    			<xsl:attribute name="onclick"><xsl:text>xulconnector.send_request({action: 'goToCoverPage', param1: 'side'});</xsl:text></xsl:attribute>
    				COVER
    			</a>
    		</li>
	        <xsl:apply-templates />
      </ol>
  </div>
</xsl:template>

<!-- Generate List Items -->
<xsl:template match="navMap/navPoint">
	<li>
        <xsl:apply-templates />
    </li>
    <xsl:if test="./navPoint">
      <ol><xsl:call-template name="nesting"/></ol>
    </xsl:if>
  
</xsl:template>

<xsl:template match="navPoint/navLabel">
  <a href="javascript: void(0);">
    <xsl:attribute name="onclick"><xsl:text>xulconnector.send_request({action: 'goToFromToc', param1: '</xsl:text><xsl:value-of select="following-sibling::content[1]/@src" /><xsl:text>', param2: 'side'});</xsl:text></xsl:attribute>
    <xsl:attribute name="class"><xsl:value-of select="following-sibling::content[1]/@src" /></xsl:attribute>
    <xsl:apply-templates />
  </a>
</xsl:template>

<!-- Processing For Nesting -->
<xsl:template match="navMap/navPoint//navPoint" />
<xsl:template name="nesting">
  <xsl:for-each select="navPoint">
    <li><xsl:apply-templates /></li>
      <xsl:if test="./navPoint">
        <ol><xsl:call-template name="nesting"/></ol>
      </xsl:if>
  </xsl:for-each>
</xsl:template>

</xsl:stylesheet>
